*DECK RGAUSS
      FUNCTION RGAUSS (XMEAN, SD)
C***BEGIN PROLOGUE  RGAUSS
C***PURPOSE  Generate a normally distributed (Gaussian) random number.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  L6A14
C***TYPE      SINGLE PRECISION (RGAUSS-S)
C***KEYWORDS  FNLIB, GAUSSIAN, NORMAL, RANDOM NUMBER, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Generate a normally distributed random number, i.e., generate random
C numbers with a Gaussian distribution.  These random numbers are not
C exceptionally good -- especially in the tails of the distribution,
C but this implementation is simple and suitable for most applications.
C See R. W. Hamming, Numerical Methods for Scientists and Engineers,
C McGraw-Hill, 1962, pages 34 and 389.
C
C             Input Arguments --
C XMEAN  the mean of the Guassian distribution.
C SD     the standard deviation of the Guassian function
C          EXP (-1/2 * (X-XMEAN)**2 / SD**2)
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  RAND
C***REVISION HISTORY  (YYMMDD)
C   770401  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   910819  Added EXTERNAL statement for RAND due to problem on IBM
C           RS 6000.  (WRB)
C***END PROLOGUE  RGAUSS
      EXTERNAL RAND
C***FIRST EXECUTABLE STATEMENT  RGAUSS
      RGAUSS = -6.0
      DO 10 I=1,12
        RGAUSS = RGAUSS + RAND(0.0)
 10   CONTINUE
C
      RGAUSS = XMEAN + SD*RGAUSS
C
      RETURN
      END

      subroutine SVA(A,MDA,M,N,MDATA,B,SING,KPVEC,NAMES,ISCALE,D,WORK)
c
C  SINGULAR VALUE ANALYSIS.  COMPUTES THE SINGULAR VALUE
C  DECOMPOSITION OF THE MATRIX OF A LEAST SQUARES PROBLEM, AND
C  PRODUCES A PRINTED REPORT.
c
c  The original version of this code was developed by
c  Charles L. Lawson and Richard J. Hanson at Jet Propulsion Laboratory
c  1973 JUN 12, and published in the book
c  "SOLVING LEAST SQUARES PROBLEMS", Prentice-HalL, 1974.
c  Revised FEB 1995 to accompany reprinting of the book by SIAM.
C     ------------------------------------------------------------------   
c  This 1995 version differs from the original 1973 version by the 
c  addition of the arguments KPVEC() and WORK(), and by allowing user to
c  choose the length of names in NAMES().
c  KPVEC() allows the user to exercise options regarding printing.
c  WORK() provides 2*N locations of work space.  Originally SING() was
c  required to have 3*N elements, of which the last 2*N were used for
c  work space.  Now SING() only needs N elements.
c     ------------------------------------------------------------------
c                         Subroutine Arguments
c     A(,)     [inout]  On entry, contains the M x N matrix of the least
c              squares problem to be analyzed.  This could be a matrix
c              obtained by preliminary orthogonal transformations
c              applied to the actual problem matrix which may have had
c              more rows (See MDATA below.)
c
c     MDA   [in]  First dimensioning parameter for A(,).  Require
c              MDA .ge. max(M, N).
c
c     M,N   [in]  No. of rows and columns, respectively, in the
c              matrix, A.  Either M > N or M .le. N is permitted.
c              Require M > 0 and N > 0.
c
c     MDATA [in]  No. of rows in actual least squares problem.
c              Generally MDATA .ge. M.  MDATA is used only in computing
c              statistics for the report and is not used as a loop
c              count or array dimension.
c
c     B()   [inout]  On entry, contains the right-side vector, b, of the
c              least squares problem.  This vector is of length, M.
c              On return, contains the vector, g = (U**t)*b, where U
c              comes from the singular value decomposition of A.  The
c              vector , g, is also of length M.
c
c     SING()   [out] On return, contains the singular values of A, in
c              descending order, in locations indexed 1 thru min(M,N).
c              If M < N, locations indexed from M+1 through N will be
c              set to zero.
c
c     KPVEC()  [integer array, in]  Array of integers to select print
c              options.  KPVEC(1) determines whether the rest of
c              the array is to be used or ignored.
c              If KPVEC(1) = 1, the contents of (KPVEC(I), I=2,4)
c              will be used to set internal variables as follows:
c                       PRBLK = KPVEC(2)
c                       UNIT  = KPVEC(3)
c                       WIDTH = KPVEC(4)
c              If KPVEC(1) = 0 default settings will be used.  The user
c              need not dimension KPVEC() greater than 1.  The subr will
c              set PRBLK = 111111, UNIT = -1, and WIDTH = 69.
c
c              The internal variables PRBLK, UNIT, and WIDTH are
c              interpreted as follows:
c
c              PRBLK    The decimal representation of PRBLK must be
c              representable as at most 6 digits, each being 0 or 1.
c              The decimal digits will be interpreted as independant
c              on/off flags for the 6 possible blocks of printed output.
c              Examples:  111111 selects all blocks, 0 suppresses all
c              printing,  101010 selects the 1st, 3rd, and 5th blocks,
c              etc.
c              The six blocks are:
c              1. Header, with size and scaling option parameters.
c              2. V-matrix.  Amount of output depends on M and N.
c              3. Singular values and related quantities.  Amount of
c                 output depends on N.
c              4. Listing of YNORM and RNORM and their logarithms.
c                 Amount of output depends on N.
c              5. Levenberg-Marquart analysis.
c              6. Candidate solutions.  Amount of output depends on
c                 M and N.
c
c              UNIT     Selects the output unit.  If UNIT .ge. 0,
c              UNIT will be used as the output unit number.
c              If UNIT = -1, output will be written to the "*" output
c              unit, i.e., the standard system output unit.
c              The calling program unit is responsible for opening
c              and/or closing the selected output unit if the host
c              system requires these actions.
c
c        WIDTH    Default value is 79.  Determines the width of
c        blocks 2, 3, and 6 of the output report.
c        Block 3 will use 95(+1) cols if WIDTH .ge. 95, and otherwise
c        69(+1) cols.
c        Blocks 2 and 6 are printed by subroutine MFEOUT.  These blocks
c        generally use at most WIDTH(+1) cols, but will use more if
c        the names are so long that more space is needed to print one
c        name and one numeric column.  The (+1)'s above are reminders
c        that in all cases there is one extra initial column for Fortran
c        "carriage control".  The carriage control character will always
c        be a blank.
c        Blocks 1, 4, and 5 have fixed widths of 63(+1), 66(+1) and
c        66(+1), respectively.
c
c     NAMES()  [in]  NAMES(j), for j = 1, ..., N, may contain a
c              name for the jth component of the solution
c              vector.  The declared length of the elements of the
c              NAMES() array is not specifically limited, but a
c              greater length reduces the space available for columns
c              of the matris to be printed.
c              If NAMES(1) contains only blank characters,
c              it will be assumed that no names have been provided,
c              and this subr will not access the NAMES() array beyond
c              the first element.
C
C     ISCALE   [in]  Set by the user to 1, 2, or 3 to select the column
c              scaling option.
C                  1   SUBR WILL USE IDENTITY SCALING AND IGNORE THE D()
C                      ARRAY.
C                  2   SUBR WILL SCALE NONZERO COLS TO HAVE UNIT EUCLID-
C                      EAN LENGTH AND WILL STORE RECIPROCAL LENGTHS OF
C                      ORIGINAL NONZERO COLS IN D().
C                  3   USER SUPPLIES COL SCALE FACTORS IN D(). SUBR
C                      WILL MULT COL J BY D(J) AND REMOVE THE SCALING
C                      FROM THE SOLN AT THE END.
c
c     D()   [ignored or out or in]  Usage of D() depends on ISCALE as
c              described above.  When used, its length must be
c              at least N.
c
c     WORK()   [scratch]   Work space of length at least 2*N.  Used
c              directly in this subr and also in _SVDRS.
c     ------------------------------------------------------------------
      integer I, IE, IPASS, ISCALE, J, K, KPVEC(4), M, MDA, MDATA
      integer MINMN, MINMN1, MPASS, N, NSOL
      integer PRBLK, UNIT, WIDTH
      double precision A(MDA,N), A1, A2, A3, A4, ALAMB, ALN10, B(M)
      double precision D(N), DEL, EL, EL2
      double precision ONE, PCOEF, RL, RNORM, RS
      double precision SB, SING(N), SL, TEN, THOU, TWENTY
      double precision WORK(2*N), YL, YNORM, YS, YSQ, ZERO
      character*(*) NAMES(N)
      logical BLK(6), NARROW, STAR
      parameter( ZERO = 0.0d0, ONE = 1.0d0)
      parameter( TEN = 10.0d0, TWENTY = 20.0d0, THOU = 1000.0d0)
c     -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  220 format (1X/' INDEX  SING. VAL.    P COEF   ',
     *        '   RECIPROCAL    G COEF         G**2   ',
     *        '   CUMULATIVE  SCALED SQRT'/
     *    31x,'   SING. VAL.',26x,
     *        '  SUM of SQRS  of CUM.S.S.')
  221 format (1X/' INDEX  SING. VAL.    P COEF   ',
     *        '   RECIPROCAL    G COEF     SCALED SQRT'/
     *    31x,'   SING. VAL.',13x,'  of CUM.S.S.')
  222 format (1X/' INDEX  SING. VAL.    G COEF         G**2   ',
     *        '   CUMULATIVE  SCALED SQRT'/
     *    44x,'  SUM of SQRS  of CUM.S.S.')

  230 format (' ',4X,'0',64X,2g13.4)
  231 format (' ',4X,'0',51X, g13.4)
  232 format (' ',4X,'0',38X,2g13.4)

  240 format (' ',i5,g12.4,6g13.4)

  260 format (1X,' M  = ',I6,',   N  =',I4,',   MDATA  =',I8)
  270 format (1X/' Singular Value Analysis of the least squares',
     *        ' problem,  A*X = B,'/
     *        ' scaled as (A*D)*Y = B.')
  280 format (1X/' Scaling option No.',I2,'.  D is a diagonal',
     * ' matrix with the following diagonal elements..'/(5X,10E12.4))
  290 format (1X/' Scaling option No. 1.   D is the identity matrix.'/
     * 1X)
  300 format (1X/' INDEX',12X,'YNORM      RNORM',11X,
     * '      LOG10      LOG10'/
     * 45X,'      YNORM      RNORM'/1X)
  310 format (' ',I5,6X,2E11.3,11X,2F11.3)
  320 format (1X/
     *' Norms of solution and residual vectors for a range of values'/
     *' of the Levenberg-Marquardt parameter, LAMBDA.'//
     *        '      LAMBDA      YNORM      RNORM',
     *         '      LOG10      LOG10      LOG10'/
     *     34X,'     LAMBDA      YNORM      RNORM')
  330 format (1X, 3E11.3, 3F11.3)
c     ------------------------------------------------------------------
      IF (M.LE.0 .OR. N.LE.0) RETURN
      MINMN = min(M,N)
      MINMN1 = MINMN + 1
      if(KPVEC(1) .eq. 0) then
         PRBLK = 111111
         UNIT = -1
         WIDTH = 79
      else
         PRBLK = KPVEC(2)
         UNIT = KPVEC(3)
         WIDTH = KPVEC(4)
      endif
      STAR = UNIT .lt. 0
c                           Build logical array BLK() by testing
c                           decimal digits of PRBLK.
      do 20 I=6, 1, -1
         J = PRBLK/10
         BLK(I) = (PRBLK - 10*J) .gt. 0
         PRBLK = J
   20 continue
c     -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c                         Optionally print header and M, N, MDATA
      if(BLK(1)) then
         if(STAR) then
            write (*,270)
            write (*,260) M,N,MDATA
         else
            write (UNIT,270)
            write (UNIT,260) M,N,MDATA
         endif
      endif
c     -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c                                  Handle scaling as selected by ISCALE.
      if( ISCALE .eq. 1) then
         if(BLK(1)) then
            if(STAR) then
               write (*,290)
            else
               write (UNIT,290)
            endif
         endif
      else
C
C                                  Apply column scaling to A.
C
         DO 52 J = 1,N
            A1 = D(J)
            if( ISCALE .le. 2) then
               SB = ZERO
               DO 30 I = 1,M
   30             SB = SB + A(I,J)**2
               A1 = sqrt(SB)
               IF (A1.EQ.ZERO) A1 = ONE
               A1 = ONE/A1
               D(J) = A1
            endif
            DO 50 I = 1,M
               A(I,J) = A(I,J)*A1
   50       continue
   52    continue
         if(BLK(1)) then
            if(STAR) then
               write (*,280) ISCALE,(D(J),J = 1,N)
            else
               write (UNIT,280) ISCALE,(D(J),J = 1,N)
            endif
         endif
      endif
c     -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C         Compute the Singular Value Decomposition of the scaled matrix.
C
      call SVDRS (A,MDA,M,N,B,M,1,SING,WORK)
c
c                                               Determine NSOL.
      NSOL = MINMN
      do 60 J = 1,MINMN
         if(SING(J) .eq. ZERO) then
            NSOL = J-1
            go to 65
         endif
   60 continue
   65 continue
C
c              The array B() contains the vector G.
C              Compute cumulative sums of squares of components of
C              G and store them in WORK(I), I = 1,...,MINMN+1
C
      SB = ZERO
      DO 70 I = MINMN1,M
         SB = SB + B(I)**2
   70 CONTINUE
      WORK(MINMN+1) = SB
      DO  75 J = MINMN, 1, -1
         SB = SB + B(J)**2
         WORK(J) = SB
   75 CONTINUE
c     -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C                                          PRINT THE V MATRIX.
C
      if(BLK(2)) CALL MFEOUT (A,MDA,N,N,NAMES,1, UNIT, WIDTH)
c     -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C                                REPLACE V BY D*V IN THE ARRAY A()
      if (ISCALE .gt.1) then
         do 82 I = 1,N
            do 80 J = 1,N
               A(I,J) = D(I)*A(I,J)
   80       continue
   82    continue
      endif
c     -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      if(BLK(3)) then
c                     Print singular values and other summary results.
c
c     Output will be done using one of two layouts.  The narrow
c     layout uses 69 cols + 1 for carriage control, and makes two passes
c     through the computation.
c     The wide layout uses 95 cols + 1 for carriage control, and makes
c     only one pass through the computation.
c
C                       G  NOW IN  B() ARRAY.  V NOW IN A(,) ARRAY.
C
      NARROW = WIDTH .lt. 95
      MPASS = 1
      if(NARROW) MPASS = 2
      do 170 IPASS = 1, MPASS
         if(STAR) then
            if(NARROW) then
               if(IPASS .eq. 1) then
                  write(*,221)
               else
                  write(*,222)
               endif
            else
               write (*,220)
            endif
         else
            if(NARROW) then
               if(IPASS .eq. 1) then
                  write(UNIT,221)
               else
                  write(UNIT,222)
               endif
            else
               write (UNIT,220)
            endif
         endif
c                               The following stmt converts from
c                               integer to floating-point.
      A3 = WORK(1)
      A4 = sqrt(A3/ max(1,MDATA))
      if(STAR) then
         if(NARROW) then
            if(IPASS .eq. 1) then
               write(*,231) A4
            else
               write(*,232) A3, A4
            endif
         else
            write (*,230) A3,A4
         endif
      else
         if(NARROW) then
            if(IPASS .eq. 1) then
               write(UNIT,231) A4
            else
               write(UNIT,232) A3, A4
            endif
         else
            write (UNIT,230) A3,A4
         endif
      endif
C
      DO 160 K = 1,MINMN
         if (SING(K).EQ.ZERO) then
            PCOEF = ZERO
            if(STAR) then
               write (*,240) K,SING(K)
            else
               write (UNIT,240) K,SING(K)
            endif
         else
            PCOEF = B(K) / SING(K)
            A1 = ONE / SING(K)
            A2 = B(K)**2
            A3 = WORK(K+1)
            A4 = sqrt(A3/max(1,MDATA-K))
            if(STAR) then
               if(NARROW) then
                  if(IPASS .eq. 1) then
                     write(*,240) K,SING(K),PCOEF,A1,B(K),      A4
                  else
                     write(*,240) K,SING(K),         B(K),A2,A3,A4
                  endif
               else
                  write (*,240) K,SING(K),PCOEF,A1,B(K),A2,A3,A4
               endif
            else
               if(NARROW) then
                  if(IPASS .eq. 1) then
                     write(UNIT,240) K,SING(K),PCOEF,A1,B(K),      A4
                  else
                     write(UNIT,240) K,SING(K),         B(K),A2,A3,A4
                  endif
               else
                  write (UNIT,240) K,SING(K),PCOEF,A1,B(K),A2,A3,A4
               endif

            endif
         endif
  160 continue
  170 continue
      endif
c     -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      if( BLK(4) ) then
C
C         Compute and print values of YNORM, RNORM and their logarithms.
C
      if(STAR) then
         write (*,300)
      else
         write (UNIT,300)
      endif
      YSQ = ZERO
      do 180 J = 0, NSOL
         if(J .ne. 0) YSQ = YSQ + (B(J) / SING(J))**2
         YNORM = sqrt(YSQ)
         RNORM = sqrt(WORK(J+1))
         YL = -THOU
         IF (YNORM .GT. ZERO) YL = log10(YNORM)
         RL = -THOU
         IF (RNORM .GT. ZERO) RL = log10(RNORM)
         if(STAR) then
            write (*,310) J,YNORM,RNORM,YL,RL
         else
            write (UNIT,310) J,YNORM,RNORM,YL,RL
         endif
  180 continue
      endif
c     -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      if( BLK(5) .and. SING(1) .ne. ZERO ) then
C
C     COMPUTE VALUES OF XNORM AND RNORM FOR A SEQUENCE OF VALUES OF
C     THE LEVENBERG-MARQUARDT PARAMETER.
C
         EL = log10(SING(1)) + ONE
         EL2 = log10(SING(NSOL)) - ONE
         DEL = (EL2-EL) / TWENTY
         ALN10 = log(TEN)
         if(STAR) then
            write (*,320)
         else
            write (UNIT,320)
         endif
         DO 200 IE = 1,21
C                                    COMPUTE        ALAMB = 10.0**EL
            ALAMB = EXP(ALN10*EL)
            YS = ZERO
            RS = WORK(NSOL+1)
            DO 190 I = 1,MINMN
               SL = SING(I)**2 + ALAMB**2
               YS = YS + (B(I)*SING(I)/SL)**2
               RS = RS + (B(I)*(ALAMB**2)/SL)**2
  190       CONTINUE
            YNORM = sqrt(YS)
            RNORM = sqrt(RS)
            RL = -THOU
            IF (RNORM.GT.ZERO) RL = log10(RNORM)
            YL = -THOU
            IF (YNORM.GT.ZERO) YL = log10(YNORM)
            if(STAR) then
               write (*,330) ALAMB,YNORM,RNORM,EL,YL,RL
            else
               write (UNIT,330) ALAMB,YNORM,RNORM,EL,YL,RL
            endif
            EL = EL + DEL
  200    CONTINUE
      endif
c     -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C                   Compute and optionally print candidate solutions.
C
      do 215 K = 1,NSOL
         PCOEF = B(K) / SING(K)
         DO 210 I = 1,N
                A(I,K) = A(I,K) * PCOEF
  210           IF (K.GT.1) A(I,K) = A(I,K) + A(I,K-1)
  215 continue
      if (BLK(6) .and. NSOL.GE.1)
     *       CALL MFEOUT (A,MDA,N,NSOL,NAMES,2,UNIT,WIDTH)
      return
      END

      subroutine MFEOUT (A, MDA, M, N, NAMES, MODE, UNIT, WIDTH)
c
C  LABELED MATRIX OUTPUT FOR USE WITH SINGULAR VALUE ANALYSIS.
C   
c  The original version of this code was developed by
c  Charles L. Lawson and Richard J. Hanson at Jet Propulsion Laboratory
c  1973 JUN 12, and published in the book
c  "SOLVING LEAST SQUARES PROBLEMS", Prentice-HalL, 1974.
c  Revised FEB 1995 to accompany reprinting of the book by SIAM.
C     ------------------------------------------------------------------   
c  This 1995 version has additional arguments, UNIT and WIDTH,
c  to support user options regarding the output unit and the width of
c  print lines.  Also allows user to choose length of names in NAMES().
c     ------------------------------------------------------------------
c                           Subroutine Arguments
C     All are input arguments.  None are modified by this subroutine.
c
C     A(,)     Array containing matrix to be output.
C     MDA      First dimension of the array, A(,).
C     M, N     No. of rows and columns, respectively in the matrix
c              contained in A(,).
C     NAMES()  [character array]  Array of names.
c              If NAMES(1) contains only blanks, the rest of the NAMES()
c              array will be ignored.
C     MODE     =1  Write header for V matrix and use an F format.
C              =2  Write header for  for candidate solutions and use
c                  P format.
c     UNIT  [integer]   Selects output unit.  If UNIT .ge. 0 then UNIT
c              is the output unit number.  If UNIT = -1, output to
c              the '*' unit.
c     WIDTH [integer]   Selects width of output lines.
c              Each output line from this subroutine will have at most
c              max(26,min(124,WIDTH)) characters plus one additional
c              leading character for Fortran "carriage control".  The
c              carriage control character will always be a blank.
c     ------------------------------------------------------------------
      integer I, J, J1, J2, KBLOCK, L, LENNAM
      integer M, MAXCOL, MDA, MODE, N, NAMSIZ, NBLOCK, UNIT, WIDTH
      double precision    A(MDA,N)
      character  NAMES(M)*(*)
      character*4  HEAD (2)
      character*26 FMT1(2)
      character*26 FMT2(2)
      logical      BLKNAM, STAR
C
      data HEAD(1)/' COL'/
      data HEAD(2)/'SOLN'/
      data FMT1 / '(/7x,00x,8(5x,a4,i4,1x)/)',
     *            '(/7x,00x,8(2x,a4,i4,4x)/)'/
      data FMT2 / '(1x,i4,1x,a00,1x,4p8f14.0)',
     *            '(1x,i4,1x,a00,1x,8g14.6  )'/
c     ------------------------------------------------------------------
      if (M .le. 0 .or. N .le. 0) return
      STAR = UNIT .lt. 0
C
c     The LEN function returns the char length of a single element of
c     the NAMES() array.
c
      LENNAM = len(NAMES(1))
      BLKNAM = NAMES(1) .eq. ' '
      NAMSIZ = 1
      if(.not. BLKNAM) then
         do 30 I = 1,M
            do 10 L = LENNAM, NAMSIZ+1, -1
               if(NAMES(I)(L:L) .ne. ' ') then
                  NAMSIZ = L
                  go to 20
               endif
   10       continue
   20       continue
   30    continue
      endif
c
      write(FMT1(MODE)(6:7),'(i2.2)') NAMSIZ
      write(FMT2(MODE)(12:13),'(i2.2)') NAMSIZ

   70 format(/' V-Matrix of the Singular Value Decomposition of A*D.'/
     *    ' (Elements of V scaled up by a factor of 10**4)')
   80 format(/' Sequence of candidate solutions, X')

      if(STAR) then
         if (MODE .eq. 1) then
            write (*,70)
         else
            write (*,80)
         endif
      else
         if (MODE .eq. 1) then
            write (UNIT,70)
         else
            write (UNIT,80)
         endif
      endif
c
c     With NAMSIZ characters allowed for the "name" and MAXCOL
c     columns of numbers, the total line width, exclusive of a
c     carriage control character, will be 6 + LENNAM + 14 * MAXCOL.
c
      MAXCOL = max(1,min(8,(WIDTH - 6 - NAMSIZ)/14))
C
      NBLOCK = (N + MAXCOL -1) / MAXCOL
      J2 = 0
C
      do 50 KBLOCK = 1, NBLOCK
         J1 = J2 + 1
         J2 = min(N, J2 + MAXCOL)
         if(STAR) then
            write (*,FMT1(MODE)) (HEAD(MODE),J,J=J1,J2)
         else
            write (UNIT,FMT1(MODE)) (HEAD(MODE),J,J=J1,J2)
         endif
C
         do 40 I=1,M
            if(STAR) then
               if(BLKNAM) then
                  write (*,FMT2(MODE)) I,' ',(A(I,J),J=J1,J2)
               else
                  write (*,FMT2(MODE)) I,NAMES(I),(A(I,J),J=J1,J2)
               endif
            else
               if(BLKNAM) then
                  write (UNIT,FMT2(MODE)) I,' ',(A(I,J),J=J1,J2)
               else
                  write (UNIT,FMT2(MODE)) I,NAMES(I),(A(I,J),J=J1,J2)
               endif
            endif
   40    continue
   50 continue
      end

      FUNCTION gasdev(idum)
      INTEGER idum
      REAL gasdev
CU    USES ran1
      INTEGER iset
      REAL fac,gset,rsq,v1,v2,ran1
      SAVE iset,gset
      DATA iset/0/
      if (iset.eq.0) then
1       v1=2.*ran1(idum)-1.
        v2=2.*ran1(idum)-1.
        rsq=v1**2+v2**2
        if(rsq.ge.1..or.rsq.eq.0.)goto 1
        fac=sqrt(-2.*log(rsq)/rsq)
        gset=v1*fac
        gasdev=v2*fac
        iset=1
      else
        gasdev=gset
        iset=0
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software -)+%.

C     SUBROUTINE H12 (MODE,LPIVOT,L1,M,U,IUE,UP,C,ICE,ICV,NCV)  
C   
C  CONSTRUCTION AND/OR APPLICATION OF A SINGLE   
C  HOUSEHOLDER TRANSFORMATION..     Q = I + U*(U**T)/B   
C   
c  The original version of this code was developed by
c  Charles L. Lawson and Richard J. Hanson at Jet Propulsion Laboratory
c  1973 JUN 12, and published in the book
c  "SOLVING LEAST SQUARES PROBLEMS", Prentice-HalL, 1974.
c  Revised FEB 1995 to accompany reprinting of the book by SIAM.
C     ------------------------------------------------------------------
c                     Subroutine Arguments
c
C     MODE   = 1 OR 2   Selects Algorithm H1 to construct and apply a
c            Householder transformation, or Algorithm H2 to apply a
c            previously constructed transformation.
C     LPIVOT IS THE INDEX OF THE PIVOT ELEMENT. 
C     L1,M   IF L1 .LE. M   THE TRANSFORMATION WILL BE CONSTRUCTED TO   
C            ZERO ELEMENTS INDEXED FROM L1 THROUGH M.   IF L1 GT. M     
C            THE SUBROUTINE DOES AN IDENTITY TRANSFORMATION.
C     U(),IUE,UP    On entry with MODE = 1, U() contains the pivot
c            vector.  IUE is the storage increment between elements.  
c            On exit when MODE = 1, U() and UP contain quantities
c            defining the vector U of the Householder transformation.
c            on entry with MODE = 2, U() and UP should contain
c            quantities previously computed with MODE = 1.  These will
c            not be modified during the entry with MODE = 2.   
C     C()    ON ENTRY with MODE = 1 or 2, C() CONTAINS A MATRIX WHICH
c            WILL BE REGARDED AS A SET OF VECTORS TO WHICH THE
c            HOUSEHOLDER TRANSFORMATION IS TO BE APPLIED.
c            ON EXIT C() CONTAINS THE SET OF TRANSFORMED VECTORS.
C     ICE    STORAGE INCREMENT BETWEEN ELEMENTS OF VECTORS IN C().  
C     ICV    STORAGE INCREMENT BETWEEN VECTORS IN C().  
C     NCV    NUMBER OF VECTORS IN C() TO BE TRANSFORMED. IF NCV .LE. 0  
C            NO OPERATIONS WILL BE DONE ON C(). 
C     ------------------------------------------------------------------
      SUBROUTINE H12 (MODE,LPIVOT,L1,M,U,IUE,UP,C,ICE,ICV,NCV)  
C     ------------------------------------------------------------------
      integer I, I2, I3, I4, ICE, ICV, INCR, IUE, J
      integer L1, LPIVOT, M, MODE, NCV
      double precision B, C(*), CL, CLINV, ONE, SM
c     double precision U(IUE,M)
      double precision U(IUE,*)
      double precision UP
      parameter(ONE = 1.0d0)
C     ------------------------------------------------------------------
      IF (0.GE.LPIVOT.OR.LPIVOT.GE.L1.OR.L1.GT.M) RETURN    
      CL=abs(U(1,LPIVOT))   
      IF (MODE.EQ.2) GO TO 60   
C                            ****** CONSTRUCT THE TRANSFORMATION. ******
          DO 10 J=L1,M  
   10     CL=MAX(abs(U(1,J)),CL)  
      IF (CL) 130,130,20
   20 CLINV=ONE/CL  
      SM=(U(1,LPIVOT)*CLINV)**2   
          DO 30 J=L1,M  
   30     SM=SM+(U(1,J)*CLINV)**2 
      CL=CL*SQRT(SM)   
      IF (U(1,LPIVOT)) 50,50,40     
   40 CL=-CL
   50 UP=U(1,LPIVOT)-CL 
      U(1,LPIVOT)=CL    
      GO TO 70  
C            ****** APPLY THE TRANSFORMATION  I+U*(U**T)/B  TO C. ******
C   
   60 IF (CL) 130,130,70
   70 IF (NCV.LE.0) RETURN  
      B= UP*U(1,LPIVOT)
C                       B  MUST BE NONPOSITIVE HERE.  IF B = 0., RETURN.
C   
      IF (B) 80,130,130 
   80 B=ONE/B   
      I2=1-ICV+ICE*(LPIVOT-1)   
      INCR=ICE*(L1-LPIVOT)  
          DO 120 J=1,NCV
          I2=I2+ICV     
          I3=I2+INCR    
          I4=I3 
          SM=C(I2)*UP
              DO 90 I=L1,M  
              SM=SM+C(I3)*U(1,I)
   90         I3=I3+ICE 
          IF (SM) 100,120,100   
  100     SM=SM*B   
          C(I2)=C(I2)+SM*UP
              DO 110 I=L1,M 
              C(I4)=C(I4)+SM*U(1,I)
  110         I4=I4+ICE 
  120     CONTINUE  
  130 RETURN
      END   

c     file sac_io.f
c          ========
c
c     Revision by Karl Koch, 24Nov99
c
c     version 1, 20-Aug-98
c
c     SAC I/O routines for codeco.
c     Original routines by Hugues Dufumier
c     Major revision by K. Koch (19-Aug-98) and K. Stammler (20-Aug-98)



c==============================================================================



      subroutine sacin( infile, iy, ierror )
c
c     Program for conversions between GSE1.0, GSE2.0 and SAC data files.
c
c     Program modified by Hugues Dufumier to add Sac input/outputs.
c     Some bugs fixed and extension to more than 80 characters. January 98 /hd
c
c     ! Portability: Modify write(6,*) statements if not supported on HP or VMS
c                    and adapt subroutine INTAND to your computer !
c
c     Warning: Some bugs may persist with the compression schemes
c              GSE1.0 CMP7 & CMP8 and GSE2.0 CM8.
c              It is recommended to rather use CMP6 and CM6 compressions.
c              If not, for CMP7 & CMP8, prefer 0 or 1 differences to 2.

      implicit none

c     -- get header variables (hdr_...) and constants (c_...)
      include 'codeco_common.f'

c     -- parameters
      character*80   infile          ! name of input file (input)
      integer        iy(c_sigsize)   ! sample array (output)
      integer        ierror          ! return status (output)

c     -- local variables
      logical        sac_found       ! identified as SAC
      real           dt              ! sample distance in sec
      real           begin           ! start time of waveform segment
      real           sec             ! variable to hold seconds (real)
      integer*4 i, IRU, ierr
      real y(c_sigsize)

c     -- executable code

      if  (hdr_debug .gt. 2)  write(*,*)  '-- entering sacin'
      sac_found = .false.

c     -- test if this is a SAC binary file
      IRU=3
      call BRSAC(IRU,c_sigsize,infile,y,ierror)
      if  (ierror .eq. 0)  then
         if  (hdr_debug .gt. 0)  write(*,*)
     &      '-- detected SAC binary format.'
         hdr_ifmtname='SAC'
         hdr_ifmtnum=-1
         sac_found = .true.
      endif

c     -- test if this is a SAC ascii file
      if  (.not. sac_found)  then
         call ARSAC(IRU,c_sigsize,infile,y,ierror)
         if  (ierror .eq. 0)  then
            if  (hdr_debug .gt. 0)  write (*,*)
     &         '-- detected SAC ASCII format.'
            hdr_ifmtname='SACA'
            hdr_ifmtnum=-2
            sac_found = .true.
         endif
      endif

c     -- no SAC file, return
      if  (.not. sac_found)  then
         if  (hdr_debug .gt. 0)  write(*,*)
     &      '-- sacin: no sac file', infile
         hdr_ifmtname = 'UNK'
         hdr_ifmtnum = 0
         ierror = 999
         if  (hdr_debug .gt. 3)  write (*,*) '-- leaving sacin'
         return
      endif

c     -- extract number of samples and convert samples to integer
      CALL GETNHV('NPTS    ',hdr_nsamp,IERR)
      if  (hdr_debug .gt. 0)  write (*,*)
     &   '-- no.samples, err', hdr_nsamp,ierr
      do i=1,hdr_nsamp
         iy(i)=int(y(i))
      enddo

c     -- read Sac header values

      CALL GETFHV('DELTA   ',dt,ierr)
      CALL GETFHV('B       ',begin,ierr)
      hdr_smprate = 1.0 / dt

c     -- read the record time
      CALL GETNHV('NZYEAR  ',hdr_year,ierr)
      CALL GETNHV('NZJDAY  ',hdr_jday,ierr)
      CALL GETNHV('NZHOUR  ',hdr_hour,ierr)
      CALL GETNHV('NZMIN   ',hdr_min,ierr)
      CALL GETNHV('NZSEC   ',hdr_sec,ierr)
      CALL GETNHV('NZMSEC  ',hdr_msec,ierr)
      if  (hdr_debug .gt. 0)  write (*,*) '-- got time ',
     &   hdr_year, hdr_jday, hdr_hour, hdr_min, hdr_sec,
     &   hdr_msec, ierr

c     -- retrieve record time including begin shift
      sec=begin+float(hdr_sec)+float(hdr_msec)/1000.
      hdr_sec=int(sec)
      hdr_msec=1000.*(sec-float(hdr_sec))
      if (hdr_msec .lt.0) then
          hdr_sec=hdr_sec -1
c --- just in case you worry about the 999: the float to integer
c     operation from above cuts for negative values towards 0
          hdr_msec=999+hdr_msec
      endif
      hdr_min=hdr_min+int(float(hdr_sec)/60.)
      hdr_sec=mod(hdr_sec,60)
      if (hdr_sec .lt.0) then
          hdr_min=hdr_min-1
          hdr_sec=60+hdr_sec
      endif
      hdr_hour=hdr_hour+int(float(hdr_min)/60.)
      hdr_min=mod(hdr_min,60)
      if (hdr_min .lt.0) then
          hdr_hour=hdr_hour-1
          hdr_min=60+hdr_min
      endif
      hdr_jday=hdr_jday+int(float(hdr_hour)/24.)
      hdr_hour=mod(hdr_hour,24)
      if (hdr_hour .lt.0) then
          hdr_jday=hdr_jday-1
          hdr_hour=24+hdr_hour
      endif
      if (hdr_jday.lt.1) then
          hdr_year=hdr_year-1
          call julien( 31, 12, hdr_year, hdr_jday, 1 )
      else
          call julien( hdr_day, hdr_month, hdr_year, hdr_jday, 0 )
      endif
      if  (hdr_debug .gt. 0)  write (*,*) '-- got start time ',
     &   hdr_year, hdr_jday, hdr_hour, hdr_min, hdr_sec,
     &   hdr_msec, begin,sec

c     -- read other header values
      CALL GETKHV('KSTNM   ',hdr_station,ierr)
      CALL GETKHV('KCMPNM  ',hdr_chan,ierr)
      CALL GETKHV('KINST   ',hdr_instr,ierr)
      if  (hdr_debug .gt. 0)  write (*,*) '-- and ',
     &   hdr_station, hdr_chan, hdr_instr, ierr
      CALL GETFHV('STLA    ',hdr_stalat,ierr)
      CALL GETFHV('STLO    ',hdr_stalon,ierr)
      CALL GETFHV('STEL    ',hdr_staelev,ierr)
      CALL GETFHV('STDP    ',hdr_stadepth,ierr)
      if  (hdr_debug .gt. 0)  write (*,*) '-- and ',
     &   hdr_smprate, hdr_stalat, hdr_stalon, hdr_staelev,
     &   hdr_stadepth, ierr
      CALL GETFHV('BAZ     ',hdr_beamaz,ierr)
      CALL GETFHV('CMPAZ   ',hdr_hang,ierr)
      CALL GETFHV('CMPINC  ',hdr_vang,ierr)
c     calibration factor and period are usually not available from Sac
      hdr_calfac = 0.0
      hdr_calper = -1.0
      CALL GETFHV('USER0   ',hdr_calfac,IERR)
      CALL GETFHV('USER1   ',hdr_calper,IERR)
      if  (hdr_debug .gt. 0)  write (*,*) '-- and ',
     &   hdr_beamaz, hdr_hang, hdr_vang, hdr_calfac,
     &   hdr_calper, ierr
      if  (hdr_stalat .le. -12345.0)  hdr_stalat = -999.0
      if  (hdr_stalon .le. -12345.0)  hdr_stalon = -999.0
      if  (hdr_staelev .le. -12345.0)  hdr_staelev = -999.0
      if  (hdr_stadepth .le. -12345.0)  hdr_stadepth = -999.0
      if  (hdr_beamaz .le. -12345.0)  hdr_beamaz = -999.

cks      chid='        '
cks      hdr_idiff = 0

      if  (hdr_debug .gt. 3)  write (*,*) '-- leaving sacin'
      close(3)
      return
      end



c ==============================================================================



      subroutine sacout( outfile, iy, wavecnt )

c     Program to convert GSE2.0-datafiles into other GSE or Sac format.
c                        ------
c
c     Program adapted by Hugues Dufumier to add output in Sac format.
c     1997, EOST Ecole et Observatoire Sciences de la Terre, Strasbourg
c
c     Converts INT, CM2 and CM6 formats in INT, CM6 or SAC[A] ones.
c
c     Usage: gse2sac InputFile OutputFile OutputFormat (INT, CM6 or SAC[A])
c
c     For Sac outputs, all channels will be converted in single files.
c     Station and Component names will be appended: OutputFile.STA.CMP
c

      implicit none

c     -- get header variables
      include 'codeco_common.f'

c     -- parameters
      character      outfile*80      ! name of output file (input)
      integer        iy(c_sigsize)   ! sample array (input)
      integer        wavecnt         ! waveform counter (input)

c     -- local variables
      integer     ierr               ! return code
      integer     i                  ! counter
c     integer     y2                 ! 2-digit year
      real        dt                 ! sample distance in sec
      real        y(c_sigsize)       ! real array
      character FSAC*90
      integer*4 IRU, LN, NERR

c     -- functions
      integer   trimlen

c     -- executable code

      if  (hdr_debug .gt. 1)  write (*,*) '-- entering sacout'

      dt = 1.0 / hdr_smprate

c     -- build sac filename
      fsac = ' '
c     -- use station and time info in filename
c     y2 = hdr_year - 1900
c     if  (y2 .ge. 100)  y2 = y2 - 100
c     write( fsac, '(4a,3i2.2,a,3i2.2,2a)' )
c    &   outfile(1:trimlen(outfile)), '.',
c    &   hdr_station(1:trimlen(hdr_station)), '_', y2, hdr_month,
c    &   hdr_day, '_', hdr_hour, hdr_min, hdr_sec, '.',
c    &   hdr_chan(1:trimlen(hdr_chan))
c     -- just number files
      write( fsac, '(2a,i3.3)' )
     &   outfile(1:trimlen(outfile)), '.', wavecnt
      if  (hdr_debug .gt. 2)  write (*,*) '-- create sac file ',
     &   outfile(1:trimlen(outfile)), wavecnt

c     -- writes in header the useful values
      CALL NEWHDR()
      CALL SETNHV('NPTS    ',hdr_nsamp,IERR)
      CALL SETLHV('LEVEN   ',.TRUE.,IERR)
      CALL SETLHV('LOVROK  ',.TRUE.,IERR)
      CALL SETLHV('LCALDA  ',.TRUE.,IERR)
      CALL SETFHV('B       ',0.,IERR)
      CALL SETFHV('E       ',FLOAT(hdr_nsamp-1)*dt,IERR)
      CALL SETFHV('DELTA   ',dt,IERR)
      CALL SETIHV('IFTYPE  ','ITIME',IERR)
      CALL SETIHV('IZTYPE  ','IB',IERR)
c     -- writes the record time
      CALL SETNHV('NZYEAR  ',hdr_year,IERR)
      CALL SETNHV('NZJDAY  ',hdr_jday,IERR)
      CALL SETNHV('NZHOUR  ',hdr_hour,IERR)
      CALL SETNHV('NZMIN   ',hdr_min,IERR)
      CALL SETNHV('NZSEC   ',hdr_sec,IERR)
      CALL SETNHV('NZMSEC  ',hdr_msec,IERR)
c     -- writes other header values
      CALL SETKHV('KSTNM   ',hdr_station,IERR)
      CALL SETKHV('KCMPNM  ',hdr_chan,IERR)
      CALL SETKHV('KINST   ',hdr_instr,IERR)
      CALL SETKHV('KUSER0  ','codeco',IERR)
      CALL SETIHV('ISYNTH  ','IRLDTA',IERR)
      CALL SETFHV('CMPAZ   ',hdr_beamaz,IERR)
      CALL SETFHV('CMPINC  ',hdr_beamslo,IERR)
c     -- calibration factor and period reported in user0 and user1
c     -- change to displacement units
      hdr_calfac = hdr_calfac / 
     &   (atan(1.0)*8.0/hdr_calper)**hdr_calunit
      hdr_calunit = 0
      CALL SETFHV('USER0   ',hdr_calfac,IERR)
      CALL SETFHV('USER1   ',hdr_calper,IERR)
      call setihv('IFTYPE   ','ITIME   ',nerr)
      call setihv('IZTYPE   ','IB      ',nerr)

c     -- set logical header value
      call setlhv('LEVEN   ',.true.,nerr)
      call setlhv('LSPOL   ',.true.,nerr)
      call setlhv('LOVERK  ',.false.,nerr)
      call setlhv('LCALDA  ',.false.,nerr)
c     -- writes the data
      do i=1,hdr_nsamp
         y(i)=float(iy(i))
      enddo
C     CALL WSAC0(FSAC,Y,Y,IERR)
      IRU = 1
      LN = c_sigsize
      if (hdr_ofmtname.eq.'SACA') then
          call awsac(IRU,LN,FSAC(1:trimlen(FSAC)),Y)
      else
          call bwsac(IRU,LN,FSAC(1:trimlen(FSAC)),Y)
      endif
      IF(IERR.EQ.0) WRITE(6,'(3A,I6,A,F9.6,A)')'Written ',
     &   FSAC(1:trimlen(FSAC)),' :',hdr_nsamp,' points, dt=',dt,' s.'

      if  (hdr_debug .gt. 1)  write (*,*) '-- leaving sacout'
      return 
      end

      FUNCTION ran1(idum)
      INTEGER idum,IA,IM,IQ,IR,NTAB,NDIV
      REAL ran1,AM,EPS,RNMX
      PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
     *NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)
      INTEGER j,k,iv(NTAB),iy
      SAVE iv,iy
      DATA iv /NTAB*0/, iy /0/
      if (idum.le.0.or.iy.eq.0) then
        idum=max(-idum,1)
        do 11 j=NTAB+8,1,-1
          k=idum/IQ
          idum=IA*(idum-k*IQ)-IR*k
          if (idum.lt.0) idum=idum+IM
          if (j.le.NTAB) iv(j)=idum
11      continue
        iy=iv(1)
      endif
      k=idum/IQ
      idum=IA*(idum-k*IQ)-IR*k
      if (idum.lt.0) idum=idum+IM
      j=1+iy/NDIV
      iy=iv(j)
      iv(j)=idum
      ran1=min(AM*iy,RNMX)
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software -)+%.

C     SUBROUTINE QRBD (IPASS,Q,E,NN,V,MDV,NRV,C,MDC,NCC)    
c
C  QR ALGORITHM FOR SINGULAR VALUES OF A BIDIAGONAL MATRIX.
c
c  The original version of this code was developed by
c  Charles L. Lawson and Richard J. Hanson at Jet Propulsion Laboratory
c  1973 JUN 12, and published in the book
c  "SOLVING LEAST SQUARES PROBLEMS", Prentice-HalL, 1974.
c  Revised FEB 1995 to accompany reprinting of the book by SIAM.
C     ------------------------------------------------------------------   
C     THE BIDIAGONAL MATRIX 
C   
C                       (Q1,E2,0...    )
C                       (   Q2,E3,0... )
C                D=     (       .      )
C                       (         .   0)
C                       (           .EN)
C                       (          0,QN)
C   
C                 IS PRE AND POST MULTIPLIED BY 
C                 ELEMENTARY ROTATION MATRICES  
C                 RI AND PI SO THAT 
C   
C                 RK...R1*D*P1**(T)...PK**(T) = DIAG(S1,...,SN) 
C   
C                 TO WITHIN WORKING ACCURACY.   
C   
C  1. EI AND QI OCCUPY E(I) AND Q(I) AS INPUT.  
C   
C  2. RM...R1*C REPLACES 'C' IN STORAGE AS OUTPUT.  
C   
C  3. V*P1**(T)...PM**(T) REPLACES 'V' IN STORAGE AS OUTPUT.
C   
C  4. SI OCCUPIES Q(I) AS OUTPUT.   
C   
C  5. THE SI'S ARE NONINCREASING AND NONNEGATIVE.   
C   
C     THIS CODE IS BASED ON THE PAPER AND 'ALGOL' CODE..    
C REF..     
C  1. REINSCH,C.H. AND GOLUB,G.H. 'SINGULAR VALUE DECOMPOSITION 
C     AND LEAST SQUARES SOLUTIONS' (NUMER. MATH.), VOL. 14,(1970).  
C   
C     ------------------------------------------------------------------   
      SUBROUTINE QRBD (IPASS,Q,E,NN,V,MDV,NRV,C,MDC,NCC)    
C     ------------------------------------------------------------------   
      integer MDC, MDV, NCC, NN, NRV
c     double precision C(MDC,NCC), E(NN), Q(NN),V(MDV,NN)
      double precision C(MDC,*  ), E(* ), Q(* ),V(MDV,* )
      integer I, II, IPASS, J, K, KK, L, LL, LP1, N, N10, NQRS
      double precision CS, DIFF, DNORM, F, G, H, SMALL
      double precision ONE, SN, T, TEMP, TWO, X, Y, Z, ZERO
      
      logical WNTV ,HAVERS,FAIL     
      parameter(ONE = 1.0d0, TWO = 2.0d0, ZERO = 0.0d0)
C     ------------------------------------------------------------------   
      N=NN  
      IPASS=1   
      IF (N.LE.0) RETURN
      N10=10*N  
      WNTV=NRV.GT.0     
      HAVERS=NCC.GT.0   
      FAIL=.FALSE.  
      NQRS=0
      E(1)=ZERO 
      DNORM=ZERO
           DO 10 J=1,N  
   10      DNORM=max(abs(Q(J))+abs(E(J)),DNORM)   
           DO 200 KK=1,N
           K=N+1-KK     
C   
C     TEST FOR SPLITTING OR RANK DEFICIENCIES.. 
C         FIRST MAKE TEST FOR LAST DIAGONAL TERM, Q(K), BEING SMALL.    
   20       IF(K.EQ.1) GO TO 50     
            IF(DIFF(DNORM+Q(K),DNORM) .ne. ZERO) go to 50
C   
C     SINCE Q(K) IS SMALL WE WILL MAKE A SPECIAL PASS TO    
C     TRANSFORM E(K) TO ZERO.   
C   
           CS=ZERO  
           SN=-ONE  
                DO 40 II=2,K
                I=K+1-II
                F=-SN*E(I+1)
                E(I+1)=CS*E(I+1)    
                CALL G1 (Q(I),F,CS,SN,Q(I))     
C         TRANSFORMATION CONSTRUCTED TO ZERO POSITION (I,K).
C   
                IF (.NOT.WNTV) GO TO 40 
                     DO 30 J=1,NRV  
c
c                          Apply procedure G2 (CS,SN,V(J,I),V(J,K))  
c
                        TEMP = V(J,I)
                        V(J,I) = CS*TEMP + SN*V(J,K)
                        V(J,K) =-SN*TEMP + CS*V(J,K)
   30                continue
C              ACCUMULATE RT. TRANSFORMATIONS IN V. 
C   
   40           CONTINUE
C   
C         THE MATRIX IS NOW BIDIAGONAL, AND OF LOWER ORDER  
C         SINCE E(K) .EQ. ZERO..    
C   
   50           DO 60 LL=1,K
                  L=K+1-LL
                  IF(DIFF(DNORM+E(L),DNORM) .eq. ZERO) go to 100
                  IF(DIFF(DNORM+Q(L-1),DNORM) .eq. ZERO) go to 70
   60           CONTINUE
C     THIS LOOP CAN'T COMPLETE SINCE E(1) = ZERO.   
C   
           GO TO 100    
C   
C         CANCELLATION OF E(L), L.GT.1. 
   70      CS=ZERO  
           SN=-ONE  
                DO 90 I=L,K 
                F=-SN*E(I)  
                E(I)=CS*E(I)
                IF(DIFF(DNORM+F,DNORM) .eq. ZERO) go to 100
                CALL G1 (Q(I),F,CS,SN,Q(I))     
                IF (HAVERS) then
                     DO 80 J=1,NCC  
c
c                          Apply procedure G2 ( CS, SN, C(I,J), C(L-1,J)
c
                        TEMP = C(I,J)
                        C(I,J)   = CS*TEMP + SN*C(L-1,J)
                        C(L-1,J) =-SN*TEMP + CS*C(L-1,J)
   80                continue
                endif
   90           CONTINUE
C   
C         TEST FOR CONVERGENCE..    
  100      Z=Q(K)   
           IF (L.EQ.K) GO TO 170    
C   
C         SHIFT FROM BOTTOM 2 BY 2 MINOR OF B**(T)*B.   
           X=Q(L)   
           Y=Q(K-1)     
           G=E(K-1)     
           H=E(K)   
           F=((Y-Z)*(Y+Z)+(G-H)*(G+H))/(TWO*H*Y)
           G=sqrt(ONE+F**2) 
           IF (F .ge. ZERO) then
              T=F+G
           else
              T=F-G
           endif
           F=((X-Z)*(X+Z)+H*(Y/T-H))/X  
C   
C         NEXT QR SWEEP..   
           CS=ONE   
           SN=ONE   
           LP1=L+1  
                DO 160 I=LP1,K  
                G=E(I)  
                Y=Q(I)  
                H=SN*G  
                G=CS*G  
                CALL G1 (F,H,CS,SN,E(I-1))  
                F=X*CS+G*SN 
                G=-X*SN+G*CS
                H=Y*SN  
                Y=Y*CS  
                IF (WNTV) then
C   
C              ACCUMULATE ROTATIONS (FROM THE RIGHT) IN 'V' 
c
                     DO 130 J=1,NRV 
c                    
c                          Apply procedure G2 (CS,SN,V(J,I-1),V(J,I))
c
                        TEMP = V(J,I-1)
                        V(J,I-1) = CS*TEMP + SN*V(J,I)
                        V(J,I)   =-SN*TEMP + CS*V(J,I)
  130                continue
                endif
                CALL G1 (F,H,CS,SN,Q(I-1))  
                F=CS*G+SN*Y 
                X=-SN*G+CS*Y
                IF (HAVERS) then
                     DO 150 J=1,NCC 
c
c                          Apply procedure G2 (CS,SN,C(I-1,J),C(I,J))
c
                        TEMP = C(I-1,J)
                        C(I-1,J) = CS*TEMP + SN*C(I,J)
                        C(I,J)   =-SN*TEMP + CS*C(I,J)
  150                continue
                endif
c
C              APPLY ROTATIONS FROM THE LEFT TO 
C              RIGHT HAND SIDES IN 'C'..
C   
  160           CONTINUE
           E(L)=ZERO    
           E(K)=F   
           Q(K)=X   
           NQRS=NQRS+1  
           IF (NQRS.LE.N10) GO TO 20
C          RETURN TO 'TEST FOR SPLITTING'.  
C 
           SMALL=ABS(E(K))
           I=K     
C          IF FAILURE TO CONVERGE SET SMALLEST MAGNITUDE
C          TERM IN OFF-DIAGONAL TO ZERO.  CONTINUE ON.
C      ..           
                DO 165 J=L,K 
                TEMP=ABS(E(J))
                IF(TEMP .EQ. ZERO) GO TO 165
                IF(TEMP .LT. SMALL) THEN
                     SMALL=TEMP
                     I=J
                end if  
  165           CONTINUE
           E(I)=ZERO
           NQRS=0
           FAIL=.TRUE.  
           GO TO 20
C     ..    
C     CUTOFF FOR CONVERGENCE FAILURE. 'NQRS' WILL BE 2*N USUALLY.   
  170      IF (Z.GE.ZERO) GO TO 190 
           Q(K)=-Z  
           IF (WNTV) then
                DO 180 J=1,NRV  
  180           V(J,K)=-V(J,K)  
           endif
  190      CONTINUE     
C         CONVERGENCE. Q(K) IS MADE NONNEGATIVE..   
C   
  200      CONTINUE     
      IF (N.EQ.1) RETURN
           DO 210 I=2,N 
           IF (Q(I).GT.Q(I-1)) GO TO 220
  210      CONTINUE     
      IF (FAIL) IPASS=2 
      RETURN
C     ..    
C     EVERY SINGULAR VALUE IS IN ORDER..
  220      DO 270 I=2,N 
           T=Q(I-1)     
           K=I-1
                DO 230 J=I,N
                IF (T.GE.Q(J)) GO TO 230
                T=Q(J)  
                K=J     
  230           CONTINUE
           IF (K.EQ.I-1) GO TO 270  
           Q(K)=Q(I-1)  
           Q(I-1)=T     
           IF (HAVERS) then
                DO 240 J=1,NCC  
                T=C(I-1,J)  
                C(I-1,J)=C(K,J)     
  240           C(K,J)=T
           endif

  250      IF (WNTV) then
                DO 260 J=1,NRV  
                T=V(J,I-1)  
                V(J,I-1)=V(J,K)     
  260           V(J,K)=T
           endif
  270      CONTINUE     
C         END OF ORDERING ALGORITHM.
C   
      IF (FAIL) IPASS=2 
      RETURN
      END   

      SUBROUTINE G1 (A,B,CTERM,STERM,SIG)   
c
C     COMPUTE ORTHOGONAL ROTATION MATRIX..  
c
c  The original version of this code was developed by
c  Charles L. Lawson and Richard J. Hanson at Jet Propulsion Laboratory
c  1973 JUN 12, and published in the book
c  "SOLVING LEAST SQUARES PROBLEMS", Prentice-HalL, 1974.
c  Revised FEB 1995 to accompany reprinting of the book by SIAM.
C   
C     COMPUTE.. MATRIX   (C, S) SO THAT (C, S)(A) = (SQRT(A**2+B**2))   
C                        (-S,C)         (-S,C)(B)   (   0          )    
C     COMPUTE SIG = SQRT(A**2+B**2) 
C        SIG IS COMPUTED LAST TO ALLOW FOR THE POSSIBILITY THAT 
C        SIG MAY BE IN THE SAME LOCATION AS A OR B .
C     ------------------------------------------------------------------
      double precision A, B, CTERM, ONE, SIG, STERM, XR, YR, ZERO
      parameter(ONE = 1.0d0, ZERO = 0.0d0)
C     ------------------------------------------------------------------
      if (abs(A) .gt. abs(B)) then
         XR=B/A
         YR=sqrt(ONE+XR**2)
         CTERM=sign(ONE/YR,A)
         STERM=CTERM*XR
         SIG=abs(A)*YR     
         RETURN
      endif

      if (B .ne. ZERO) then
         XR=A/B
         YR=sqrt(ONE+XR**2)
         STERM=sign(ONE/YR,B)
         CTERM=STERM*XR
         SIG=abs(B)*YR     
         RETURN
      endif

      SIG=ZERO  
      CTERM=ZERO  
      STERM=ONE   
      RETURN
      END   

c***************************************************************************
      subroutine CASEFOLD(cn) ! Urs Kradolfer, 20. Feb. 1990
c
c Input : character-string of any length
c Output: same character-string, but all letters are CAPITAL now
c         (other characters are not changed)
c
c   --> this subroutine needs the function TRIMLEN !
c
c Call  : call CASEFOLD(charstring)
c
      implicit none
      character cn*(*)
      integer i, trimlen,ilen, ival
      ilen=trimlen(cn)
      do i=1,ilen
         ival=ICHAR(cn(i:i))
         if(ival.ge.97.and.ival.le.122)then
            cn(i:i)=CHAR(ival-32)
         endif
      enddo
      RETURN
      end ! of subroutine casefold
c
c***************************************************************************
      integer function TRIMLEN(t)   ! Urs Kradolfer, June 1986
c
c     Call:    nc=TRIMLEN(char)
c
c          --> nc says, how many characters the input-string has
c              (ignoring trailing blanks!).
c
      implicit none
      character t*(*)
      do 1 trimlen=LEN(t),1,-1
    1    if(t(trimlen:trimlen).ne.' ')RETURN
      trimlen=1
      end ! of integer function trimlen
c
c***************************************************************************

      integer function TRIMBEG(t)   ! Urs Kradolfer, 17.1.90
c
c     Call:    nc=TRIMBEG(char)
c
c          --> nc returns the position of the first characters of
c              the input-string (ignoring leading blanks!).
c
      implicit none
      character t*(*)
      do 1 trimbeg=1,LEN(t)
    1    if(t(trimbeg:trimbeg).ne.' ')RETURN
      trimbeg=1

      end ! of integer function trimbeg


C=======================================================================

      SUBROUTINE JULIEN(IJ,IM,IY,IJD,ISI)

C=======================================================================
C     CONVERTS IJ,IM,IY -> IY,IJD      FOR ISI >= 1
C     CONVERTS IY,IJD   -> IJ,IM,IY    FOR ISI <= 0
C     EX:  IJ,IM,IY = 21 02 80    IY,IJD = 1980 52

      INTEGER IMO(12)
      DATA IMO/31,28,31,30,31,30,31,31,30,31,30,31/

cTD   IF(MOD(IY,4).EQ.0) IMO(2)=29
      IF(MOD(IY,4).EQ.0)then
        IMO(2)=29
      else
        IMO(2)=28
      end if
      IF(IY.LT.1900) IY=IY+1900
      if  (iy .lt. 1970)  iy = iy + 100   ! K.S. 20-Aug-98

      IF(ISI.GE.1) THEN
        IJD=0
        DO 10 I=1,IM-1
   10   IJD=IJD+IMO(I)
        IJD=IJD+IJ
      ELSE
        IDL=IJD
        DO 30 I=1,12
        IF(IDL.LE.IMO(I)) GOTO 40
   30   IDL=IDL-IMO(I)
   40   IJ=IDL
        IM=I
      ENDIF

      RETURN
      END

c***************************************************************************
c
      subroutine DIF1(iy,nmax)
c
c     Do Data-compression (first differences)
c
c     Urs Kradolfer, January 1990
c
      implicit none
      integer nmax, iy(nmax), k, xim1, xtemp
c
      xim1=iy(1)
      do k=2,nmax
         xtemp=iy(k)
         iy(k)=xtemp-xim1
         xim1=xtemp
      enddo
c
      RETURN
      end ! of subroutine dif1
c
c***************************************************************************
c
      subroutine REMDIF1(iy,nmax)
c
c     Remove Data-compression (first differences)
c
c     Urs Kradolfer, January 1990
c
      implicit none
      integer nmax, iy(nmax), k
c
      do k=2,nmax
         iy(k)=iy(k)+iy(k-1)
      enddo
c
      RETURN
      end ! of subroutine remdif1
c
c***************************************************************************
      integer*4 function icheck_sum_gse1(ix,n)
c     Karl Koch, May 1995
      integer*4 ix(n),n
      integer*4 i,nchk

      nchk=0
      do i=1,n
         nchk=nchk+ix(i)
      enddo
      icheck_sum_gse1=nchk
      return
      end

c
c***************************************************************************
      integer*4 function icheck_sum_gse2(ix,n)
c     Karl Koch, May 1995
      integer*4 ix(n),n
      integer*4 i,nchk,ixx
      integer*4 MODULO_VALUE
      parameter (MODULO_VALUE = 100 000 000)
      integer*4 modulo
c
      modulo=MODULO_VALUE
      nchk=0
      do i=1,n
        ixx=ix(i)
        if (abs(ixx).ge.modulo) ixx=ixx-(ixx/modulo)*modulo
           nchk=nchk+ixx
        if (abs(nchk).ge.modulo) nchk=nchk-(nchk/modulo)*modulo
      enddo
      icheck_sum_gse2=abs(nchk)
      return
      end



c ==============================================================================



      subroutine get_flags( ifmt, flags )

c     Parses format string 'ifmt' and extracts flags appended after '-'.
c     'ifmt' is truncated at '-'.
c     K. Stammler, 20-Aug-98

c     -- parameters
      character*(*)   ifmt     ! user input (modified)
      character*(*)   flags    ! flag string found (output)

c     -- local variables
      integer         strlth   ! length of input string
      integer         i, j     ! counter
      logical         f_found  ! flags found

c     -- functions
      integer         trimlen

c     -- executable code

      flags = ' '
      strlth = trimlen( ifmt )
      f_found = .false.
      j = 1
      do  i=1,strlth
         if  (f_found)  then
            flags(j:j) = ifmt(i:i)
            ifmt(i:i) = ' '
         endif
         if  (ifmt(i:i) .eq. '-')  then
            f_found = .true.
            ifmt(i:i) = ' '
         endif
      enddo

      end ! of subroutine get_flags



c ==============================================================================

c  Checks for 'CHK2' changed to checks for 'CHK2 ', because it occurred that
c  compressed waveform data started with 'CHK2...' on the first column of a
c  line.       Urs Kradolfer, 3 May 2000
c
c  Set hdr_instr = '_' (instead of ' ') in subr. init_hdrvars.  3Dec99 K.Koch
c
c  Output-Lines in GSE-Format have always a length of 80 characters, also the
c  last line of the DAT2 section. Urs Kradolfer, 6.6.99
c
c  Version 98.002 - 27.11.98
c==============================================================================
c     Karl Koch, 08.05.98
c
c     This file contains two subroutines: GSEIN and GSEOUT
c
c          *) GSEIN ....  reads GSE-waveform data
c
c          *) GSEOUT ...  write GSE-waveform data
c
c==============================================================================
c
c-----
      subroutine gsein(iin,iout,cbuf,iy,ichecksum,ierr)
c------------------------------------------------------------------------------
c     Input/Output parameters:
c        iin ......... logical unit with input data
c        iout ........ logical unit for output data
c        cbuf ........ character array to store compressed data (see c_bufsize)
c        iy .......... integer array to hold raw waveform data (see c_sigsize)
c        ichecksum ... checksum value for data stored in iy according to format
c        ierr ........ error code
c
c        in common block
c        hdr_ifmtnum . GSE format identifier of input data
c        hdr_nsamp ... number of samples in array iy
c
c        disabled
c        iformat_in .. GSE format identifier (ie. =2 for GSE2.0) (output)
c        nmax ........ number of samples in array iy (output)
c        lin ......... character array to hold header lines
c        ilin ........ number of header lines (output)
c------------------------------------------------------------------------------
c
      implicit none

c     -- include header variables (hdr_...) and constants (c_...)
      include 'codeco_common.f'

c     -- parameters
      integer*4 iin, iout
      character*1 cbuf(1)
      integer*4 iy(1)
      integer*4 ichecksum, ierr

c     -- local variables
      integer*4 icomp, i, j, ierror, nchecksum
      integer*4 numout, nchar, ii
      integer*4 trimlen
      integer*4 icheck_sum_gse1,icheck_sum_gse2
      real      fsec                 ! seconds and milliseconds
      character line*132, fmt*6
      character firstline*132        ! store first line for error message
c     -- for month conversions:
      integer   mnths(12)
      data mnths/31,28,31,30,31,30,31,31,30,31,30,31/

c     -- executable code

		hdr_coosys = ' '
      if  (hdr_debug .gt. 2)  write (*,*)  '-- entering gsein'
      ierr = 0

c     -- loop all lines in GSE file until WID is found
1     read(iin,'(a)',end=999) line
      if  (line(1:4) .ne. 'WID1' .and. line(1:4) .ne. 'WID2')  then
c        -- copy all lines before WID-line
         if  (hdr_ofmtnum .gt. 0)
     &      write(iout,'(a)') line(1:trimlen(line))
         goto 1
      else
         if  (line(1:4).eq.'WID1')  hdr_ifmtnum = 1
         if  (line(1:4).eq.'WID2')  hdr_ifmtnum = 2
      endif
      firstline = line
      if  (hdr_debug .gt. 3)  then
         write (*,*)  '-- found hdr line: '
         write (*,'(a)')  firstline
      endif
c
      if  (hdr_ifmtnum .eq. 2)  goto 20
c
c     -- input data are in GSE1.0 format
c
      if  (hdr_debug .gt. 0)  write(*,*)
     &   '-- reading GSE1.0 format data'

c     -- parse first header line of GSE1.0
100   format(i4,i3,3(1x,i2),1x,i3,1x,i8,1x,a6,1x,a8,1x,
     &   a2,1x,f11.7,1x,a6,1x,a4,1x,i1)
      read( line(7:), 100 ) hdr_year, hdr_jday, hdr_hour, hdr_min,
     &   hdr_sec, hdr_msec, hdr_nsamp, hdr_station, hdr_stadescr,
     &   hdr_chan, hdr_smprate, hdr_instr, hdr_ifmtname, hdr_idiff

c     -- read and parse second header line
      read( iin, '(a)' ) line
101   format(f9.6,i1,f7.4,1x,4(f9.4,1x),2(f7.2,1x),f6.1,1x,f6.1)
      read( line, 101 ) hdr_calfac, hdr_calunit, hdr_calper,
     &   hdr_stalat, hdr_stalon, hdr_staelev, hdr_stadepth,
     &   hdr_beamaz, hdr_beamslo, hdr_hang
      if  (hdr_nsamp .gt. c_sigsize)  goto 998

c     -- compute day and month from julian day
cks      if(ifix(float(hdr_year)/4.0)*4 .eq. hdr_year) mnths(2)=29
cks      hdr_month = 0
cks      do i=1,12
cks         hdr_month = hdr_month + mnths(i)
cks         if  (hdr_month .ge. hdr_jday)  goto 60
cks      enddo
cks60    hdr_month = hdr_month - mnths(i)
cks      hdr_day = hdr_jday - hdr_month
cks      hdr_month = i
      call julien( hdr_day, hdr_month, hdr_year, hdr_jday, 0 )

c     -- adjust channel name (insert a 'H' in the middle)
      hdr_chan(3:3) = hdr_chan(2:2)
      hdr_chan(2:2) = 'H'
      call casefold( hdr_chan )

c     -- read away all lines until DAT1
      if  (hdr_debug .gt. 3)  write (*,*) '-- find DAT1'
2     read( iin, '(a)' )  line
      if  (line(1:4) .ne. 'DAT1')  goto 2

c     -- Now read in data according to the format:
      if  (hdr_debug .gt. 2)  write (*,*) '-- read in samples'
      if  (hdr_ifmtname .eq. 'INTV')  then
         if  (hdr_debug .gt. 3)  write (*,*) '-- read INTV data'
         read(iin,*) (iy(i),i=1,hdr_nsamp)
         read(iin,'(4x,6x,i15)') ichecksum
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif
      if(hdr_ifmtname(1:3).eq.'INT'.and.hdr_ifmtname.ne.'INTV')then
         if  (hdr_debug .gt. 3)  write (*,*) '-- read INTx data'
         read(hdr_ifmtname(4:4),*) ii
         read(iin,'(a)') line
         i=(trimlen(line)+ii-1)/ii
         write(fmt,'(''('',i2.2,''i'',i1.1,'')'')') i,ii
         backspace(3)
         read(iin,fmt) (iy(i),i=1,hdr_nsamp)
         read(iin,'(4x,6x,i15)') ichecksum
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif
c
      if(hdr_ifmtname(1:3).eq.'CMP')then
         if  (hdr_debug .gt. 3)  write (*,*) '-- read CMPx data'
         read(hdr_ifmtname(4:4),*) icomp 
         j=0
c        -- loop all data lines
10       continue
            read(iin,'(a)') line
            if(line(1:4).eq.'CHK1') goto 11
            nchar=trimlen(line)
            do i=1,nchar
               j=j+1
               cbuf(j)=line(i:i)
            enddo
         goto 10
11       continue
         read(line(5:),*) ichecksum
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
         nchar=j
         numout=c_sigsize   ! on input, give max. size of array iout (=iy)
         if  (hdr_debug .gt. 3)  write (*,*) '-- decompress', icomp
         if(icomp.eq.6) call DCOMP6(nchar,cbuf,numout,iy,ierror)
         if(icomp.eq.7) call DCOMP7(nchar,cbuf,numout,iy,ierror)
         if(icomp.eq.8) call DCOMP8(nchar,cbuf,numout,iy,ierror)
         if(ierror.eq.-1) write(6,*)'Integer*4 array not large enough !'
         if(numout.ne.hdr_nsamp)then
            write(6,*)'Error in retrieving correct number of samples !'
            write(6,*)'Expected ',hdr_nsamp,', received ',numout
         endif
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif

c     -- remove first or second differences if necessary
      if  (hdr_debug .gt. 3)  write (*,*) '-- remove differences diff:',
     &   hdr_idiff, 'no. samples: ', hdr_nsamp
      do i=1,hdr_idiff
         call REMDIF1(iy,hdr_nsamp)
      enddo
      if  (hdr_debug .gt. 3)  write (*,*) '-- done'
c
      if (hdr_ifmtnum.eq.1) goto 50
      write(6,*) 'There is good news and bad news at this point:'
      write(6,*) 'First the good news: no more CPU time will be used!!!'
      write(6,*) 'and now the bad news: You have screwed up !!!'
      stop
c
c     -- The input data are GSE2.0
c
20    if  (hdr_debug .gt. 0)  write(*,*) '-- reading GSE2.0 format data'

c     -- parse WID2 line
200   format(i4,1x,i2,1x,i2,1x,i2,1x,i2,1x,f6.3,1x,a5,1x,a3,1x,
     &  a4,1x,a3,1x,i8,1x,f11.6,1x,e10.2,1x,f7.3,1x,a6,1x,f5.1,1x,f4.1)
      read( line(6:), 200 )  hdr_year, hdr_month, hdr_day, hdr_hour,
     &   hdr_min, fsec, hdr_station, hdr_chan, hdr_stadescr,
     &   hdr_ifmtname, hdr_nsamp, hdr_smprate, hdr_calfac, hdr_calper,
     &   hdr_instr, hdr_hang, hdr_vang
      hdr_sec = ifix( fsec )
      hdr_msec = nint( (fsec-float(hdr_sec)) * 1000.0 )
      if  (hdr_debug .gt. 3)  write (*,*) '-- got start time: ',
     &   hdr_year, hdr_month, hdr_day, hdr_hour, hdr_min, hdr_sec,
     &   hdr_msec
      if (hdr_nsamp .gt. c_sigsize) goto 998

c     -- compute julian day
cks      if  (ifix(float(hdr_year)/4.0)*4 .eq. hdr_year)  mnths(2)=29
cks      hdr_jday = 0
cks      do i=1,hdr_month-1
cks          hdr_jday = hdr_jday + mnths(i)
cks      enddo
cks      hdr_jday = hdr_jday + hdr_day
      call julien( hdr_day, hdr_month, hdr_year, hdr_jday, 1 )

c     -- read away all lines until DAT2, read possibly existing STA2-line
      if  (hdr_debug .gt. 3)  write (*,*) '-- find DAT2'
22    read( iin, '(a)' )  line
         if  (line(1:4) .eq. 'STA2')  then
            read( line,
     &         '(5x,a9,1x,f9.5,1x,f10.5,1x,a12,1x,f5.3,1x,f5.3)' )
     &         hdr_network, hdr_stalat, hdr_stalon, hdr_coosys,
     &         hdr_staelev, hdr_stadepth
            hdr_staelev = hdr_staelev * 1000.0
            hdr_stadepth = hdr_stadepth * 1000.0
            if  (hdr_debug .gt. 3)  write (*,*) '-- found STA2 ',
     &         hdr_network, hdr_stalat, hdr_stalon, hdr_coosys,
     &         hdr_staelev, hdr_stadepth
         endif
      if  (line(1:4) .ne. 'DAT2')  goto 22
      if  (hdr_debug .gt. 3)  write (*,*) '-- done'

c     -- Now read in data according to the format:
      if  (hdr_debug .gt. 2)   write (*,*) '-- reading samples'
      if  (hdr_ifmtname .eq. 'INT')  then
         if  (hdr_debug .gt. 3)  write (*,*) '-- reading INT data'
         read(iin,*) (iy(i),i=1,hdr_nsamp)
30       read(iin,'(a)') line
         if(line(1:5).eq.'CHK2 ') goto 31
         goto 30
31       read(line(5:),*) ichecksum
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif
c
      if  (hdr_ifmtname(1:2) .eq. 'CM')  then
         read(hdr_ifmtname(3:3),*) icomp 
         if  (hdr_debug .gt. 3)  write (*,*) '-- reading CM', icomp
         j=0
c        -- reading all compressed lines
32       continue
            read(iin,'(a)') line
            if(line(1:5).eq.'CHK2 ') goto 34
            nchar=trimlen(line)
            do i=1,nchar
               j=j+1
               cbuf(j)=line(i:i)
            enddo
         goto 32
  34     continue
         read(line(5:),*) ichecksum
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
         nchar=j
         numout=c_sigsize   ! on input, give max. size of array iout (=iy)
         if  (hdr_debug .gt. 3)  write (*,*) '-- decompress data'
         if(icomp.eq.6) call DCOMP6(nchar,cbuf,numout,iy,ierror)
         if(icomp.eq.7) call DCOMP7(nchar,cbuf,numout,iy,ierror)
         if(icomp.eq.8) call DCOMP8(nchar,cbuf,numout,iy,ierror)
         if(ierror.eq.-1) write(6,*)'Integer*4 array not large enough !'
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
         if(numout.ne.hdr_nsamp)then
            write(6,*)'Error in retrieving correct number of samples !'
            write(6,*)'Expected ',hdr_nsamp,', received ',numout
         endif

c        -- remove first and second differences
         if  (hdr_debug .gt. 3)  write (*,*) '-- remove 2 differences'
         call REMDIF1(iy,hdr_nsamp)
         call REMDIF1(iy,hdr_nsamp)
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif
c
50    continue
      if  (hdr_debug .gt. 3)  write (*,*) '-- check checksums'
      if (hdr_ifmtnum .eq. 1) then
c        -- calculate checksum for GSE1.0 format
         nchecksum=icheck_sum_gse1(iy,hdr_nsamp)
      elseif (hdr_ifmtnum .eq. 2) then
c        -- calculate checksum for GSE2.0 format
         nchecksum=icheck_sum_gse2(iy,hdr_nsamp)
      else
         print *, 'Unknown GSE-Format ',hdr_ifmtnum,'.x'
         stop
      endif
      if(nchecksum.ne.ichecksum)then
         write(6,*)'Error in checksum in the following waveform'
         write(6,'(a)') firstline(1:trimlen(firstline))
         write(6,*)'Read checksum       =',ichecksum
         write(6,*)'Calculated checksum =',nchecksum
         write(6,*)
         ichecksum=nchecksum  ! ... use the correct checksum  !!!
      endif
      if  (hdr_debug .gt. 2)  write (*,*) '-- leaving gsein'
      return
c
 998  print *,' >>>> WARNING: Program dimensions too small for ',
     &    ' the following waveform :'
          print *, line
      goto 1
 999  ierr = 999
      return
      end


c------------------------------------------------------------------------------


      subroutine gseout(iout,cbuf,iy,nchecksum)
c------------------------------------------------------------------------------
c     Input/Output parameters:
c        iout ........ logical unit for output data
c        cbuf ........ character array to store compressed data (see c_bufsize)
c        iy .......... integer array to hold raw waveform data (see c_sigsize)
c        nchecksum ... checksum value for data iy according to hdr_ifmtname
c
c        in common block
c        hdr_ifmtnum . GSE format identifier of input data
c        hdr_nsamp ... number of samples in array iy
c
c        disabled
c        iformat_in
c        nmax
c        format_out .. GSE format identifier for output data (e.g. "CM6")
c        iformat_out . GSE format identifier (ie. =2 for GSE2.0)
c        lin ......... character array to hold header lines
c        ilin ........ number of header lines
c        idiffout .... difference identifier
c------------------------------------------------------------------------------
c
      implicit none

      include 'codeco_common.f'

c     parameters
      integer*4 iout
      character*1 cbuf(1)
      integer*4 iy(1)
      integer*4 nchecksum

c     local variables
c
      integer*4 icomp, i,j, ierror
      integer*4 nchar, ii, ichecksum
      integer*4 trimlen
      integer*4 icheck_sum_gse1,icheck_sum_gse2
      integer*4 n
      real      fsec                ! seconds and milliseconds
      character line*132, fmt*132

c     -- executable code

      if  (hdr_debug .gt. 1)  write (*,*) '-- entering gseout'

      if (hdr_ifmtnum.eq.hdr_ofmtnum) then
          ichecksum=nchecksum
      else
         if (hdr_ofmtnum.eq.2)  then
            if  (hdr_debug .gt. 0)  write (*,*)
     &         '-- writing GSE2.0 output'
c           -- adjust calibration factor to displacement
            if  (hdr_calunit .gt. 0)  then
c              -- divide cal.factor 'hdr_calunit' times by 2*pi/hdr_calper
               hdr_calfac = hdr_calfac / 
     &            (atan(1.0)*8.0/hdr_calper)**hdr_calunit
               hdr_calunit = 0
            endif
c           -- calculate checksum for GSE2.0 format
            ichecksum=icheck_sum_gse2(iy,hdr_nsamp)
         else if  (hdr_ofmtnum .eq. 1)  then
            if  (hdr_debug .gt. 0)  write (*,*)
     &         '-- writing GSE1.0 output'
            ichecksum=icheck_sum_gse1(iy,hdr_nsamp)
            ichecksum=icheck_sum_gse1(iy,hdr_nsamp)   !!! why this ?
         else
            write (*,*) '** gseout: this should not happen'
            write (*,*) '** output format number is ', hdr_ofmtnum
            stop
         endif
      endif

c     -- compute differences if requested
      if  (hdr_debug .gt. 3)  write (*,*) '-- apply differences',
     &   hdr_odiff
      do i=1,hdr_odiff
         call DIF1(iy,hdr_nsamp)
      enddo
      if  (hdr_debug .gt. 3)  write (*,*) '-- done'

c     -- here write out header lines
      if  (hdr_debug .gt. 3)  write (*,*)  '-- write header line(s)'
      if  (hdr_ofmtnum .eq. 1)  then
c        -- first line is straightforward
100      format(a6,i4,i3.3,3(1x,i2.2),1x,i3.3,1x,i8,1x,a6,1x,a8,1x,
     &      a1,a1,1x,f11.7,1x,a6,1x,a4,1x,i1)
         write(iout,100) 'WID1  ', hdr_year, hdr_jday, hdr_hour,
     &      hdr_min, hdr_sec, hdr_msec, hdr_nsamp, hdr_station,
     &      hdr_stadescr, hdr_chan(1:1), hdr_chan(3:3),
     &      hdr_smprate, hdr_instr, hdr_ofmtname, hdr_odiff
c        -- second line's format depends on hdr_calfac
         fmt = '(f9.6,i1,f7.4,1x,4(f9.4,1x),2(f7.2,1x),f6.1,1x,f6.1)'
         n = 6
         if (hdr_calfac .ge. 100.0) n = 9-(log10(hdr_calfac)+3)
         write(fmt(5:5),'(i1)') n
         write(iout,fmt) hdr_calfac, hdr_calunit, hdr_calper,
     &      hdr_stalat, hdr_stalon, hdr_staelev, hdr_stadepth,
     &      hdr_beamaz, hdr_beamslo, hdr_hang
         write( iout, '(a)' )  'DAT1'
      else
         fsec = float(hdr_sec) + float(hdr_msec)/1000.0
200      format(a5,i4,2(1h/,i2.2),1x,2(i2.2,1h:),f6.3,1x,a5,1x,a3,
     &      1x,a4,1x,a3,1x,i8,1x,f11.6,1x,e10.2,1x,f7.3,1x,a6,1x,
     &      f5.1,1x,f4.1)
         write( iout, 200 )  'WID2 ', hdr_year, hdr_month, hdr_day,
     &      hdr_hour, hdr_min, fsec, hdr_station, hdr_chan,
     &      hdr_stadescr, hdr_ofmtname, hdr_nsamp, hdr_smprate,
     &      hdr_calfac, hdr_calper, hdr_instr, hdr_hang, hdr_vang
         fmt = '(a5,a9,1x,f9.5,1x,f10.5,1x,a12,1x,f5.3,1x,f5.3)'
c        -- need to change from f9.5 to f9.4 if hdr_stalat is empty (= -999.0)
         if  (hdr_stalat .le. -100.0)  fmt(14:14) = '4'
         write( iout, fmt )  'STA2 ', hdr_network, hdr_stalat,
     &      hdr_stalon, hdr_coosys, hdr_staelev/1000.0,
     &      hdr_stadepth/1000.0
         write( iout, '(a)' )  'DAT2'
      endif
      if  (hdr_debug .gt. 3)  write (*,*) '-- done'

      if(hdr_ofmtname(1:2).eq.'CM')then
         if (hdr_ofmtnum.eq.1) read(hdr_ofmtname(4:4),*) icomp
         if (hdr_ofmtnum.eq.2) read(hdr_ofmtname(3:3),*) icomp
         if  (hdr_debug .gt. 3)  write (*,*) '-- compress data', icomp
         nchar=c_bufsize ! on input, give max. size of array cbuf
         if(icomp.eq.6) call CMPRS6(hdr_nsamp,iy,nchar,cbuf,ierror)
         if(icomp.eq.7) call CMPRS7(hdr_nsamp,iy,nchar,cbuf,ierror)
         if(icomp.eq.8) call CMPRS8(hdr_nsamp,iy,nchar,cbuf,ierror)
         if  (ierror .eq. -1)  write(*,*)
     &      '** character array not large enough !'
         if  (hdr_debug .gt. 3)  write (*,*) '-- done, found nchar',
     &      nchar
C        TEST FOR MULTIPLE OF 80 CHARACTERS
         if(nchar-((nchar/80)*80).ne.0)then
            write(6,*)  '** not a multiple of 80 characters !'
         endif
         do i=1,nchar/80
            line = ' '
            do j=1,80
               line(j:j)=cbuf(80*(i-1)+j)
            enddo
            if  (hdr_debug .gt. 4) write(*,'(a)') line(1:trimlen(line))
cccc            write(iout,'(a)') line                      ! kradi, 28.11.90
c99 6.6.99/uk  if  (line .ne. ' ') write(iout,'(a)') line(1:trimlen(line))
            if  (line .ne. ' ') write(iout,'(a)') line(1:80)
         enddo
      endif
      if  (hdr_ofmtname(1:3) .eq. 'INT')  then
         if  (hdr_ofmtname(4:4) .eq. 'V' .or. 
     &      hdr_ofmtname(4:4) .eq. ' ')  then
            if  (hdr_debug .gt. 3)  write (*,*)
     &         '-- write uncompressed samples (INT,INTV)', hdr_nsamp
cks            write(iout,*) (iy(i),i=1,hdr_nsamp)
            do  i=1,hdr_nsamp
               write (iout,*) iy(i)
            enddo
         else
             if  (hdr_debug .gt. 3)  write (*,*) '-- write fixed INTx'
             read(hdr_ofmtname(4:4),*) ii
cc             i=(trimlen(line)+ii-1)/ii
             i=(80+ii-1)/ii
             write(fmt,'(''('',i2.2,''i'',i1.1,'')'')') i,ii
             write(iout,fmt) (iy(i),i=1,hdr_nsamp)
         endif
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif

      if  (hdr_debug .gt. 3)  write (*,*) '-- write checksum'
      if (hdr_ofmtnum.eq.1) then
          line='CHK1'
          write(line(10:24),'(i15)') ichecksum
      endif
      if (hdr_ofmtnum.eq.2) then
          line='CHK2'
          write(line(6:13),'(i8)') ichecksum
      endif
      write(iout,'(a)') line(1:trimlen(line))

      if  (hdr_debug .gt. 1)  write (*,*) '-- leaving gseout'
      return
      end


c -----------------------------------------------------------------------------


      subroutine init_hdrvars

c     Initializes header variables in common block

      include 'codeco_common.f'

c     -- leave hdr_debug untouched
      hdr_year = 0
      hdr_month = 0
      hdr_day = 0
      hdr_jday = 0
      hdr_hour = 0
      hdr_min = 0
      hdr_sec = 0
      hdr_msec = 0
      hdr_nsamp = 0
      hdr_ifmtnum = 0
      hdr_ofmtnum = 0
      hdr_idiff = 0
      hdr_odiff = 0
      hdr_calunit = 0
      hdr_smprate = 0.0
      hdr_calfac = 1.0
      hdr_calper = 1.0
      hdr_stalat = -999.0
      hdr_stalon = -999.0
      hdr_staelev = -999.0
      hdr_stadepth = -999.0
      hdr_beamaz = -1.0
      hdr_beamslo = -1.0
      hdr_hang = -1.0
      hdr_vang = -1.0
      hdr_station = ' '
      hdr_stadescr = ' '
      hdr_chan = ' '
      hdr_instr = '_'
      hdr_network = ' '
      hdr_ifmtname = ' '
      hdr_ofmtname = ' '

      return
      end


c -----------------------------------------------------------------------------
 

C     SUBROUTINE SVDRS (A, MDA, M1, N1, B, MDB, NB, S, WORK) 
c
C  SINGULAR VALUE DECOMPOSITION ALSO TREATING RIGHT SIDE VECTOR.
c
c  The original version of this code was developed by
c  Charles L. Lawson and Richard J. Hanson at Jet Propulsion Laboratory
c  1974 SEP 25, and published in the book
c  "SOLVING LEAST SQUARES PROBLEMS", Prentice-HalL, 1974.
c  Revised FEB 1995 to accompany reprinting of the book by SIAM.
C     ------------------------------------------------------------------   
c  This 1995 version differs from the original 1974 version by adding
c  the argument WORK().
c  WORK() provides 2*N1 locations of work space.  Originally S() was
c  required to have 3*N1 elements, of which the last 2*N1 were used for
c  work space.  Now S() only needs N1 elements.
C     ------------------------------------------------------------------
c  This subroutine computes the singular value decomposition of the
c  given M1 x N1 matrix, A, and optionally applys the transformations
c  from the left to the NB column vectors of the M1 x NB matrix B.
c  Either M1 .ge. N1  or  M1 .lt. N1 is permitted.
c
c       The singular value decomposition of A is of the form
c
c                  A  =  U * S * V**t
c
c  where U is M1 x M1 orthogonal, S is M1 x N1 diagonal with the
c  diagonal terms nonnegative and ordered from large to small, and
c  V is N1 x N1 orthogonal.  Note that these matrices also satisfy
c
c                  S = (U**t) * A * V
c
c       The matrix V is returned in the leading N1 rows and
c  columns of the array A(,).
c
c       The singular values, i.e. the diagonal terms of the matrix S,
c  are returned in the array S().  If M1 .lt. N1, positions M1+1
c  through N1 of S() will be set to zero.
c
c       The product matrix  G = U**t * B replaces the given matrix B
c  in the array B(,).
c
c       If the user wishes to obtain a minimum length least squares
c  solution of the linear system
c
c                        A * X ~=~ B
c
c  the solution X can be constructed, following use of this subroutine,
c  by computing the sum for i = 1, ..., R of the outer products
c
c          (Col i of V) * (1/S(i)) * (Row i of G)
c
c  Here R denotes the pseudorank of A which the user may choose
c  in the range 0 through Min(M1, N1) based on the sizes of the
c  singular values.
C     ------------------------------------------------------------------
C                    Subroutine Arguments
c
c  A(,)     (In/Out)  On input contains the M1 x N1 matrix A.
c           On output contains the N1 x N1 matrix V.
c
c  LDA      (In)  First dimensioning parameter for A(,).
c           Require LDA .ge. Max(M1, N1).
c
c  M1       (In)  No. of rows of matrices A, B, and G.
c           Require M1 > 0.
c
c  N1       (In)  No. of cols of matrix A, No. of rows and cols of
c           matrix V.  Permit M1 .ge. N1  or  M1 .lt. N1.
c           Require N1 > 0.
c
c  B(,)     (In/Out)  If NB .gt. 0 this array must contain an
c           M1 x NB matrix on input and will contain the
c           M1 x NB product matrix, G = (U**t) * B on output.
c
c  LDB      (In)  First dimensioning parameter for B(,).
c           Require LDB .ge. M1.
c
c  NB       (In)  No. of cols in the matrices B and G.
c           Require NB .ge. 0.
c
c  S()      (Out)  Must be dimensioned at least N1.  On return will
c           contain the singular values of A, with the ordering
c                S(1) .ge. S(2) .ge. ... .ge. S(N1) .ge. 0.
c           If M1 .lt. N1 the singular values indexed from M1+1
c           through N1 will be zero.
c           If the given integer arguments are not consistent, this
c           subroutine will return immediately, setting S(1) = -1.0.
c
c  WORK()  (Scratch)  Work space of total size at least 2*N1.
c           Locations 1 thru N1 will hold the off-diagonal terms of
c           the bidiagonal matrix for subroutine QRBD.  Locations N1+1
c           thru 2*N1 will save info from one call to the next of
c           H12.
c     ------------------------------------------------------------------
C  This code gives special treatment to rows and columns that are
c  entirely zero.  This causes certain zero sing. vals. to appear as
c  exact zeros rather than as about MACHEPS times the largest sing. val.
c  It similarly cleans up the associated columns of U and V.  
c
c  METHOD..  
c   1. EXCHANGE COLS OF A TO PACK NONZERO COLS TO THE LEFT.  
c      SET N = NO. OF NONZERO COLS.  
c      USE LOCATIONS A(1,N1),A(1,N1-1),...,A(1,N+1) TO RECORD THE    
c      COL PERMUTATIONS. 
c   2. EXCHANGE ROWS OF A TO PACK NONZERO ROWS TO THE TOP.   
c      QUIT PACKING IF FIND N NONZERO ROWS.  MAKE SAME ROW EXCHANGES 
c      IN B.  SET M SO THAT ALL NONZERO ROWS OF THE PERMUTED A   
c      ARE IN FIRST M ROWS.  IF M .LE. N THEN ALL M ROWS ARE 
c      NONZERO.  IF M .GT. N THEN      THE FIRST N ROWS ARE KNOWN    
c      TO BE NONZERO,AND ROWS N+1 THRU M MAY BE ZERO OR NONZERO.     
c   3. APPLY ORIGINAL ALGORITHM TO THE M BY N PROBLEM.   
c   4. MOVE PERMUTATION RECORD FROM A(,) TO S(I),I=N+1,...,N1.   
c   5. BUILD V UP FROM  N BY N  TO  N1 BY N1  BY PLACING ONES ON     
c      THE DIAGONAL AND ZEROS ELSEWHERE.  THIS IS ONLY PARTLY DONE   
c      EXPLICITLY.  IT IS COMPLETED DURING STEP 6.   
c   6. EXCHANGE ROWS OF V TO COMPENSATE FOR COL EXCHANGES OF STEP 2. 
c   7. PLACE ZEROS IN  S(I),I=N+1,N1  TO REPRESENT ZERO SING VALS.   
c     ------------------------------------------------------------------
      subroutine SVDRS (A, MDA, M1, N1, B, MDB, NB, S, WORK) 
      integer I, IPASS, J, K, L, M, MDA, MDB, M1
      integer N, NB, N1, NP1, NS, NSP1
c     double precision A(MDA,N1),B(MDB,NB), S(N1)
      double precision A(MDA, *),B(MDB, *), S( *)
      double precision ONE, T, WORK(N1,2), ZERO
      parameter(ONE = 1.0d0, ZERO = 0.0d0)
c     -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C                             BEGIN.. SPECIAL FOR ZERO ROWS AND COLS.   
C   
C                             PACK THE NONZERO COLS TO THE LEFT 
C   
      N=N1  
      IF (N.LE.0.OR.M1.LE.0) RETURN 
      J=N   
   10 CONTINUE  
         DO 20 I=1,M1  
            IF (A(I,J) .ne. ZERO) go to 50
   20    CONTINUE  
C   
C           COL J  IS ZERO. EXCHANGE IT WITH COL N.   
C   
         IF (J .ne. N) then
            DO 30 I=1,M1  
   30       A(I,J)=A(I,N) 
         endif
         A(1,N)=J  
         N=N-1 
   50    CONTINUE  
         J=J-1 
      IF (J.GE.1) GO TO 10  
C                             IF N=0 THEN A IS ENTIRELY ZERO AND SVD    
C                             COMPUTATION CAN BE SKIPPED    
      NS=0  
      IF (N.EQ.0) GO TO 240 
C                             PACK NONZERO ROWS TO THE TOP  
C                             QUIT PACKING IF FIND N NONZERO ROWS   
      I=1   
      M=M1  
   60 IF (I.GT.N.OR.I.GE.M) GO TO 150   
      IF (A(I,I)) 90,70,90  
   70     DO 80 J=1,N   
          IF (A(I,J)) 90,80,90  
   80     CONTINUE  
      GO TO 100 
   90 I=I+1 
      GO TO 60  
C                             ROW I IS ZERO     
C                             EXCHANGE ROWS I AND M 
  100 IF(NB.LE.0) GO TO 115 
          DO 110 J=1,NB 
          T=B(I,J)  
          B(I,J)=B(M,J) 
  110     B(M,J)=T  
  115     DO 120 J=1,N  
  120     A(I,J)=A(M,J) 
      IF (M.GT.N) GO TO 140 
          DO 130 J=1,N  
  130     A(M,J)=ZERO   
  140 CONTINUE  
C                             EXCHANGE IS FINISHED  
      M=M-1 
      GO TO 60  
C   
  150 CONTINUE  
C                             END.. SPECIAL FOR ZERO ROWS AND COLUMNS   
C                             BEGIN.. SVD ALGORITHM 
C     METHOD..  
C     (1)     REDUCE THE MATRIX TO UPPER BIDIAGONAL FORM WITH   
C     HOUSEHOLDER TRANSFORMATIONS.  
C          H(N)...H(1)AQ(1)...Q(N-2) = (D**T,0)**T  
C     WHERE D IS UPPER BIDIAGONAL.  
C   
C     (2)     APPLY H(N)...H(1) TO B.  HERE H(N)...H(1)*B REPLACES B    
C     IN STORAGE.   
C   
C     (3)     THE MATRIX PRODUCT W= Q(1)...Q(N-2) OVERWRITES THE FIRST  
C     N ROWS OF A IN STORAGE.   
C   
C     (4)     AN SVD FOR D IS COMPUTED.  HERE K ROTATIONS RI AND PI ARE 
C     COMPUTED SO THAT  
C          RK...R1*D*P1**(T)...PK**(T) = DIAG(S1,...,SM)    
C     TO WORKING ACCURACY.  THE SI ARE NONNEGATIVE AND NONINCREASING.   
C     HERE RK...R1*B OVERWRITES B IN STORAGE WHILE  
C     A*P1**(T)...PK**(T)  OVERWRITES A IN STORAGE. 
C   
C     (5)     IT FOLLOWS THAT,WITH THE PROPER DEFINITIONS,  
C     U**(T)*B OVERWRITES B, WHILE V OVERWRITES THE FIRST N ROW AND     
C     COLUMNS OF A.     
C   
      L=min(M,N)   
C             THE FOLLOWING LOOP REDUCES A TO UPPER BIDIAGONAL AND  
C             ALSO APPLIES THE PREMULTIPLYING TRANSFORMATIONS TO B.     
C   
          DO 170 J=1,L  
          IF (J.GE.M) GO TO 160     
          CALL H12 (1,J,J+1,M,A(1,J),1,T,A(1,J+1),1,MDA,N-J)
          CALL H12 (2,J,J+1,M,A(1,J),1,T,B,1,MDB,NB)
  160     IF (J.GE.N-1) GO TO 170   
          CALL H12 (1,J+1,J+2,N,A(J,1),MDA,work(J,2),A(J+1,1),MDA,1,M-J)   
  170     CONTINUE  
C   
C     COPY THE BIDIAGONAL MATRIX INTO S() and WORK() FOR QRBD.   
C 1986 Jan 8. C. L. Lawson. Changed N to L in following 2 statements.
      IF (L.EQ.1) GO TO 190 
          DO 180 J=2,L  
          S(J)=A(J,J) 
  180     WORK(J,1)=A(J-1,J)   
  190 S(1)=A(1,1)     
C   
      NS=N  
      IF (M.GE.N) GO TO 200 
      NS=M+1
      S(NS)=ZERO  
      WORK(NS,1)=A(M,M+1)  
  200 CONTINUE  
C   
C     CONSTRUCT THE EXPLICIT N BY N PRODUCT MATRIX, W=Q1*Q2*...*QL*I    
C     IN THE ARRAY A(). 
C   
          DO 230 K=1,N  
          I=N+1-K   
          IF (I .GT. min(M,N-2)) GO TO 210     
          CALL H12 (2,I+1,I+2,N,A(I,1),MDA,WORK(I,2),A(1,I+1),1,MDA,N-I)   
  210         DO 220 J=1,N  
  220         A(I,J)=ZERO   
  230     A(I,I)=ONE    
C   
C          COMPUTE THE SVD OF THE BIDIAGONAL MATRIX 
C   
      CALL QRBD (IPASS,S(1),WORK(1,1),NS,A,MDA,N,B,MDB,NB)   
C   
      if(IPASS .eq. 2) then
         write (*,'(/a)')
     *      ' FULL ACCURACY NOT ATTAINED IN BIDIAGONAL SVD'
      endif

  240 CONTINUE  
      IF (NS.GE.N) GO TO 260
      NSP1=NS+1 
          DO 250 J=NSP1,N   
  250     S(J)=ZERO   
  260 CONTINUE  
      IF (N.EQ.N1) RETURN   
      NP1=N+1   
C                                  MOVE RECORD OF PERMUTATIONS  
C                                  AND STORE ZEROS  
          DO 280 J=NP1,N1   
          S(J)=A(1,J) 
              DO 270 I=1,N  
  270         A(I,J)=ZERO   
  280     CONTINUE  
C                             PERMUTE ROWS AND SET ZERO SINGULAR VALUES.
          DO 300 K=NP1,N1   
          I=S(K)  
          S(K)=ZERO   
              DO 290 J=1,N1 
              A(K,J)=A(I,J) 
  290         A(I,J)=ZERO   
          A(I,K)=ONE    
  300     CONTINUE  
C                             END.. SPECIAL FOR ZERO ROWS AND COLUMNS   
      RETURN
      END   

      program volpis

*
*               ^ ^   VOLPIS
*              <* *> -------~~~*
*                -      |  |
*              !   !   !  !
*
****************************************************************
* THIS CODE HAS BEEN SUBMITTED TO COMPUTERS AND GEOSCIENCES
* ON JUNE 29TH, 2006, TOGETHER WITH THE RESEARCH PAPER: 
* "A FREQUENCY DOMAIN INVERSION CODE TO RETRIEVE TIME-DEPENDENT
* PARAMETERS OF LONG PERIOD VOLCANIC EVENTS" 
* BY S.CESCA AND T.DAHM
****************************************************************
* S. Cesca, Univ. Hamburg, December 2005
* S. Cesca, version 4, UHH, March 2006
* S. Cesca, version 6, UHH, May 2006
* S. Cesca, version 8, UHH, June 2006
* S. Cesca, version 9, UHH, December 2006
*
* 1. Comments on VOLPIS original code
*
* VOLPIS, VOlcanic Long Period Inversion for the Source
* is an inversion program, which main structure is based on 
* mtinvers code (Dahm).
* It uses observed displacements and synthetic Green Function
* to determinate source mechanism of LP event as the sum
* of a moment tensor component (MT) and a single force (SF).
* No previous assumption are done on time history of this
* source components, except that this has the same time length 
* then used traces.
* Inversion can be done both in time domain, using the approach
* formulated by Ohminato et al. (1998) and Chouet et al. (2003),
* or in frequency domain. Note that this last approach differs
* from amplitude spectra moment tensor inversion technique, as
* in this code it is fit the full spectra (amplitude and phase).
*
* 2. Comments on later versions 
* 
* Version 4 (UHH, Feb 2006)
* Version 4 include determination of solution including 
* 2 possible constrains on the source history: common
* source history for all source components, and common MT +
* common SF.
* These are obtained using as input the unconstrained source
* inverted by VOLPIS (as done by the original version), and using
* singular value decomposition approach (Vasco,  1989, BSSA; 
* Numerical recipes in Fortran)
* Output include fits relative to constrained source.
*
* Version 6-7
* Version 6-7 include the possibility of forward modelling
* some new files must be included:
*   - volpis6.input, is similar to older version volpis.input
*     but has an extra last line.
*     the line as the following format
*        ex. 1, 0, 45, 60, 3, 6
*        1: run forward modeling (other values run the inversion)
*(VERS7) 0: indicates no stf convolution (other numbers represent
*                           length in seconds of Fz. Brustle-Muller)
*        45: strike angle of the crack (in degree)
*        60: dip angle of the crack (in degree)
*        3: mu       
*        6: lambda
*
* Version 8, May-June 2006
* Version 8 is summaryzing all changes introduced in the previous
* versions, including some new features:
*  - improvement in the management of SAC input files
*  - generalization of the data windows to include also North
*    and East direction. This is helpful to handle the problem
*    of the inversion for different source locations, as rotation
*    of the axis does not have to be considered in the preprocessing.
*  - added file volpis.erg to check correct response of the code
*  - generalization of forward modeling, including 3 possible cases:
*    generic source (0), pure crack (1), pure DC (2).
*  - improvement of the code script by adding subroutines
*    CALMIS (calculate misfit, L2 norm) and 
*    SFORW (solving forward problem, calculating synthetic 
*    seismograms for given MT and GF) 
* Version 8 is described in the paper Cesca and Dahm (2006) which 
* is under preparation and will be soon submitted to a scientific
* journal.
* Version 8 is accompanied by text files describing input/output 
* formats and how the code works.
*                          Simone Cesca, UHH, June 2006 
*
* Version 9
* This version of volpis code include an estimation of errors
* for the unconstrained solution.
* Errors traces are saved in files named:
*         emt*.dat, esf*.dat (error)
*         zmt*.dat, zsf*.dat (unconstrained solution + error)
*         ymt*.dat, ysf*.dat (unconstrained solution - error) 
*
* Simone Cesca, UHH, November/December 2006
*
*
*
* 3. I/O Files (updated for version 4)
*
* Input files
* volpis.input : inversion parameters 
* retard.dat   : traces parameters
* displ.c.n    : observed displacements, coordinate c station n
* MTx.c.n      : Green functions related to MT components
* SFx.c.n      : Green functions related to SF components
*
* Output files
* result.fit   : fits of the inversions
*                  line 1: fit of unconstrained source (case 1)
*                  line 2: fit of common history source (case 2)
*                  line 3: fit of common MT + common SF (case 3)
* dispi*       : filtered displacements (case 1) 
* synti*       : filtered synthetics (case 1)
* dispf*       : filtered displacements (case 2) 
* synth*       : filtered synthetics (case 2)
* dispc*       : filtered displacements (case 3) 
* syntc*       : filtered synthetics (case 3)
* imt*.dat     : mt(t) source solution (case 1)
* isf*.dat     : sf(t) source solution (case 1)
* mmt*.dat     : mt(t) source solution (case 2)
* fsf*.dat     : sf(t) source solution (case 2)
* cmt*.dat     : mt(t) source solution (case 3)
* csf*.dat     : sf(t) source solution (case 3)
* volpis.erg
*
*********************************************************************************
*
* Some comments on the version of the original code are below the text
*********************************************************************************

********************************************************************************
*     0. DECLARATIVE
********************************************************************************

      include 'volpis.inc'
      include 'codeco_common.f'

      ! --------- other local parameter ------------
      integer*4 iballa(wmaxIBALLA)
      character*1 cbuf(c_bufsize),simrisp
      integer*4 nchecksum,ierr
      integer i4,i5,i6
      integer igsein,igseout ! (1) output waveforms in gse2, else in 13bit ascii
      integer ngridmod
      real    xxx(wmax)

      !---------------------------------------------
      if (c_sigsize.ne.wmaxIBALLA) then
       write(*,*)"c_sigsize.ne.wmaxIBALLA"
       write(*,*)"change parameter in codeco_common.f or mtinvers.inc"
       stop
      end if
     
      igsein  = 0
      igseout = 0
      pi = 4.*atan(1.)
      rad = 180./pi
      ci = cmplx(0.,1.)
      iadd = 0    ! Daten werden um 0 Punkte verlaengert
      iadd = 20    ! Daten werden um 20 Punkte verlaengert



********************************************************************************
*     MAIN PROGRAM
********************************************************************************

********************************************************************************
*     1. READ PARAMETER FROM PROMPT OR USING VOLPIS.INPUT
********************************************************************************
      ! control output file
      open(unit=40,file='volpis.erg')

      ! plot VOLPIS drawing
      call introvolp      

      !-------------------------------------------
      ! name of control file
      !-------------------------------------------
      write(*,*)'Step 1: Reading volpis6.input input file'
      write(40,*)'Step 1: Reading volpis6.input input file'
c      write(*,*)'Name des Steuerungsfiles (retard.dat)'
      read(*,*)cinput

      !-------------------------------------------
      !             inversion mode               
      !isampf : root of 2, idicates number of frequency samples for FFT
      !tap :  Taper on time window in percentage (-0.25 < tap <0.25),
      !       negative values enlarge chosen window
      !iscal: 0 no scaling, 1 scaling proportional to r
      !igame = 0: 6 indep MT 
      !        1: Single Force
      !        2: SF + MT
      !ifreq = 0: time domain inversion 
      !        1: frequency domain inversion 
      !--------------------------------------------
c      write(*,*)'npts (isampf) Potenz 2,',
c     & ' Taper-length (-0.25 < tap < 0.25)',
c     & ' lopass fcu, fc',' iscal',' igame',' ifr'
      read(*,*)isampf,tap,fcu,fc,iscal,igame,ifr
      write(40,*)'isampf ',isampf
      write(40,*)'tap    ',tap
      write(40,*)'fcu    ',fcu
      write(40,*)'fc     ',fc
      write(40,*)'iscal  ',iscal
      write(40,*)'fgame  ',igame
      write(40,*)'ifr    ',ifr
      read(*,*)eta,mu,qp,qs
      
      wfikt = 0.0                ! must be zero for seismic sensors

      if(tap.lt.-0.25)tap = -0.25
      if(tap.gt.+0.25)tap = +0.25
      fa = log(real(isampf))/log(2.)
      write(40,*)'isampf=',isampf,' power',fa
      if(fa-int(fa).gt.0.000001)then
       write(*,*)' ERROR: isampf must be power of 2'
       write(40,*)' ERROR: isampf must be power of 2'
       stop
      end if
      if(real(isampf).le.1.6*isamp(1))then   ! not used anymore, f.k. 3.1.01
       write(*,*)'ERROR: isampf too small, or isamp too large'
       write(40,*)'ERROR: isampf too small, or isamp too large'
       stop
      end if
      lxx=isampf/2+1
      if(fc.le.0)then
       write(*,*)' ERROR: fc must be > 0 '
       write(40,*)' ERROR: fc must be > 0 '    
       stop
      end if

      !--------------------------------------------
      ! input output format
      ! igsein,igseout: 0=13bit ascii format,
      !                 1=gse format, 
      !                 2=sac-binary format
      !--------------------------------------------

      write(*,*)'igsein,igseout'
      read(*,*)igsein,igseout
      write(40,*)'I-mode ',igsein
      write(40,*)'O-mode ',igseout


      read(*,*)v6i,v6istf,v6fmod
      if (v6i.eq.1) then
       write(*,*)'Forward mode chosen!'     
       write(40,*)'Forward mode, parameters:'
       if (v6istf.eq.0) then
        write(40,*)'STF type : none, already included in GF'
       else
        write(40,*)'STF type :      Brustle-Muller'
        write(40,*)'STF length :    ',v6istf
       end if
       if (v6fmod.eq.0) then
        write(*,*)'Moment tensor : Generic Source'
        write(40,*)'Moment tensor : Generic Source'
	read(*,*)v8m(1),v8m(2),v8m(3),v8m(4),v8m(5),v8m(6)
	read(*,*)v6f1,v6f2,v6f3	
	write(40,*)'          M11 : ',v8m(1)
	write(40,*)'          M12 : ',v8m(2)
	write(40,*)'          M22 : ',v8m(3)
	write(40,*)'          M13 : ',v8m(4)
	write(40,*)'          M23 : ',v8m(5)
	write(40,*)'          M33 : ',v8m(6)
	write(40,*)'          F1  : ',v6f1
	write(40,*)'          F2  : ',v6f2
	write(40,*)'          F3  : ',v6f3
       else if (v6fmod.eq.1) then
        write(*,*)'Moment tensor : Pure crack'
        write(40,*)'Moment tensor : Pure crack'
        read(*,*)v6str,v6dip,v6mu,v6lam            
	write(40,*)'       Strike : ',v6str
	write(40,*)'       Dip    : ',v6dip
	write(40,*)'       Mu     : ',v6mu
	write(40,*)'       Lambda : ',v6lam
       else if (v6fmod.eq.2) then
        write(*,*)'Moment tensor : Pure DC'
        write(40,*)'Moment tensor : Pure DC'
        read(*,*)v6str,v6dip,v6rak            
	write(40,*)'       Strike : ',v6str
	write(40,*)'       Dip    : ',v6dip
	write(40,*)'       Rake   : ',v6rak
       else
        write(*,*)'ERROR: Source type, incorrect input'
        write(40,*)'ERROR: Source type, incorrect input'
	stop
       end if 
      else 
       write(*,*)'Inverse mode'
       if (v6istf.eq.0) then
        write(*,*)'STF type : none, already included in GF'
       else
        write(*,*)'STF type :      Brustle-Muller'
        write(*,*)'STF length :    ',v6istf
       end if
      end if
      

c     FORWARD MODELING
c     setting source term configuration
c      
      if (v6i.eq.1) then
c     Calculating moment tensor components

      if (v6fmod.eq.0) then
      ! case of generic MT

       xm1d(1,1)=v8m(1)
       xm1d(1,2)=v8m(2)
       xm1d(2,2)=v8m(3)
       xm1d(1,3)=v8m(4)
       xm1d(2,3)=v8m(5)
       xm1d(3,3)=v8m(6)        
       xf1d(1)=v6f1
       xf1d(2)=v6f2
       xf1d(3)=v6f3  

      else if (v6fmod.eq.1) then
      ! case of pure crack

      !original principal axis tensor
      !  lambda     0        0
      !    0     lambda      0
      !    0        0    lambda+2mu
      scalf=(3*v6lam)+(2*v6mu)
      xm0d(1,1) = v6lam/scalf
      xm0d(1,2) = 0.d0
      xm0d(2,1) = 0.d0 
      xm0d(1,3) = 0.d0
      xm0d(3,1) = 0.d0
      xm0d(2,2) = v6lam/scalf
      xm0d(2,3) = 0.d0
      xm0d(3,2) = 0.d0
      xm0d(3,3) = (v6lam+(2*v6mu))/scalf

      !Euler matrix
      
      do i=1,3
       do j=1,3
        rza(i,j)=0.d0
	rxb(i,j)=0.d0
	rzg(i,j)=0.d0
       end do
      end do

      v6str=v6str*PI/180
      v6dip=v6dip*PI/180
      rza(1,1)=dcos(v6str)
      rza(1,2)=-dsin(v6str)
      rza(2,1)=dsin(v6str)
      rza(2,2)=dcos(v6str)
      rza(3,3)=1.d0
      rxb(1,1)=1.d0
      rxb(2,2)=dcos(v6dip)
      rxb(2,3)=-dsin(v6dip)
      rxb(3,2)=dsin(v6dip)
      rxb(3,3)=dcos(v6dip)
   
      call matmul1(3,3,3,rza,3,rxb,3,rhilf,3)
      
      do k=1,3
       do m=1,3
        xm1d(k,m)=0.d0
	do i=1,3
	 do j=1,3
          xm1d(k,m)=xm1d(k,m)+xm0d(i,j)*rhilf(k,i)*rhilf(m,j) 
	 end do
	end do
       end do
      end do
      xf1d(1)=0.d0
      xf1d(2)=0.d0
      xf1d(3)=0.d0  

      else if (v6fmod.eq.2) then
      ! case of pure double couple
      ! originally coded in mtdekomp.f, T. Dahm

       v6str = pi*v6str/180.
       v6dip = pi*v6dip/180.
       v6rak = pi*v6rak/180.

       xm0d(1,1) = 1.d0
       xm0d(1,2) = 0.d0
       xm0d(2,1) = xm0d(1,2) 
       xm0d(1,3) = 0.d0
       xm0d(3,1) = xm0d(1,3)
       xm0d(2,2) = 0.d0
       xm0d(2,3) = 0.d0
       xm0d(3,2) = xm0d(2,3)
       xm0d(3,3) = -1.d0

c      Euler Matrix
       do i=1,3
        do j=1,3
         rza(i,j) = 0.d0
         rxb(i,j) = 0.d0
         rzg(i,j) = 0.d0
         ry45(i,j) = 0.d0
        end do
       end do

       rza(1,1) = dcos(v6str)
       rza(1,2) = -dsin(v6str)
       rza(2,1) = +dsin(v6str)
       rza(2,2) = dcos(v6str)
       rza(3,3) = 1.d0
       rxb(1,1) = 1.d0
       rxb(2,2) = dcos(v6dip)
       rxb(2,3) = -dsin(v6dip)
       rxb(3,2) = +dsin(v6dip)
       rxb(3,3) = dcos(v6dip)
       rzg(1,1) = dcos(v6rak)
       rzg(1,2) = +dsin(v6rak)
       rzg(2,1) = -dsin(v6rak)
       rzg(2,2) = dcos(v6rak)
       rzg(3,3) = 1.d0
       phi = pi*45.d0/180.
       ry45(1,1) = dcos(phi)
       ry45(1,3) = +dsin(phi)
       ry45(2,2) = 1.d0
       ry45(3,1) = -dsin(phi)
       ry45(3,3) = dcos(phi)

       call matmul1(3,3,3,rza,3,rxb,3,rhilf,3)
       call matmul1(3,3,3,rhilf,3,rzg,3,rbet,3)
       do k=1,3
        do m=1,3
         rhilf(k,m) = rbet(k,m)
        end do
       end do

       call matmul1(3,3,3,rhilf,3,ry45,3,rbet,3)

       do k=1,3
        do m=1,3
         xm1d(k,m) = 0.d0
         do i=1,3
          do j=1,3
           xm1d(k,m) = xm1d(k,m) + xm0d(i,j)*rbet(k,i)*rbet(m,j)
          end do
	 end do
	end do
       end do
      xf1d(1)=0.d0
      xf1d(2)=0.d0
      xf1d(3)=0.d0  
      
      else
       write(*,*)'ERROR: incorrect source type'
       write(40,*)'ERROR: incorrect source type'
       stop
      end if

      write(*,*)'M11 ',xm1d(1,1)
      write(*,*)'M12 ',xm1d(1,2),xm1d(2,1)
      write(*,*)'M13 ',xm1d(1,3),xm1d(3,1)
      write(*,*)'M22 ',xm1d(2,2)
      write(*,*)'M23 ',xm1d(2,3),xm1d(3,2)
      write(*,*)'M33 ',xm1d(3,3)
      write(*,*)'F1  ',xf1d(1)
      write(*,*)'M2  ',xf1d(2)
      write(*,*)'M3  ',xf1d(3)
      write(40,*)'M11 ',xm1d(1,1)
      write(40,*)'M12 ',xm1d(1,2),xm1d(2,1)
      write(40,*)'M13 ',xm1d(1,3),xm1d(3,1)
      write(40,*)'M22 ',xm1d(2,2)
      write(40,*)'M23 ',xm1d(2,3),xm1d(3,2)
      write(40,*)'M33 ',xm1d(3,3)
      write(40,*)'F1  ',xf1d(1)
      write(40,*)'M2  ',xf1d(2)
      write(40,*)'M3  ',xf1d(3)
      
      
      end if

********************************************************************************
*     2. READ CONTROL FILE RETARD.DAT 
********************************************************************************

      write(*,*)'Step 2: Reading retard.dat control file'
      write(40,*)'Step 2: Reading retard.dat control file'
      open(2,file=cinput)
      idummy = isamp(1)
      call comment(2)
      read(2,'(a25)')cdir
      call searchbl1(cdir,26,ibl)
      j=0
      nstatc(1)=0
      nstatc(2)=0
      nstatc(3)=0
      nstatc(4)=0
      nstatc(5)=0
      nstatc(6)=0
      nstatc(7)=0
      nstatc(8)=0
      
1     j=j+1
      call comment(2)
      read(2,123,end=2)
     &  comp(j),istat(j),cphas(j),vel(j),iretard(j),
     &  iretardg(j),toff(j),azi(j),isamp(j),wt(j)
      write(*,123)
     &  comp(j),istat(j),cphas(j),vel(j),iretard(j),
     &  iretardg(j),toff(j),azi(j),isamp(j),wt(j)
123   format(a1,1x,i3,1x,a8,1x,f7.3,1x,2(i5,1x),2(f8.3,1x),i3,1x,f6.3)
       if(isamp(j).le.0)isamp(j)=idummy

       ifreq(j)=ifr

       toff(j) = toff(j)/rad
       dazi = azi(j)/rad

       sa(j,1) = dsin(toff(j))
       sa(j,2) = 0.
       sa(j,3) = dcos(toff(j))

        vel(j) = vel(j)*1000.
        if(comp(j).eq.'r' .or. comp(j).eq.'R')then
         nstatc(1)=nstatc(1)+1
         ikomp(j)=1
         comp(j)='r'
        else if(comp(j).eq.'z' .or. comp(j).eq.'Z')then
         nstatc(2)=nstatc(2)+1
         ikomp(j)=2
         comp(j)='z'
        else if(comp(j).eq.'t' .or. comp(j).eq.'T')then
         nstatc(3)=nstatc(3)+1
         ikomp(j)=3
         comp(j)='t'
	else if (comp(j).eq.'n' .or. comp(j).eq.'N')then
         nstatc(7)=nstatc(7)+1
         ikomp(j)=7
         comp(j)='n'
        else if(comp(j).eq.'e' .or. comp(j).eq.'E')then
         nstatc(8)=nstatc(8)+1
         ikomp(j)=8
         comp(j)='e'
	else
         write(*,*)' component must be r, t, z, n or e '
         stop 
        end if

       ! changing window length depending on tap
       if(tap.lt.0)then
        isamp(j) = int( 1.0*isamp(j) / (1.+2.0*tap) )
        iretard(j) = iretard(j) + int(isamp(j)*tap) 
        iretardg(j) = iretardg(j) + int(isamp(j)*tap) 
c        write(*,*)iretard(j),iretardg(j)
       end if

       ! ------- ein paar tests -----------
       lx=isampf

       if(real(lx).le.1.0*isamp(j))then
        write(*,*)'in retard.dat: j=',j,' phas=',cphas(j)
        write(*,*)'isampf too small, or isamp too large'
        write(40,*)'in retard.dat: j=',j,' phas=',cphas(j)
        write(40,*)'isampf too small, or isamp too large'
        stop
       end if
       if(istat(j).gt.999)then
        write(*,*)'istat(j).gt.999, j=',j
        write(40,*)'istat(j).gt.999, j=',j
        stop
       end if

       go to 1

2     close(2)

      nstat = j-1
      if(nstat.gt.nmax)then
       write(*,*)'nstat.gt.nmax'
       write(40,*)'nstat.gt.nmax'
       stop
      end if
      if(tap.lt.0.0)tap = -tap      ! jetzt gilt 0 < tap < 0.25

      iwl=isamp(1)

********************************************************************************
*     3. READ GROUND DISPLACEMENT DATA, PROCESSING AND WRITE INTO DISPI.*
********************************************************************************

      write(*,*)'Step 3: Reading displ.* data files'    
      write(40,*)'Step 3: Reading displ.* data files'         
      
      if(igseout.eq.1)then
       cfil0(1)= 'dispf.r.gse'
       cfil0(2)= 'dispf.z.gse'
       cfil0(3)= 'dispf.t.gse'
       cfil0(7)= 'dispf.n.gse'
       cfil0(8)= 'dispf.e.gse'
      else
       cfil0(1)= 'dispf.r'
       cfil0(2)= 'dispf.z'
       cfil0(3)= 'dispf.t'
       cfil0(7)= 'dispf.z'
       cfil0(8)= 'dispf.t'     
      end if
      ifil(1) = 31
      ifil(2) = 32
      ifil(3) = 33
      ifil(7) = 37
      ifil(5) = 38
      do i=1,3
       if(nstatc(i).gt.0)open(ifil(i),file=cfil0(i))
      end do
      do i=7,8
       if(nstatc(i).gt.0)open(ifil(i),file=cfil0(i))
      end do
      ione = -1
      
      do i=1,nstat   !...loop over stations as given in retard.dat

        if(istat(i).lt.10)then
         write(char3,'(a1,i1)')'.',istat(i)
        else if(istat(i).lt.100)then
         write(char3,'(a1,i2)')'.',istat(i)
        else
         write(char3,'(a1,i3)')'.',istat(i)
        end if
        cfil(i) = cdir(1:ibl)//'displ.'//comp(i)//char3

        if(igsein.eq.0)then   ! 13 bit ascii format
         open(1,file=cfil(i))
         read(1,'(a1)')cdummy
         read(1,110)nlay,mdeck,iso,idummy
         do k=1,nlay
          read(1,'(5f10.4)')x1,x2,(nv(j),j=1,3)
         end do
         read(1,150) nstat1
         if(nstat1.ne.1)then
          write(*,*)'nstat1.ne.1 in ',cfil(i)
          write(40,*)'nstat1.ne.1 in ',cfil(i)
          stop
         end if
         read(1,160)x1
         read(1,170)dtr
        else if(igsein.eq.1) then
         write(*,*)'input in gse2 not yet implemented'
         write(40,*)'input in gse2 not yet implemented'
         stop
        else                  ! sac binary input


          !call rsac1(cfil(i),xxx,lx,abal,dtr,wmaxIBALLA,ierr)
          call rsac1(cfil(i),xxx,lx,abal,dtr,wmax,ierr)
          if (ierr.gt.0) then
           write(*,"('reading error , ierr= ',i4)") ierr
           write(40,"('reading error , ierr= ',i4)") ierr
           write(40,*)'lx  = ',lx
           write(40,*)'dtr = ',dtr
           write(40,*)'abal= ',abal
           if(ierr.eq.108) write(*,*)'file ',cfil(i),' not existing'
           ! 801 = 'file not evenly spaced'
           ! 803 = 'only idim points read'
           ! call getfhv('E',x1,ierr)
           ! write(*,"('ending value of indep. variable, e=',f15.3)")x1
           stop
          else if (ierr.lt.0) then
           write(40,*)'too many points, file ',cfil(i),' cutted',ierr
          end if
           write(40,*)'station i=',i,' read C'
          call getfhv('DIST',x1,ierr)
           re(i) = x1
          call getfhv('AZ',x1,ierr)
          az = x1
          call getfhv ('USER1',x1,ierr)
           komp = int(x1)
          call getkhv('KSTNM',cinput,ierr)

           write(40,*)'station i=',i,' read D'
           write(40,*)' lx    ',lx
           write(40,*)' abal  ',abal
           write(40,*)' dtr   ',dtr
           write(40,*)' ierr  ',ierr
           write(40,*)' dist  ',re(i)
           write(40,*)' az    ',az
           write(40,*)' kstnm ',cinput
           write(40,*)' nevid ',komp 
           write(40,*)'station i=',i,' read E'

        end if

        dt=dtr
        ione = ione+1
      
        if (fc.gt.0) then 
       !-------------------------------------------
       ! calculate cosine taper 
       ! letztlich wird isamp Bereich zum rechnen + Inversion verwendet.
       ! Der taper ist isamp*tap (0 < tap < 0.25) auf jeder Seite
       ! beginnt bei iretard.
       ! Wenn das Nutzsignal den isamp-Bereich voll ausfuellt (z.B. vorne
       ! zu knapp gelegt) dann kann es evtl. zu syst. Fehlern durch den 
       ! Taper kommen.
       !-------------------------------------------
         fscal = 1000000.

         ifenl = int(isamp(i)*tap+0.5)
         if (ifenl .eq. 0) then
          ifenl = 1
          write(40,*)'ifenl was 0, changed to 1!!!!'
         endif
         do k=1,isamp(i)
          if(k .le. +ifenl)then
           ifen(i,k) = fscal*0.5*(1.+cos(pi*(1.*k-ifenl)/ifenl))
          else if(k.ge. isamp(i)-ifenl)then
           ifen(i,k) = fscal*0.5*
     &           (1.+cos(pi*(1.*k-(isamp(i)-ifenl))/ifenl))
          else 
           ifen(i,k) = fscal*1.0
          end if
         end do

        end if
 
c        write(*,*)'Step 3.3'
 
       !-------------------------------------------
       !  diverse einmalige Befehle wenn ione == 0, ionel ==0
       !-------------------------------------------
        if(ione.eq.0) then
         ! ----------- header von dispi.* schreiben
         do j1=1,3
          if(nstatc(j1).gt.0)then

          if(igseout.eq.1)then
           write(ifil(j1),'(a50)')'Raumwellen'
           write(ifil(j1),'(a50)')
     & 'scale with: GSEcounts * calib *1.E-9 ym'
           write(ifil(j1),151) nstatc(j1)
           write(ifil(j1),161)(re(1),j=1,nstatc(j1))
	   
           write(ifil(j1),171)0.,0.,dt,0.,0.
          else
           write(ifil(j1),'(a50)')'Raumwellen'
           write(ifil(j1),111)1,0,0,j1
           write(ifil(j1),'(5f10.4)')x1,x2,(nv(j),j=1,3)
           write(ifil(j1),151) nstatc(j1)
           write(ifil(j1),161)(re(1),j=1,nstatc(j1))
           
           write(ifil(j1),171)0.,0.,dt,0.,0.	   
          end if

          end if
         end do
 
       !--------------------------------------------
       !  BP Filter in frequency                       
       !--------------------------------------------
         if(fc.gt.0)then 
          ifail=0
          write(40,*)'Traces Filter, f=',fc,'Hz'
          dtr = dt
          call filtkaus(dtr,fcu,fc,1,isampf,filt,ifail)
          if(ifail.ne.0)then
            write(40,*)'ifail filter .ne. 0, stopped'
            write(*,*)'ifail filter .ne. 0, stopped'
            stop
          end if
         end if

         ione = ione + 1
        end if

       !--------------------------------------------
       !     end diverse einmalige Befehle
       !--------------------------------------------

        if(igsein.eq.0)then
         read(1,5001)re(i),ABAL,komp,lx,BALMAX,az
         !if(iscal.gt.0)BALMAX = BALMAX*sqrt(1.e+4+re(i)**2)/1.e+3
         if(iscal.gt.0)BALMAX = BALMAX*re(i)/1000.
        else
         if(iscal.gt.0)then
          BALMAX = re(i)/1000.
         else
          BALMAX = 1.
         end if
        end if
        BALMAX = BALMAX*sign(1.0,wt(i))
        wt(i) = abs(wt(i))

        !..... Daten werden spaeter um iadd Punkte verlaengert
        abal = abal -iadd*dtr

        ibal = int(abal/dtr)

        if(abs(azi(i)-az).gt.0.1)then  ! test whether azi is correct
         write(40,*)'warning'
         write(40,*)'i=',i,'azi .ne. az, r=',re(i),azi(i),az
         az=azi(i)
	 write(40,*)'...corrected'
        end if
        itmp=isampf

        if((lx+iadd).lt.itmp)then
         write(40,*)'lx+iadd.lt.isamp, i=',i,' r=',re(i)
         write(40,*)'lx=',lx,' iadd=',iadd,' isamp=',itmp
        end if
        if((lx+iadd).gt.wmaxIBALLA)then
         write(*,*)'lx+iadd.gt.wmaxIBALLA , r=',re(i)
         write(40,*)'lx+iadd.gt.wmaxIBALLA , r=',re(i)
	 stop
        end if

        if(igsein.eq.0)then
         read(1,5002)(IBALLA(i1),i1=1,lx)
         !....... Daten um iadd punkte nach vorne verlaengern
         do i1=lx+iadd,iadd+1,-1
          iballa(i1)=iballa(i1-iadd)
         end do
         do i1=1,iadd
          iballa(i1)=iballa(iadd+1)*0.5*
     &              (1-cos(pi*(real(i1)-1.)/real(iadd)))
         end do
        else
         do i1=lx+iadd,iadd+1,-1
          xxx(i1)=xxx(i1-iadd)
         end do
         do i1=1,iadd
          xxx(i1)=xxx(iadd+1)*0.5*
     &              (1-cos(pi*(real(i1)-1.)/real(iadd)))
         end do
        end if

        lx = lx+iadd

       !--------------------------------------------
       !  Taper in time domain                                
       !--------------------------------------------
        i2 = iretard(i)-ibal
        ! kbeg = i2+int(isamp(i)/2) - int(itmp/2)-1
        kbeg = i2-1
        !write(*,*)abal,ibal,i2,kbeg
        if(kbeg.lt.0)then
         write(*,*)cfil(i),kbeg
         write(*,*)'ERROR!!! kbeg < 0 '
         write(40,*)cfil(i),kbeg
         write(40,*)'ERROR!!! kbeg < 0 '
         !kbeg = 0
         stop
        end if
        write(40,*)'kbeg',kbeg,isamp(i),lx,iadd
        do k=kbeg+1,kbeg+isamp(i)       ! Zeitfenster isamp
          if(igsein.eq.0)then
             x2=(iballa(k)/10000.-5.0001)*balmax/4.999
             ddd(i,k-kbeg)=iballa(k)
	     dddmax(i)=balmax
          else
             x2 = xxx(k)*balmax
          end if
          x2 = x2*ifen(i,k-kbeg) / fscal
c         if(kbeg+isamp(i).le.lx-iadd)then changed F.K. 26.11.02
          if(k.le.lx-iadd)then
            cx(k-kbeg) = cmplx(real(x2),0.0)
          else
            cx(k-kbeg) = cmplx(0.0,0.0)
          endif
        end do
c       do k=kbeg+isamp(i)+1,kbeg+itmp  ! Rest mit Nullen, alte Formulierung f.k.8.5.02
        do k=kbeg+isamp(i)+1,wmax+kbeg  ! Rest mit Nullen
          x2 = 0.
          cx(k-kbeg) = cmplx(real(x2),0.0)
        end do

c        write(*,*)'Step 3.10'
        if(cphas(i)(8:8).eq.'P')then
         q = qp
         !write(*,*)cphas(i)(8:8),', qp = ',q,' used'
        else if(cphas(i)(8:8).eq.'S')then
         q = qs
         !write(*,*)cphas(i)(8:8),', qs = ',q,' used'
        else
         q = qp
         !write(*,*)cphas(i)(8:8),', q  = ',q,' used, unknown phase'
        end if
        tstar = re(i) / (vel(i)*q)
c        write(*,*)'here below'
c        write(*,*)cphas(i)(8:8),re(i),vel(i),q,tstar

       !--------------------------------------------
       ! Filter in frequency                               
       !--------------------------------------------
        call fork(isampf,cx,-1.0)
        wnyq = 2.*pi / (2.*dt )
        !v6 add if
	if (v6i.ne.1) then
	 do k=1,isampf
          cx(k)=cx(k)*cmplx(filt(k),0.)
         end do
	end if
        do k=2,lxx
         w=2.*pi*real(k-1)/(real(isampf)*dt)
	 carg=cmplx(0.5*w*tstar,-w*tstar*log(w/wnyq)/pi)
	 cx(k)=cx(k)*cdexp(carg)
         cx(isampf-k+2)=conjg(cx(k))
        end do
        cx(lxx)=cmplx(real(cx(lxx)),0.)

        if(ifr.eq.1)then
	 do k=1,lxx
c          write(*,*)i,k,' fdat ',cx(k)
          fdat(i,k)=cx(k)
c          synth(k,i) = cabs(cx(k))
         end do
        end if
	
        call fork(isampf,cx,+1.0)
        do i1=1,isampf
         dat(i,i1)=dble(cx(i1))
         synth(i1,i) = real(cx(i1))
        end do

       !--------------------------------------------
       ! Write to dispi.*                          
       !--------------------------------------------

        abal = iretard(i)*dt

        lx = isamp(i)
        komp = ikomp(i)
         
        do i1=1,lx
          xxx(i1) = synth(i1,i)
        enddo

        BALMAX = AMAX(xxx,lx)
        BAL = abs(AMIN(xxx,lx))
        IF(BAL.GT.BALMAX) BALMAX = BAL
        IF(BALMAX.EQ.0.) then
         bal = 1.
        else
         bal = BALMAX
        end if

        if(igseout.eq.1)then  !-- 24 bit gse2 format

         call init_hdrvars_mtinvers
         hdr_debug    = 4   !  muss wohl groesser als 3 sein ?
         hdr_nsamp    = lx

         hdr_smprate = 1.0 / dt

         call add_time_shift(abal) !-add t-shift abal, calculate new date
         hdr_station  = cphas(i)
         hdr_chan     = '__'//comp(i)
         if(komp.eq.1)then          ! rad
           hdr_hang   = azi(i)
           hdr_vang   = 90.0
         else if(komp.eq.2)then     ! ver, but comp=s has also komp=2
           hdr_hang   = -1.
           hdr_vang   = 0.0
         else if(komp.eq.3)then     ! tra
           hdr_hang   = azi(i)-90.
           hdr_vang   = 90.0
         end if
         hdr_calfac  = BAL*59.6  ! bal * 1E9/2**24
         !write(*,*)cphas(i),' calfac= ',hdr_calfac

         do i1=1,lx
          synth(i1,i)=synth(i1,i)/hdr_calfac
          iballa(i1)=1.E+9 *synth(i1,i)
         end do
         
         do i1=1,10  ! check free space in character variables
          if(hdr_station(i1:i1).eq.' ')hdr_station(i1:i1)='_'
         end do

         iout = ifil(ikomp(i))
         call gseout(iout,cbuf,iballa,nchecksum)

        else     ! ---------- 13 bit ascii format

         do i1=1,lx
          synth(i1,i)=4.999*synth(i1,i)/BAL + 5.0001
          iballa(i1)=10000.*synth(i1,i)
         end do
         write(ifil(ikomp(i)),6001)
     &      re(i),ABAL,komp,lx,dddmax(i),azi(i)
         write(ifil(ikomp(i)),6002)(ddd(i,i1),i1=1,lx)

        end if

        if(igsein.eq.0)then
         read(1,5003)re(i),sn,se,sz
         close(1)
        end if


        if(comp(i).eq.'r') then     ! radial component

         sn = +cos(azi(i)/rad)*1.  -sin(azi(i)/rad)*0.
         se = +sin(azi(i)/rad)*1.  +cos(azi(i)/rad)*0.
         sz = 0.
         vkomp(i,1) = 1.
         vkomp(i,2) = 0.
         vkomp(i,3) = 0.
         vkomp(i,4) = 0.
         vkomp(i,5) = 0.	 

        else if(comp(i).eq.'t') then     ! transversal component

         sn = +cos(azi(i)/rad)*0.  -sin(azi(i)/rad)*1.
         se = +sin(azi(i)/rad)*0.  +cos(azi(i)/rad)*1.
         sz = 0.
         vkomp(i,1) = 0.
         vkomp(i,2) = 1.
         vkomp(i,3) = 0.
         vkomp(i,4) = 0.
         vkomp(i,5) = 0.	 

        else if(comp(i).eq.'z') then     ! vertical component

         sn = 0.
         se = 0.
         sz = 1.
         vkomp(i,1) = 0.
         vkomp(i,2) = 0.
         vkomp(i,3) = 1.
         vkomp(i,4) = 0.
         vkomp(i,5) = 0.	 

        else if(comp(i).eq.'n') then     ! north component

         sn = 1.
         se = 0.
         sz = 0.
         vkomp(i,1) = 0.
         vkomp(i,2) = 0.
         vkomp(i,3) = 0.
         vkomp(i,4) = 1.
         vkomp(i,5) = 0.	 

        else if(comp(i).eq.'e') then     ! east component

         sn = 0.
         se = 1.
         sz = 0.
         vkomp(i,1) = 0.
         vkomp(i,2) = 0.
         vkomp(i,3) = 0.
         vkomp(i,4) = 0.
         vkomp(i,5) = 1.	 	 

        end if
        if(igseout.ne.1)write(ifil(ikomp(i)),6003)re(i),sn,se,sz
      end do

      !--------------------------------------------
      ! Closing dispi.* 
      !--------------------------------------------
      do i=1,8
       if(nstatc(i).gt.0) close(ifil(i))
      end do

110   FORMAT(4I5)
140   FORMAT(20X,3F10.4)
150   FORMAT(I5)
160   FORMAT(7F10.3)
170   FORMAT(20x,F10.6,25X)
5001  FORMAT(2F15.5,I5/,I10,5X,E15.4,f15.5)
5002  FORMAT(16I5)
5003  FORMAT(4F15.5)


********************************************************************************
*     4. READ AND PROCESS GREEN FUNCTIONS
********************************************************************************

      if (v6i.ne.1) go to 2233
      
      !option use STF=Fz.Brustle-Muller
      do i=1,nstat
       winlen=dt*isamp(i)
       if (v6istf.ge.winlen) then
       write(40,*)'WARNING: stf too long or data too short at ',i
       end if
      end do
      if (v6istf.ne.0) then
       do ihfkt=1,isampf
        hfktlen=ihfkt*dt
        if (hfktlen.le.v6istf) then
         hfkt(ihfkt)=0.75*pi/v6istf*dsin(pi*ihfkt*dt/v6istf)**3
        else
         hfkt(ihfkt)=0.
        end if
        do igreen=1,9
         sfun(igreen,ihfkt)=cmplx(hfkt(ihfkt),0.e0)
         if (igreen.eq.1) then
  	  sfun(igreen,ihfkt)=sfun(igreen,ihfkt)*xm1d(1,1) 
         else if (igreen.eq.2) then
 	  sfun(igreen,ihfkt)=sfun(igreen,ihfkt)*xm1d(1,2)
         else if (igreen.eq.3) then
	  sfun(igreen,ihfkt)=sfun(igreen,ihfkt)*xm1d(2,2)
	 else if (igreen.eq.4) then
	  sfun(igreen,ihfkt)=sfun(igreen,ihfkt)*xm1d(1,3)
         else if (igreen.eq.5) then
	  sfun(igreen,ihfkt)=sfun(igreen,ihfkt)*xm1d(2,3)
         else if (igreen.eq.6) then
	  sfun(igreen,ihfkt)=sfun(igreen,ihfkt)*xm1d(3,3)
         else if (igreen.eq.7) then 
	  sfun(igreen,ihfkt)=sfun(igreen,ihfkt)*xf1d(1)
         else if (igreen.eq.8) then
	  sfun(igreen,ihfkt)=sfun(igreen,ihfkt)*xf1d(2)
         else if (igreen.eq.9) then
	  sfun(igreen,ihfkt)=sfun(igreen,ihfkt)*xf1d(3)	 
	 end if
        end do
       end do 
      else
       do igreen=1,9
        if (igreen.eq.1) then
  	  sfun(igreen,1)=cmplx(xm1d(1,1),0.) 
         else if (igreen.eq.2) then
  	  sfun(igreen,1)=cmplx(xm1d(1,2),0.) 
         else if (igreen.eq.3) then
  	  sfun(igreen,1)=cmplx(xm1d(2,2),0.) 
	 else if (igreen.eq.4) then
  	  sfun(igreen,1)=cmplx(xm1d(1,3),0.) 
         else if (igreen.eq.5) then
  	  sfun(igreen,1)=cmplx(xm1d(2,3),0.) 
         else if (igreen.eq.6) then
  	  sfun(igreen,1)=cmplx(xm1d(3,3),0.) 
         else if (igreen.eq.7) then 
  	  sfun(igreen,1)=cmplx(xf1d(1),0.) 
         else if (igreen.eq.8) then
  	  sfun(igreen,1)=cmplx(xf1d(2),0.) 
         else if (igreen.eq.9) then
  	  sfun(igreen,1)=cmplx(xf1d(3),0.)
	 end if
        end do
       
      end if    
      !end generation STF (at this point in f-domain)     

2233  continue

      write(*,*)'Step 4: Reading Greens Functions' 
      write(40,*)'Step 4: Reading Greens Functions' 

      cfil2(1) = 'MT1.r'
      cfil2(2) = 'MT1.z'
      cfil2(3) = 'MT1.t'
      cfil2(4) = 'MT1.n'
      cfil2(5) = 'MT1.e'     

      cfil2(6) = 'MT2.r'
      cfil2(7) = 'MT2.z'
      cfil2(8) = 'MT2.t'
      cfil2(9) = 'MT2.n'
      cfil2(10) = 'MT2.e'
      
      cfil2(11) = 'MT3.r'
      cfil2(12) = 'MT3.z'
      cfil2(13) = 'MT3.t'
      cfil2(14) = 'MT3.n'
      cfil2(15) = 'MT3.e'
      
      cfil2(16) = 'MT4.r'
      cfil2(17) = 'MT4.z'
      cfil2(18) = 'MT4.t'
      cfil2(19) = 'MT4.n'
      cfil2(20) = 'MT4.e'

      cfil2(21) = 'MT5.r'
      cfil2(22) = 'MT5.z'
      cfil2(23) = 'MT5.t'
      cfil2(24) = 'MT5.n'
      cfil2(25) = 'MT5.e'

      cfil2(26) = 'MT6.r'    
      cfil2(27) = 'MT6.z'
      cfil2(28) = 'MT6.t'
      cfil2(29) = 'MT6.n'
      cfil2(30) = 'MT6.e'

      cfil2(31) = 'SF1.r'
      cfil2(32) = 'SF1.z'
      cfil2(33) = 'SF1.t'
      cfil2(34) = 'SF1.n'
      cfil2(35) = 'SF1.e'

      cfil2(36) = 'SF2.r'
      cfil2(37) = 'SF2.z'
      cfil2(38) = 'SF2.t'
      cfil2(39) = 'SF2.n'
      cfil2(40) = 'SF2.e'

      cfil2(41) = 'SF3.r'     
      cfil2(42) = 'SF3.z'
      cfil2(43) = 'SF3.t'      
      cfil2(44) = 'SF3.n'
      cfil2(45) = 'SF3.e'            
                
      do j=1,nstat   !............ loop over stations
       ifenl = int(isamp(j)/4)
       if(istat(j).lt.10)then
        write(char3,'(a1,i1)')'.',istat(j)
       else if(istat(j).lt.100)then
        write(char3,'(a1,i2)')'.',istat(j)
       else
        write(char3,'(a1,i3)')'.',istat(j)
       end if

       igreen=9
       if(comp(j).eq.'r')then
        cfil2a(1) = cdir(1:ibl)//cfil2(1)//char3
        cfil2a(2) = cdir(1:ibl)//cfil2(6)//char3
        cfil2a(3) = cdir(1:ibl)//cfil2(11)//char3
        cfil2a(4) = cdir(1:ibl)//cfil2(16)//char3
        cfil2a(5) = cdir(1:ibl)//cfil2(21)//char3
        cfil2a(6) = cdir(1:ibl)//cfil2(26)//char3	
        cfil2a(7) = cdir(1:ibl)//cfil2(31)//char3
        cfil2a(8) = cdir(1:ibl)//cfil2(36)//char3
        cfil2a(9) = cdir(1:ibl)//cfil2(41)//char3
       else if(comp(j).eq.'z')then
        cfil2a(1) = cdir(1:ibl)//cfil2(2)//char3
        cfil2a(2) = cdir(1:ibl)//cfil2(7)//char3
        cfil2a(3) = cdir(1:ibl)//cfil2(12)//char3
        cfil2a(4) = cdir(1:ibl)//cfil2(17)//char3
        cfil2a(5) = cdir(1:ibl)//cfil2(22)//char3
        cfil2a(6) = cdir(1:ibl)//cfil2(27)//char3	
        cfil2a(7) = cdir(1:ibl)//cfil2(32)//char3
        cfil2a(8) = cdir(1:ibl)//cfil2(37)//char3
        cfil2a(9) = cdir(1:ibl)//cfil2(42)//char3
       else if(comp(j).eq.'t')then
        cfil2a(1) = cdir(1:ibl)//cfil2(3)//char3
        cfil2a(2) = cdir(1:ibl)//cfil2(8)//char3
        cfil2a(3) = cdir(1:ibl)//cfil2(13)//char3
        cfil2a(4) = cdir(1:ibl)//cfil2(18)//char3
        cfil2a(5) = cdir(1:ibl)//cfil2(23)//char3
        cfil2a(6) = cdir(1:ibl)//cfil2(28)//char3	
        cfil2a(7) = cdir(1:ibl)//cfil2(33)//char3
        cfil2a(8) = cdir(1:ibl)//cfil2(38)//char3
        cfil2a(9) = cdir(1:ibl)//cfil2(43)//char3
       else if(comp(j).eq.'n')then
        cfil2a(1) = cdir(1:ibl)//cfil2(4)//char3
        cfil2a(2) = cdir(1:ibl)//cfil2(9)//char3
        cfil2a(3) = cdir(1:ibl)//cfil2(14)//char3
        cfil2a(4) = cdir(1:ibl)//cfil2(19)//char3
        cfil2a(5) = cdir(1:ibl)//cfil2(24)//char3
        cfil2a(6) = cdir(1:ibl)//cfil2(29)//char3	
        cfil2a(7) = cdir(1:ibl)//cfil2(34)//char3
        cfil2a(8) = cdir(1:ibl)//cfil2(39)//char3
        cfil2a(9) = cdir(1:ibl)//cfil2(44)//char3
       else if(comp(j).eq.'e')then
        cfil2a(1) = cdir(1:ibl)//cfil2(5)//char3
        cfil2a(2) = cdir(1:ibl)//cfil2(10)//char3
        cfil2a(3) = cdir(1:ibl)//cfil2(15)//char3
        cfil2a(4) = cdir(1:ibl)//cfil2(20)//char3
        cfil2a(5) = cdir(1:ibl)//cfil2(25)//char3
        cfil2a(6) = cdir(1:ibl)//cfil2(30)//char3	
        cfil2a(7) = cdir(1:ibl)//cfil2(35)//char3
        cfil2a(8) = cdir(1:ibl)//cfil2(40)//char3
        cfil2a(9) = cdir(1:ibl)//cfil2(45)//char3
       end if

       do i=1,igreen

        if(igsein.eq.0)then   ! 13 bit ascii format
         open(1,file=cfil2a(i))
         read(1,'(a1)')cdummy
         read(1,110)nlay,mdeck,iso,idummy
         do k=1,nlay
          read(1,'(a1)')cdummy
         end do
         read(1,150) nstat1
         if(nstat1.ne.1)then
          write(*,*)'nstat1.ne.1 in ',cfil2a(i)
	  write(40,*)'nstat1.ne.1 in ',cfil2a(i)
          stop
         end if
         read(1,160)x1
         read(1,170)dtr
        else
          call rsac1(cfil2a(i),xxx,lx,abal,dtr,wmaxIBALLA,ierr)
          !call rsac1(cfil2a(i),xxx,lx,abal,dtr,wmax,ierr)
	  if (ierr.gt.0) then
	   write(*,"('reading error , ierr= ',i4)") ierr
           if(ierr.eq.108) write(*,*)'file ',cfil(i),' not existing'
           write(40,"('reading error , ierr= ',i4)") ierr
           if(ierr.eq.108) write(40,*)'file ',cfil(i),' not existing'        
	   stop
          else if (ierr.lt.0) then
           write(40,*)'too many points, file ',cfil(i),' cutted',ierr
          end if
          call getfhv('DIST',x1,ierr)
           r = x1
           !re(i) = x1
          call getfhv('AZ',x1,ierr)
           az = x1
          !call getnhv ('NEVID',komp,ierr)
          call getfhv ('USER1',x1,ierr)
           komp = int(x1)
          !call getfhv ('USER2',ABAL,ierr) ! bereits in rsac1 eingelesen
          call getkhv('KSTNM',cinput,ierr)
        end if
        if(abs(dt-dtr).ge.0.001) then
          write(40,*)'WARNING: dt.ne.dtr in ',cfil2a(i)
          !stop
        end if

        if(igsein.eq.0)then
         read(1,5001)r,ABAL,komp,lx,BALMAX,az
         if(iscal.gt.0)BALMAX = BALMAX*re(j)/1000.
         ! BALMAX = BALMAX*wt(j)
        else
         BALMAX = 1.
         if(iscal.gt.0)BALMAX = BALMAX*re(j)/1000.
        end if

        ibal = (abal/dtr)
        if(i.eq.1)then
         itmp=isampf
         i2 = iretardg(j) - ibal
         if(i2.lt.0)then
          write(*,*)cfil2a(i),j,i2
          write(*,*)'Error!!! i2 < 0, stop',j,iretardg(j),ibal
          write(40,*)cfil2a(i),j,i2
          write(40,*)'Error!!! i2 < 0, stop'
          stop
         end if
         kbeg = i2-1
         if(kbeg.lt.0)then
          write(*,*)cfil2a(i),j,i2,itmp,isamp(j),kbeg
          write(*,*)'Error!!! kbeg < 0, stop'
          write(40,*)cfil2a(i),j,i2,itmp,isamp(j),kbeg
          write(40,*)'Error!!! kbeg < 0, stop'
          stop
         end if
        end if

        if((abs(r-re(j))).gt.(r/100))then
         write(40,*)'WARNING: r=',r,'.ne.re(j)=',re(j),
     &                        ' in ',cfil2a(i),j
         !stop
        end if

        if(igsein.eq.0)then
         read(1,5002)(iballa(i1),i1=1,lx)
         do i1=kbeg+1,kbeg+isamp(j)
          x2=(iballa(i1)/10000. -5.0001)*balmax/4.999
          x2 = x2*ifen(j,i1-kbeg) / fscal
          cx(i1-kbeg)=cmplx(x2,0.e0)
         end do
        else
         do i1=kbeg+1,kbeg+isamp(j)
c          x2=xxx(k)*balmax
          x2=xxx(i1)*balmax
          x2 = x2*ifen(j,i1-kbeg) / fscal
          cx(i1-kbeg)=cmplx(x2,0.e0)
         end do
        end if
        do i1=kbeg+isamp(j)+1,kbeg+itmp
         x2=0.
         cx(i1-kbeg)=cmplx(x2,0.e0)
        end do
        ! already including taper in time domain

        call fork(itmp,cx,-1.0)
        do i1=1,lxx
         w=2.*pi*real(i1-1)/(real(isampf)*dt)
         !v6 add if
         if (v6i.ne.1) then
          if(fc.gt.0) cx(i1)=cx(i1)*cmplx(filt(i1),0.)
         end if
         gmatfre(j,i,i1)= cx(i1)
        end do
        ! already including BP filter in frequency dom.

        do i1=1,lxx
c         write(*,*)j,i,i1,gmatfre(j,i,i1)
	 ccx(i1)=gmatfre(j,i,i1)
	 ccx(isampf-i1+2)=conjg(ccx(i1))
	end do
        ccx(lxx)=cmplx(real(ccx(lxx)),0.)
        call fork(isampf,ccx,+1.0)

        do k=1,isampf
	 gmattim(j,i,k) =real( ccx(k) )
c         write(*,*)j,i,k,gmattim(j,i,k)
        end do
        ! filtered and taperes green functions in time dom.
	! are saved in gmattim(j,i,k)
 
        if(igsein.eq.0)then
         read(1,5003)r,sn,se,sz
         close(1)
        end if

       end do      
       ! end local loop over GF (1-9)

      end do      
      ! end local loop over traces

      do j=1,nstat
       re(j) = re(j)*1000.
       azi(j) = azi(j)/rad
       dazi = azi(j)
       w =  sa(j,1)
       sa(j,1) = w*dcos(dazi)
       sa(j,2) = w*dsin(dazi)
      end do


********************************************************************************
*     5. PREPARING INVERSION SECTION
********************************************************************************

      write(*,*)'Step 5: Preparing inversion'
      write(40,*)'Step 5: Preparing inversion'
      
      lx = isampf

      do ig = 1,20
       costlist(ig)=1.e+35
       cbest(ig)='-12345'
      end do
      iout = 9
      open(iout+1,file='result.dat')
      write(iout+1,*)'0, M0, M11, M12, M22, M13, M23, M33',
     & ' strike1 dip1 rake1 strike2 dip2 rake2 ISO%  DC% ',
     & ' P azi P plunge T azi T plunge SF0 SF1 SF2 SF3'
     
      !........ number of free source parameter depends on igame
      if(igame.eq.1)then
       k1 = 6
      else if(igame.eq.1)then
       k1 = 3
      else if(igame.eq.2)then
       k1 = 9
      else
       write(*,*)'Error : igame incorrect'
       write(40,*)'Error : igame incorrect'
       stop
      end if


C     INVERSION SWITCH
      if (v6i.eq.1) go to 740 


********************************************************************************
*     6. INVERSION IN TIME DOMAIN
********************************************************************************
      write(*,*)'Step 6: Inversion in time domain (not impl.)'
      write(40,*)'Step 6: Inversion in time domain (not impl.)'

      if (ifr.eq.0) then
       write(*,*)'Sorry, t-domain inv not yet implemented!'
       write(40,*)'Sorry, t-domain inv not yet implemented!'
       stop
      end if
      

********************************************************************************
*     7. INVERSION IN FREQ DOMAIN
********************************************************************************

      write(*,*)'Step 7: Inversion in frequency domain'      
      write(40,*)'Step 7: Inversion in frequency domain'      

      if (ifr.eq.1) then

cc     GF(w) are saved in: gmatfre(ntraces,ngreen(9),npt(lxx=isampf/2+1))
cc     U(w)  are saved in: fdat(ntraces,npt(lxx))

       do i=1,nstat
        do wi=1,lxx
	 uw(i)=fdat(i,wi)
        end do
       end do

       chinv=0

c      added for vers.9
       do wi=1,lxx
        wsing(wi)=0
       end do
c      <vers.9        

       do wi=1,lxx  ! loop over each sampled frequency 
c       do wi=2,lxx  ! loop over each sampled frequency 
 
c        write(*,*)'Frequency sample ',wi       
c       assign vector U(w_i), with dimension=number traces -> uw(i), i=1..nstat
        do i=1,nstat
	 uw(i)=fdat(i,wi)
        end do
        do i=nstat+1,nmax
	 uw(i)=(0.,0.)
        end do	

c       assign matrix G(w_i), with dimensions:
c                                       lines=number traces
c                                       columns=number free source parameters (9)
c                            -> gw(i,j), i=1..nstat, j=1..9        
        do i=1,nstat
	 do j=1,9
	  gw(i,j)=gmatfre(i,j,wi)
	 end do
	end do

c       calculate G^t, transposed of G ; dim G^t = (9,nstat)
        do i=1,nstat
	 do j=1,9
	  gwt(j,i)=gw(i,j)
	 end do
	end do        

c       calculate G^t G ; dim(9,9)
        do i=1,9
	 do j=1,9
	  hws(i,j)=(0.0)
	  do k=1,nstat
	   hws(i,j)=hws(i,j)+(gwt(i,k)*gw(k,j))
	  end do
	 end do
        end do

c       calculate (G^t G)^{-1}; dim(9,9)
c       the inverse matrix is saved in hwi
c       using external subroutines 
*       .... Gauss Elimination 

        do i=1,9
	 do j=1,9
	  hw(i,j)=hws(i,j)
	 end do
	end do
        dimmat=9
        nfpar=(dimmat*2)+1   !19

        call zgeco(hw,nfpar,dimmat,ipiv,deven,nonimp)
c        write(*,*)' condition of matrix = ',deven
        if(1.d0+deven .eq. 1.d0)then
         write(40,*)wi,' : acond singular to working precision'
         do j=1,9
          sourfre(j,wi)=(0.0)
          wsing(wi)=1
         end do
	 go to 700
c         stop
        end if
	chinv=chinv+1
        call zgedi(hw,nfpar,dimmat,ipiv,dete,bvect,01)
    
        do i=1,9
	 do j=1,9
	  hwi(i,j)=hw(i,j)
	 end do
	end do
    
c       end of calculation inverted complex matrix    

c       calculate (G^t G)^{-1}) G^t ; dim (gwi) = (9,nstat)
c       call matmulc (hwi,9,9,gwt,9,nstat,gwi,9,nstat)
        do i=1,9
	 do j=1,nstat
	  gwi(i,j)=(0.0)
	  do k=1,9
	   gwi(i,j)=gwi(i,j)+(hwi(i,k)*gwt(k,j))
	  end do
	 end do
        end do

c       added in version 9, S.C.
        do i=1,9
	 do j=1,nstat
          gwiw(wi,i,j)=gwi(i,j)
	 end do
        end do
c       <vers.9

c       calculate M = (G^t G)^{-1}) G^t U ; dim (mw) = (9,1)
c       call matmulc (gwi,9,nstat,uw,nstat,1,mw,9,1)
        do i=1,9
	 j=1
	 mw(i)=(0.0)
	 do k=1,nstat
	  mw(i)=mw(i)+(gwi(i,k)*uw(k))
	 end do
	end do

c       at this point M(w_i) have been determinated, with dimension=free sour. par. (9)                  
c                           -> mw(j), j=1..9

c       save spectra of components of source in sourfre(j,w_i). j=comp, w_i=freq
        do j=1,9
         sourfre(j,wi)=mw(j)
        end do

  700   continue
	
       end do !end loop over sampled frequencies

       if (chinv.eq.0) then
        write(*,*)'ERROR: Inversion incorrect'
	write(*,*)'Complex matrices at all frequencies can not be inverted'
        write(40,*)'ERROR: Inversion incorrect'
	write(40,*)'Complex matrices at all frequencies can not be inverted'
       end if

c      calculate synthetic spectra in syntfre(i,w_i), i=1..nstat, w_i=freq
       do wi=1,lxx
        do j=1,9
         mw(j)=sourfre(j,wi)
         do i=1,nstat
          gw(i,j)=gmatfre(i,j,wi)
         end do
        end do
c        call matmulc(gw,nstat,9,mw,9,1,sfre,nstat,1)
        do i=1,nstat
	 sfre(i)=(0.0)
	 do k=1,9
	  sfre(i)=sfre(i)+(gw(i,k)*mw(k))
	 end do
	end do
 
 	do i=1,nstat
         syntfre(i,wi)=sfre(i)
        end do
       end do
     
c      calculate ifft of M(w_i)
       do j=1,9
        do wi=1,lxx
         csourtim(wi)=sourfre(j,wi)
	 csourtim(isampf-wi+2)=conjg(csourtim(wi))	 
        end do
	call fork (isampf,csourtim,+1.0)
        do ti=1,isampf
	 sourtim(j,ti)=real(csourtim(ti))
	end do
       end do

c      calculate ifft of synthetic spectra
       do i=1,nstat
        do wi=1,lxx
         csourtim(wi)=syntfre(i,wi)
	 csourtim(isampf-wi+2)=conjg(csourtim(wi))	 
        end do
	call fork (isampf,csourtim,+1.0)
        do ti=1,isampf
	 synttim(i,ti)=real(csourtim(ti))
         synth(ti,i)=synttim(i,ti)
	end do
       end do

c      calculate ifft of observed spectra
       do i=1,nstat
        do wi=1,lxx
         dhelp(wi)=fdat(i,wi)
	 dhelp(isampf-wi+2)=conjg(dhelp(wi))	 
        end do
	call fork (isampf,dhelp,+1.0)
        do ti=1,isampf
	 fildat(i,ti)=real(dhelp(ti))
	end do
       end do

c      evaluate misfit between synthetic seismograms U and observed DAT       
c       call calmis(fildat,synttim,nstat,isampf,misf)
       call calmis(fildat,synttim,nmax,tmax,nstat,isamp,misf)

c****************************************
c      Error estimation (version 9)     *
c****************************************

c        for each frequency e=d-Gm=spectra(data)-spectra(synth)       
c        E = e^t e = sum (d-s)**2 (saved in var: ete=(eter,etei))

       do wi=1,lxx
        eter(wi)=0.
	etei(wi)=0.
       end do
       do wi=1,lxx
        if(wsing(wi).ne.1) then
         do i=1,nstat
	  pasval=fdat(i,wi)-syntfre(i,wi)
 	  eter(wi)=eter(wi)+(real(pasval))**2
	  pasval=pasval*(0.,-1.)
	  etei(wi)=etei(wi)+(real(pasval))**2
	 end do
         eter(wi)=eter(wi)/nstat
         etei(wi)=etei(wi)/nstat
        end if
       end do

c        Calculate m_j(w) and Dm_j(w)
c        they have a real and immaginary component
c        in var: rvaluem,ivaluem,rdeltam,ideltam
c        all are matrices (1..9,1..nfreq)
c
c        if m = (G^t G)^-1 G^t d = H d
c        then   
c        Dm_j = sum (H_jk^2 Dd_k^2) = Dd^2 sum (H_jk^2)

       do wi=1,lxx
        if(wsing(wi).ne.1) then
         do j=1,9
          deltam(j,wi)=0
 	  do i=1,nstat
           pasval=gwiw(wi,j,i)
	   deltam(j,wi)=deltam(j,wi)+(real(pasval))**2
           pasval=pasval*(0.,-1.)
	   deltam(j,wi)=deltam(j,wi)+(real(pasval))**2
	  end do
	  rdeltam(j,wi)=deltam(j,wi)*eter(wi)
	  ideltam(j,wi)=deltam(j,wi)*etei(wi)
	  rdeltam(j,wi)=sqrt(rdeltam(j,wi))
	  ideltam(j,wi)=sqrt(ideltam(j,wi))
          pasval=sourfre(j,wi)
          rvaluem(j,wi)=real(pasval)
	  pasval=(sourfre(j,wi))*(0,-1)
	  ivaluem(j,wi)=real(pasval)
	 end do
        end if
       end do 

c      BOOTSTRAP

c      Loop over tested solutions, e.g. 200
       do iboot=1,200

c       Loop over frequencies
        do wi=1,lxx  

         if(wsing(wi).ne.1) then
          do j=1,9
	  
c          Random number generator for real component 
c           tempmr=gennor(rvaluem(j,wi),rdeltam(j,wi))
c           jgas=-j*wi*iboot
c           tempmr=gasdev(jgas)
           tempmr=rgauss(0.,1.)
	   tempmr=rvaluem(j,wi)+(tempmr*rdeltam(j,wi))	   
c          Random number generator for immaginary component
c           tempir=gennor(ivaluem(j,wi),ivaluem(j,wi))
c           jgas=2*jgas
c 	    tempir=gasdev(jgas)
           tempir=rgauss(0.,1.)
	   tempir=ivaluem(j,wi)+(tempir*ideltam(j,wi))
	   
c           if (iboot.eq.10) then
c	    if (j.eq.1) then
c             write(*,*)'MR DR ',rvaluem(j,wi),rdeltam(j,wi)
c	     write(*,*)'mr ',tempmr
c             write(*,*)'MI DI ',ivaluem(j,wi),ideltam(j,wi)
c	     write(*,*)'mi ',tempir
c	    end if
c	   end if	  

c          Reconstruct new m(w)
           tempm(j,wi)=cmplx(tempmr,tempir)
          end do
         else
          tempm(j,wi)=sourfre(j,wi)
         end if
c       End loop freq.
        end do
	
c       Calculate ifft of modified M(w_i)
        do j=1,9
         do wi=1,lxx
          ttcsourtim(wi)=tempm(j,wi)
 	  ttcsourtim(isampf-wi+2)=conjg(ttcsourtim(wi))	 
         end do
	 call fork (isampf,ttcsourtim,+1.0)
         do ti=1,isampf
	  ttsourtim(iboot,j,ti)=real(ttcsourtim(ti))
	 end do
        end do

c      End loop over tested solutions
       end do
 
c      Loop over t
       do ti=1,isampf

c       Loop over source components
        do j=1,9
	 
         meanboot(j,ti)=0
	 sdevboot(j,ti)=0
	          
c        Loop over bootstrap solutions - calc media
         do iboot=1,200
          meanboot(j,ti)=meanboot(j,ti)+ttsourtim(iboot,j,ti)
         end do
         meanboot(j,ti)=meanboot(j,ti)/200
	
c        Loop over bootstrap solutions - calc s.dev.
         do iboot=1,200
          sdevboot(j,ti)=sdevboot(j,ti)+
     &           (ttsourtim(iboot,j,ti)-meanboot(j,ti))**2
         end do
         sdevboot(j,ti)=sdevboot(j,ti)/200
         sdevboot(j,ti)=sqrt(sdevboot(j,ti))
 
c       End loop components
        end do
 
c      End loop over t
       end do

c      Save variance, v(t)
       open(11,file='emt1.dat')
       open(12,file='emt2.dat')
       open(13,file='emt3.dat')
       open(14,file='emt4.dat')
       open(15,file='emt5.dat')
       open(16,file='emt6.dat')
       open(17,file='esf1.dat')
       open(18,file='esf2.dat')
       open(19,file='esf3.dat')            

       do i=1,9
       k=i+10
        do j=1,lx
         write(k,800)dt*(j-1),sdevboot(i,j)
	end do
	close(k)
       end do

c      Save mean+variance
       open(11,file='zmt1.dat')
       open(12,file='zmt2.dat')
       open(13,file='zmt3.dat')
       open(14,file='zmt4.dat')
       open(15,file='zmt5.dat')
       open(16,file='zmt6.dat')
       open(17,file='zsf1.dat')
       open(18,file='zsf2.dat')
       open(19,file='zsf3.dat')            

       do i=1,9
       k=i+10
        do j=1,lx
         write(k,800)dt*(j-1),sourtim(i,j)+sdevboot(i,j)
	end do
	close(k)
       end do

c      Save mean-variance
       open(11,file='ymt1.dat')
       open(12,file='ymt2.dat')
       open(13,file='ymt3.dat')
       open(14,file='ymt4.dat')
       open(15,file='ymt5.dat')
       open(16,file='ymt6.dat')
       open(17,file='ysf1.dat')
       open(18,file='ysf2.dat')
       open(19,file='ysf3.dat')            

       do i=1,9
       k=i+10
        do j=1,lx
         write(k,800)dt*(j-1),sourtim(i,j)-sdevboot(i,j)
	end do
	close(k)
       end do

      end if  !end options frequancy inversion   
      

 740  continue

      if (v6i.ne.1) go to 760


c     OPTION FORWARD MODELING

      write(*,*)'Step 7.5: Forward modeling'      
      write(40,*)'Step 7.5: Forward modeling'      

c      calculate ifft of observed spectra
       do i=1,nstat
        do wi=1,lxx
         dhelp(wi)=fdat(i,wi)
	 dhelp(isampf-wi+2)=conjg(dhelp(wi))	 
        end do
	call fork (isampf,dhelp,+1.0)
        do ti=1,isampf
	 fildat(i,ti)=real(dhelp(ti))
	end do
       end do
       
c      synthetic seismograms for constrain: f1=MT, f2=SF
       call sforw(lxx,gmatfre,nmax,wmax,tmax,nstat,
     &            sfun,isampf,syntforw,v6istf,v6i)

c      calculate best M0, and mul synthetics
       num(1)=0
       den(1)=0
       
       do i=1,nstat
c       V7: next line
        iwl=isamp(i)
        do ti=1,iwl
         num(1)=num(1)+(1000000*syntforw(i,ti)*
     &                  fildat(i,ti))
         den(1)=den(1)+(1000000*syntforw(i,ti)*
     &                  syntforw(i,ti))
        end do
       end do
       scalmom=num(1)/den(1)
       write(40,*)'iwl-scalmo',iwl,scalmom
       do i=1,nstat
c       V7: next line
        iwl=isamp(i)
        do ti=1,iwl
         syntforw(i,ti)= syntforw(i,ti)*scalmom
	 synth(ti,i)=syntforw(i,ti)
	end do
        do ti=iwl+1,isampf
         syntforw(i,ti)=0.
	 synth(ti,i)=0.
	end do
       end do     

c     additional output format
       do k=1,nstat
        if (istat(k).lt.10) then
         write(fileforw,'(a4,a1,a1,i1)')'syn.',comp(k),'.',istat(k)
        else if (istat(k).lt.100) then
         write(fileforw,'(a4,a1,a1,i2)')'syn.',comp(k),'.',istat(k)
        else 
         write(fileforw,'(a4,a1,a1,i3)')'syn.',comp(k),'.',istat(k)
        end if
        open(20,file=fileforw)
        do i=1,isamp(1)
         write(20,748)i*dt,synth(i,k)
        end do
        close(20)
        if (istat(k).lt.10) then
         write(fileforw,'(a4,a1,a1,i1)')'dis.',comp(k),'.',istat(k)
        else if (istat(k).lt.100) then
         write(fileforw,'(a4,a1,a1,i2)')'dis.',comp(k),'.',istat(k)
        else 
         write(fileforw,'(a4,a1,a1,i3)')'dis.',comp(k),'.',istat(k)
        end if
        open(20,file=fileforw)      
        do i=1,isamp(1)
         write(20,748)i*dt,fildat(k,i)
        end do
        close(20)
       end do
       
       
  748 format(F7.3,' ',E15.5)
          
c      evaluate misfit between synthetic seismograms U and observed DAT       
       call calmis(fildat,syntforw,nmax,tmax,nstat,isamp,misf)

c     write output file forward.str-dp.res
       
      istr=nint(v6str*180/PI)
      idp=nint(v6dip*180/PI)
      if (istr.lt.0) istr=istr+360
      if (istr.lt.10) then
       write(cstr,'(a2,i1)')'00',istr
      else if (istr.lt.100) then
       write(cstr,'(a1,i2)')'0',istr     
      else
       write(cstr,'(i3)')istr
      end if
      if (idp.lt.10) then
       write(cdp,'(a1,i1)')'0',idp     
      else
       write(cdp,'(i2)')idp     
      endif
      
      fileforw='forward.'//cstr//'-'//cdp//'.res'
      open(20,file=fileforw)
      write(20,750)istr,idp,misf,misf,scalmom
      close(20)
      fileforw='forward.'//cstr//'-'//cdp//'.mis'
      open(20,file=fileforw)
      write(20,751)istr,idp,misf
      close(20)
     
      
 750  format(I5,' ',I5,' ',F10.5,' ',F10.5,' ',E15.5)
 751  format(I5,' ',I5,' ',F10.5)
     
      go to 802

 760  continue

*****************************END INVERSION**************************************


c    >qui
c      additional output format
       do k=1,nstat
        if (istat(k).lt.10) then
         write(fileforw,'(a4,a1,a1,i1)')'syn.',comp(k),'.',istat(k)
        else if (istat(k).lt.100) then
         write(fileforw,'(a4,a1,a1,i2)')'syn.',comp(k),'.',istat(k)
        else 
         write(fileforw,'(a4,a1,a1,i3)')'syn.',comp(k),'.',istat(k)
        end if
        open(20,file=fileforw)
        do i=1,isamp(1)
         write(20,748)i*dt,synth(i,k)
        end do
        close(20)
        if (istat(k).lt.10) then
         write(fileforw,'(a4,a1,a1,i1)')'dis.',comp(k),'.',istat(k)
        else if (istat(k).lt.100) then
         write(fileforw,'(a4,a1,a1,i2)')'dis.',comp(k),'.',istat(k)
        else 
         write(fileforw,'(a4,a1,a1,i3)')'dis.',comp(k),'.',istat(k)
        end if
        open(20,file=fileforw)      
        do i=1,isamp(1)
         write(20,748)i*dt,fildat(k,i)
        end do
        close(20)
       end do
c      < add out format      

       write(*,*)'Step 8: Writing output files'       
       write(40,*)'Step 8: Writing output files'       

      !--------------------------------------------
      ! Source 
      !--------------------------------------------

c      independent source components

       open(11,file='imt1.dat')
       open(12,file='imt2.dat')
       open(13,file='imt3.dat')
       open(14,file='imt4.dat')
       open(15,file='imt5.dat')
       open(16,file='imt6.dat')
       open(17,file='isf1.dat')
       open(18,file='isf2.dat')
       open(19,file='isf3.dat')            

       somax=0
       do i=1,9
       sourekm=0
       sourekf=0
       sourek(i)=0
       k=i+10
c        do j=1,isampf
        do j=1,lx
         write(k,800)dt*(j-1),sourtim(i,j)
	 if (abs(sourtim(i,j)).ge.sourek(i)) then
	  sourek(i)=abs(sourtim(i,j))
	 end if
	end do
	close(k)
       end do
       do i=1,6
        if (sourek(i).ge.sourekm) sourekm=sourek(i)
       end do
       do i=7,9
        if (sourek(i).ge.sourekf) sourekf=sourek(i)
       end do

c      common mt 
       
       do i=1,6
        do j=1,lx
         amat(i,j)=sourtim(i,j)
        end do
       end do 
       m1=6
       n1=lx
       mda=lx
       do i=1,6
        do j=1,6
	 if (i.eq.j) bmat(i,j)=1
	 if (i.ne.j) bmat(i,j)=0
	end do
       end do
       mdb=6
       nb=6
       call svdrs(amat,mda,m1,n1,bmat,mdb,
     &               nb,svet,wsvd)
       do i=1,lx
        stfm(i)=amat(i,1)
       end do
       do i=1,6
        num(i)=0
	den(i)=0
	do j=1,lx
	 num(i)=num(i)+stfm(j)*sourtim(i,j)
	 den(i)=den(i)+stfm(j)*stfm(j)
	end do
       end do
       write(*,*)'coef ',num(1)/den(1)
       write(40,*)'COMMON MT'
       do i=1,6
        write(40,*)'SVET ',i,' ',svet(i)
       end do
       
       open(11,file='mmt1.dat')
       open(12,file='mmt2.dat')
       open(13,file='mmt3.dat')
       open(14,file='mmt4.dat')
       open(15,file='mmt5.dat')
       open(16,file='mmt6.dat')
       
       misffm=0
       do i=1,6
        mismax=0
        do j=1,lx
         write(i+10,800)dt*j,stfm(j)*num(i)/den(i)
         confunr(i,j)=stfm(j)*num(i)/den(i)
         confun(i,j)=cmplx(confunr(i,j),0.)
	end do         
	misfterm=0         
        do j=1,lx
	 misft2=abs((stfm(j)*num(i)/den(i))-sourtim(i,j))
	 misfterm=misfterm+misft2/sourekm
	end do
        write(40,*)',mt-sf ',i,' ',misfterm/lx
	misffm=misffm+misfterm/lx
       end do

       do i=11,16
        close(i)
       end do

  800 format(F10.5,' ',D20.10)


c      common sf 

       do i=1,3
        k=i+6
        do j=1,lx
         amat(i,j)=sourtim(k,j)
        end do
       end do 
       m1=3
       n1=lx
       mda=lx
       do i=1,3
        do j=1,3
	 if (i.eq.j) bmat(i,j)=1
	 if (i.ne.j) bmat(i,j)=0
	end do
       end do
       mdb=3
       nb=3
       call svdrs(amat,mda,m1,n1,bmat,mdb,
     &               nb,svet,wsvd)
       do i=1,lx
        stff(i)=amat(i,1)
       end do
       do i=1,3
        k=i+6
        num(k)=0
	den(k)=0
	do j=1,lx
	 num(k)=num(k)+stff(j)*sourtim(k,j)
	 den(k)=den(k)+stff(j)*stff(j)
	end do
       end do
       write(40,*)'COMMON SF'
       do i=1,3
        write(40,*)'SVET ',i,' ',svet(i)
       end do
         
       open(11,file='fsf1.dat')
       open(12,file='fsf2.dat')
       open(13,file='fsf3.dat')
       do i=1,3
        mismax=0
        k=i+6
        do j=1,lx
         write(i+10,800)dt*j,stff(j)*num(k)/den(k)
         confunr(k,j)=stff(j)*num(k)/den(k)
         confun(k,j)=cmplx(confunr(k,j),0.)
	end do         
	misfterm=0         
        do j=1,lx
	 misft2=abs((stff(j)*num(k)/den(k))-sourtim(k,j))
	 misfterm=misfterm+misft2/sourekf
	end do
        write(40,*)'mt-sf ',k,' ',misfterm/lx
	misffm=misffm+misfterm/lx       
       end do
       
       misffm=misffm/9

       do i=11,13
        close(i)
       end do
      
c      synthetic seismograms for constrain: f1=MT, f2=SF
       call sforw(lxx,gmatfre,nmax,wmax,tmax,nstat,
     &            confun,isampf,synmf,v6istf,v6i)

c      evaluate misfit between synthetic seismograms U and observed DAT       
       call calmis(fildat,synmf,nmax,tmax,nstat,isamp,misfitfm)


c      additional output format
       do k=1,nstat
        if (istat(k).lt.10) then
         write(fileforw,'(a4,a1,a1,i1)')'sy2.',comp(k),'.',istat(k)
        else if (istat(k).lt.100) then
         write(fileforw,'(a4,a1,a1,i2)')'sy2.',comp(k),'.',istat(k)
        else 
         write(fileforw,'(a4,a1,a1,i3)')'sy2.',comp(k),'.',istat(k)
        end if
        open(20,file=fileforw)
        do i=1,isamp(k)
         write(20,748)i*dt,synmf(k,i)
        end do
        close(20)
       end do
c       <qui


c      common source history (mt & sf)

       do i=1,9
        do j=1,lx
         amat(i,j)=sourtim(i,j)
        end do
       end do 
       m1=9
       n1=lx
       mda=lx
       do i=1,9
        do j=1,9
	 if (i.eq.j) bmat(i,j)=1
	 if (i.ne.j) bmat(i,j)=0
	end do
       end do
       mdb=9
       nb=9
       call svdrs(amat,mda,m1,n1,bmat,mdb,
     &               nb,svet,wsvd)
       do i=1,lx
        stfc(i)=amat(i,1)
       end do
       do i=1,9
        num(i)=0
	den(i)=0
	do j=1,lx
	 num(i)=num(i)+stfc(j)*sourtim(i,j)
	 den(i)=den(i)+stfc(j)*stfc(j)
	end do
       end do
       write(40,*)'COMMON MT&SF'
       do i=1,9
        write(40,*)'SVET ',i,' ',svet(i)
       end do
       
       open(11,file='cmt1.dat')
       open(12,file='cmt2.dat')
       open(13,file='cmt3.dat')
       open(14,file='cmt4.dat')
       open(15,file='cmt5.dat')
       open(16,file='cmt6.dat')
       open(17,file='csf1.dat')
       open(18,file='csf2.dat')
       open(19,file='csf3.dat')
       misfc=0
 
       do i=1,9
        mismax=0
        do j=1,lx
         write(i+10,800)dt*j,stfc(j)*num(i)/den(i)
         confunr(i,j)=stfc(j)*num(i)/den(i)
         confun(i,j)=cmplx(confunr(i,j),0.)
	end do
	misfterm=0         
        do j=1,lx
	 misft2=abs((stfc(j)*num(i)/den(i))-sourtim(i,j))
         if (i.le.6) then
	  misfterm=misfterm+(misft2/sourekm)
	 end if
         if (i.gt.6) then
	  misfterm=misfterm+(misft2/sourekf)
	 end if 
	end do
        write(40,*)'common ',i,' ',misfterm/lx
	misfc=misfc+misfterm/lx
       end do
       misfc=misfc/9
       
       do i=11,19
        close(i)
       end do


c      synthetic seismograms for constrain: f1=MT, f2=SF
       call sforw(lxx,gmatfre,nmax,wmax,tmax,nstat,
     &            confun,isampf,syncom,v6istf,v6i)


c      evaluate misfit between synthetic seismograms U and observed DAT       
c       call calmis(fildat,syncom,nstat,isampf,misfitcom)
       call calmis(fildat,syncom,nmax,tmax,nstat,isamp,misfitcom)

c      additional output format
       do k=1,nstat
        if (istat(k).lt.10) then
         write(fileforw,'(a4,a1,a1,i1)')'syc.',comp(k),'.',istat(k)
        else if (istat(k).lt.100) then
         write(fileforw,'(a4,a1,a1,i2)')'syc.',comp(k),'.',istat(k)
        else 
         write(fileforw,'(a4,a1,a1,i3)')'syc.',comp(k),'.',istat(k)
        end if
        open(20,file=fileforw)
        do i=1,isamp(k)
         write(20,748)i*dt,syncom(k,i)
        end do
        close(20)
       end do
c      <qui


      !--------------------------------------------
      ! Fit
      !--------------------------------------------
      
      open(11,file='result.fit')
      write(11,801)misf
      write(11,801)misfitfm
      write(11,801)misfitcom
      write(11,801)misffm
      write(11,801)misfc
      write(11,801)misffm*misf
      write(11,801)misfc*misf
   
  801 format(D20.10)
  802 continue
      close(11)

       
      !--------------------------------------------
      ! Waveforms 
      !--------------------------------------------

      if (v6i.eq.1) then
       iom=1
      else
       iom=3
      end if
      
      do io=1,iom  !loop over diff. constraints 

      ifr=0
 
      if(igseout.eq.1)then  ! ---------------- gse2 format --

       if (io.eq.1) then
        cfil0(1) = 'synth.r.gse'
        cfil0(2) = 'synth.z.gse'
        cfil0(3) = 'synth.t.gse'
        cfil0(7) = 'synth.n.gse'
        cfil0(8) = 'synth.e.gse'
       else if (io.eq.2) then
        cfil0(1) = 'synt2.r.gse'
        cfil0(2) = 'synt2.z.gse'
        cfil0(3) = 'synt2.t.gse'
        cfil0(7) = 'synt2.n.gse'
        cfil0(8) = 'synt2.e.gse'      
       else 
        cfil0(1) = 'syntc.r.gse'
        cfil0(2) = 'syntc.z.gse'
        cfil0(3) = 'syntc.t.gse'
        cfil0(7) = 'syntc.n.gse'
        cfil0(8) = 'syntc.e.gse'
       end if
        
       do j=1,3
        if(nstatc(j).gt.0)then

        open(ifil(j),file=cfil0(j))
        write(ifil(j),'(a50)')'Synthetisierte Raumwellen'
        write(ifil(j),'(a50)')'scale with: GSEcounts * calib *1.E-9 ym'
        WRITE(ifil(j),151) nstatc(j)
        WRITE(ifil(j),161)(re(1)/1000.,ie=1,nstatc(j))
        if(ifr.eq.0)then
         WRITE(ifil(j),171)0.,0.,dt,0.,0.
        else
         WRITE(ifil(j),171)0.,dt,1./(isampf*dt),0.,0.
        end if
      
        end if
       end do
       do j=7,8
        if(nstatc(j).gt.0)then

        open(ifil(j),file=cfil0(j))
        write(ifil(j),'(a50)')'Synthetisierte Raumwellen'
        write(ifil(j),'(a50)')'scale with: GSEcounts * calib *1.E-9 ym'
        WRITE(ifil(j),151) nstatc(j)
        WRITE(ifil(j),161)(re(1)/1000.,ie=1,nstatc(j))
        if(ifr.eq.0)then
         WRITE(ifil(j),171)0.,0.,dt,0.,0.
        else
         WRITE(ifil(j),171)0.,dt,1./(isampf*dt),0.,0.
        end if
      
        end if
       end do
     
      else      ! ------------------- 1 bit ascii files 

       if (io.eq.1) then
        cfil0(1) = 'synth.r'
        cfil0(2) = 'synth.z'
        cfil0(3) = 'synth.t'
        cfil0(7) = 'synth.n'
        cfil0(8) = 'synth.e'
       else if (io.eq.2) then
        cfil0(1) = 'synt2.r'
        cfil0(2) = 'synt2.z'
        cfil0(3) = 'synt2.t'
        cfil0(7) = 'synt2.n'
        cfil0(8) = 'synt2.e'      
       else 
        cfil0(1) = 'syntc.r'
        cfil0(2) = 'syntc.z'
        cfil0(3) = 'syntc.t'
        cfil0(7) = 'syntc.n'
        cfil0(8) = 'syntc.e'
       end if
       
       do j=1,3
        if(nstatc(j).gt.0)then

        open(ifil(j),file=cfil0(j))
        write(ifil(j),'(a50)')'Synthetisierte Raumwellen'
        write(ifil(j),111)1,0,0,j
        WRITE(ifil(j),141)vel(1)/1000.,vel(1)/1000.,vel(1)/1000.
        WRITE(ifil(j),151) nstatc(j)
        WRITE(ifil(j),161)(re(1)/1000.,ie=1,nstatc(j))
        if(ifr.eq.0)then           ! attention: assuming that ifreq is the same for all traces
         WRITE(ifil(j),171)0.,0.,dt,0.,0.
        else
         WRITE(ifil(j),171)0.,dt,1./(isampf*dt),0.,0.
        end if
      
        end if
       end do
       do j=7,8
        if(nstatc(j).gt.0)then

        open(ifil(j),file=cfil0(j))
        write(ifil(j),'(a50)')'Synthetisierte Raumwellen'
        write(ifil(j),111)1,0,0,j
        WRITE(ifil(j),141)vel(1)/1000.,vel(1)/1000.,vel(1)/1000.
        WRITE(ifil(j),151) nstatc(j)
        WRITE(ifil(j),161)(re(1)/1000.,ie=1,nstatc(j))
        if(ifr.eq.0)then           ! attention: assuming that ifreq is the same for all traces
         WRITE(ifil(j),171)0.,0.,dt,0.,0.
        else
         WRITE(ifil(j),171)0.,dt,1./(isampf*dt),0.,0.
        end if
      
        end if
       end do

      end if

      do ie=1,nstat
       if(ifr.eq.0)then
        lx0 = isamp(ie)
       else
        lx0 = lxx
       end if
       do j=1,lx0
        if (v6i.eq.1) then
	 wsynth(j,ie)=syntforw(ie,j)
	else
         if (io.eq.1) then
	  wsynth(j,ie)=synth(j,ie)
         else if (io.eq.2) then
	  wsynth(j,ie)=synmf(ie,j)
	 else 
	  wsynth(j,ie)=syncom(ie,j)
 	 end if
	end if
       end do
      end do 

      !...............  loop over traces to write
      do ie = 1,nstat

         abal = iretard(ie)*dt    ! immer der gleiche Spurbeginn

         if(ifr.eq.0)then
          lx0 = isamp(ie)
         else
          lx0 = lxx
         end if
         komp = ikomp(ie)

        !................  find real-valued maximum BAL of trace
        BALMAX = AMAX(wsynth(1,ie),lx0)
        BAL = abs(AMIN(wsynth(1,ie),lx0))
        IF(BAL.GT.BALMAX) BALMAX = BAL
        IF(BALMAX.EQ.0.) then
         bal = 1.
        else
         bal = BALMAX
        end if

        if(igseout.eq.1)then   ! ----------- gse2 format ---

         call init_hdrvars_mtinvers
         hdr_debug    = 4   !  muss wohl groesser als 3 sein ?
         hdr_nsamp    = lx0
          if(ifr.eq.0)then
           hdr_smprate = 1.0 / dt
          else
           hdr_smprate = isampf*dt
          end if

         call add_time_shift(abal) !-add t-shift abal, calculate new date

         hdr_station   = cphas(ie)
         hdr_chan      = '__'//comp(ie)
         if(komp.eq.1)then          ! rad
           hdr_hang    = azi(ie)
           hdr_vang    = 90.0
         else if(komp.eq.2)then     ! ver
           hdr_hang    = -1.
           hdr_vang    = 0.0
         else if(komp.eq.3)then     ! tra
           hdr_hang    = azi(ie)-90.
           hdr_vang    = 90.0
         else if(komp.eq.7)then     ! north
           hdr_hang    = 0.
           hdr_vang    = 90.0
         else if(komp.eq.8)then     ! east
           hdr_hang    = 90.
           hdr_vang    = 90.0
         end if

         hdr_calfac  = BAL*59.6  ! bal * 1E9/2**24
         !........conversion to 24 bit integer field based on micrometer
         do i=1,lx0
          wsynth(i,ie)=wsynth(i,ie)/hdr_calfac
          IBALLA(I)=1.E+9 *wsynth(i,ie)
         end do

         do i1=1,10  ! check free space in character variables
          if(hdr_station(i1:i1).eq.' ')hdr_station(i1:i1)='_'
         end do

         iout = ifil(ikomp(ie))
         call gseout(iout,cbuf,iballa,nchecksum)

        else                ! ----------- 13 bit ascii format ---

         do i=1,lx0
          wsynth(i,ie)=4.999*wsynth(i,ie)/BAL + 5.0001
          IBALLA(I)=10000.*wsynth(i,ie)
         end do
         write(ifil(ikomp(ie)),6001)re(ie)/1000.,ABAL,
     &    komp,lx0,BALMAX,rad*azi(ie)
         write(ifil(ikomp(ie)),6002)(IBALLA(i),i=1,lx0)
         write(ifil(ikomp(ie)),6003)re(ie)/1000.,
     &    sn,se,sz

        end if

      end do
      !..........................  close files
      do i=1,3
       if(nstatc(i).gt.0) close(ifil(i))
      end do

      end do       ! end loop diff. constraints
      
      
456   continue
      close(iout+1)
       
      write(*,*)'Ho finito!'
      write(40,*)'Ho finito!'
      close(40)

111   FORMAT(4I5,5X,'NLAY, MDECK,  ISO,  ISS(4)')
141   FORMAT(20X,3F10.4,5X,'REFL. ZONE')
151   FORMAT(I5,' ZAHL DER SEISMOGRAMME = ZAHL DER DISTANZEN')
161   FORMAT(7F10.3)
171   FORMAT(2F10.4,3F10.6,5X,'V-R - IN TIME - INC')
6001  FORMAT(2F15.5,I5/,I10,5X,E15.4,f15.5,e15.5)
6002  FORMAT(16I5)
6003  FORMAT(4F15.5)
      end

*****************************************************************
*     END PROGRAM VOLPIS
*****************************************************************



      subroutine introvolp  
******************************************************************************
*     Plot VOLPIS drawing
*     S. Cesca, June 2006                                    
****************************************************************************

      write(*,*)'                    VOLPIS'
      write(*,*)'VOlcanic Long Period Inversion for the Source'
      write(*,*)'    S. Cesca, University of Hamburg, 2005'
      write(*,*)''   
      write(*,*)'              ^ ^   VOLPIS   8 '
      write(*,*)'             <* *> -------~~~* '
      write(*,*)'               -      |  |     '
      write(*,*)'             !   !   !  !      '
      write(*,*)''
      write(*,*)''
      write(40,*)'                    VOLPIS'
      write(40,*)'VOlcanic Long Period Inversion for the Source'
      write(40,*)'    S. Cesca, University of Hamburg, 2005'
      write(40,*)''   
      write(40,*)'              ^ ^   VOLPIS   8 '
      write(40,*)'             <* *> -------~~~* '
      write(40,*)'               -      |  |     '
      write(40,*)'             !   !   !  !      '
      write(40,*)''
      write(40,*)''

      return
      end   


      subroutine calmis(ddo,ss,n1max,n2max,n1,calsam,mm)  
******************************************************************************
*     Calculate misfit (L2)
*     S. Cesca, June 2006                                    
****************************************************************************

      IMPLICIT NONE
      integer i,j,n1max,n2max,n1,n2
      integer calsam(n1max)
      real*8  mm,ddo(n1max,n2max),ss(n1max,n2max)
      real*8  dd(n1max,n2max)
      real*8  dmax,dabs,sumnum,sumden

      do i=1,n1
       n2=calsam(n1)
       do j=1,n2
        dd(i,j)=ddo(i,j)
       end do
      end do

      dmax=0
      do i=1,n1
       n2=calsam(n1)
       do j=1,n2
        dabs=abs(dd(i,j))
        if (dabs.ge.dmax) dmax=abs(dd(i,j))
       end do
      end do

      do i=1,n1
       n2=calsam(n1)
       do j=1,n2
        dd(i,j)=dd(i,j)/dmax
        ss(i,j)=ss(i,j)/dmax	
       end do
      end do

      write(*,*)'CALMIS'
      sumnum=0
      sumden=0     
      do i=1,n1
       n2=calsam(n1)
       do j=1,n2
        sumnum=sumnum+((dd(i,j)-ss(i,j))**2)
c        sumden=sumden+((abs(dd(i,j))+abs(ss(i,j)))**2)
	sumden=sumden+((dd(i,j))*(dd(i,j)))
       end do
      end do

      mm=sumnum/sumden
      
      return
      end



      subroutine sforw(sflxx,sfgmatfre,sfnmax,sfwmax,sftmax,sfnstat,
     &                 sfsfun,sfisampf,sfsynth,sfv6istf,sfv6i)  
******************************************************************************
*     Calculate synthetic seismograms for given source and GF
*     S. Cesca, June 2006                                    
****************************************************************************

      IMPLICIT NONE
      integer sflxx,sfnmax,sfwmax,sftmax,sfnstat,sfv6i
      complex*16 sfgmatfre(sfnmax,9,sfwmax/2+1)
      complex*8 sfsfun(9,sftmax)
      complex*16 sfmw(9),sfsfre(sfnmax),sfgw(sfnmax,9)
      complex*16 sfsyntfre(sfnstat,sfwmax)
      complex*16 sfsourfre(9,sfwmax)
      complex*8  sfcsourtim(sfwmax)
      real*8 sfsynttim(sfnmax,sfwmax)
      real*8   sfsynth(sfnmax,sftmax)
      integer sfisampf
      double precision sfv6istf
      integer wri,i,j,k,ti


c      calculate fft of M
c      assign M; save spectra of components of source in sourfre(j,w_i). j=comp, w_i=freq
       do j=1,9
        do wri=1,sfisampf       
         sfcsourtim(wri)=sfsfun(j,wri) 
        end do
	call fork(sfisampf,sfcsourtim,-1.0)
c        do wri=1,sflxx       
        do wri=1,sfisampf       
         sfsourfre(j,wri)=sfcsourtim(wri) 
        end do
       end do
   
c      calculate synthetic spectra in syntfre(i,w_i), i=1..nstat, w_i=freq
       do wri=1,sflxx
c       do wri=1,sfisampf       

        do j=1,9
         sfmw(j)=sfsourfre(j,wri)
         do i=1,sfnstat
          sfgw(i,j)=sfgmatfre(i,j,wri)
         end do
        end do

c        call matmulc(gw,nstat,9,mw,9,1,sfre,nstat,1)
        do i=1,sfnstat
	 sfsfre(i)=(0.0)
	 do k=1,9
	  if (sfv6i.eq.1) then
           if (sfv6istf.ne.0) then
            sfsfre(i)=sfsfre(i)+(sfgw(i,k)*sfmw(k))
           else
            sfsfre(i)=sfsfre(i)+(sfgw(i,k)*real(sfsfun(k,1)))	   
  	   end if
          else
	   sfsfre(i)=sfsfre(i)+(sfgw(i,k)*sfmw(k))
	  end if
	 end do
	end do

	do i=1,sfnstat
         sfsyntfre(i,wri)=sfsfre(i)
        end do
       end do
     
c      calculate ifft of synthetic spectra
       do i=1,sfnstat
        do wri=1,sflxx
         sfcsourtim(wri)=sfsyntfre(i,wri)
	 sfcsourtim(sfisampf-wri+2)=conjg(sfcsourtim(wri))	 
        end do
	call fork (sfisampf,sfcsourtim,+1.0)
        do ti=1,sfisampf
c	 sfsynttim(i,ti)=real(sfcsourtim(ti))
c         sfsynth(i,ti)=sfsynttim(i,ti)
         sfsynth(i,ti)=real(sfcsourtim(ti))
	end do
       end do

      return
      end



*******************************************************
      SUBROUTINE MATMULC(A,la,ca,B,lb,cb,C,lc,cc)
*******************************************************
c     VOLPIS subroutine, S.C.,  7.12.05
c     Product of complex matrices
c     C(a1,a3) = A(a1,a2) x B(a2,a3)
      integer    la,lb,lc,ca,cb,cc
      complex*16 A(la,ca),B(lb,cb),C(lc,cc),app
      integer    i,j,k
 
      write(*,*)'matrix a'
      do i=1,la
       write(*,*)'line ',la
       do j=1,ca
        write(*,*)i,j,A(i,j)
       end do
      end do
      
      write(*,*)'matrix b'
      do i=1,lb
       write(*,*)'line ',lb
       do j=1,cb
        write(*,*)i,j,B(i,j)
       end do
      end do
      
      do i=1,lc
       do j=1,cc
        write(*,*)'term ',i,j
	app=(0.,0.)
	write(*,*)'starting from ',app
        do k=1,ca
         app=app+(A(i,k)*B(k,j))
	 write(*,*)i,j,k,A(i,k),B(k,j),app
	end do
	C(i,j)=app
       end do
      end do
      
      return
      end



c
c     SUBROUTINES FROM MTINVERS:  
c  
*******************************************************
      SUBROUTINE MATMUL1(L,M,N,A,LA,B,MB,C,LC)
******************************************************      
*     CALCULATES C = A*B
      DOUBLE PRECISION A(LA,M), B(MB,N), C(LC,N)
      INTEGER I,J,K

      DO 1 I = 1,L
      DO 1 J = 1,N
	 C(I,J) = 0.D0
	 DO 2 K = 1,M
	    C(I,J) = C(I,J) + A(I,K)*B(K,J)
 2       CONTINUE
 1    CONTINUE
      RETURN
      END

*******************************************************
      SUBROUTINE MATMUL(L,M,N,A,LA,B,MB,C,LC)
******************************************************      
*     CALCULATES C = A*B
      DOUBLE PRECISION A(LA,M), B(MB,N), C(LC,N)
      INTEGER I,J,K

      DO 1 I = 1,L
      DO 1 J = 1,N
	 C(I,J) = 0.D0
	 DO 2 K = 1,M
	    C(I,J) = C(I,J) + A(I,K)*B(K,J)
 2       CONTINUE
 1    CONTINUE
      RETURN
      END

      FUNCTION AMAX(A,N)
      DIMENSION A(1)
      AMAX=A(1)
      DO 10 I=2,N
      IF(A(I)-AMAX) 10,10,9
9     AMAX=A(I)
10    CONTINUE
      RETURN
      END
 
      FUNCTION AMIN(A,N)
      DIMENSION A(1)
      AMIN=A(1)
      DO 10 I=2,N
      IF(A(I)-AMIN) 9,10,10
9     AMIN=A(I)
10    CONTINUE
      RETURN
      END

      SUBROUTINE FORK(LX,CX,SIGNI)
      COMPLEX*8 CX(LX),CARG,CW,CTEMP
      PI=3.14159265
      J=1
      SC=1./FLOAT(LX)
      SC=SQRT(SC)
      DO 5 I=1,LX
      IF(I.GT.J) GOTO 2
      CTEMP=CX(J)*SC
      CX(J)=CX(I)*SC
      CX(I)=CTEMP
2     M=LX/2
3     IF(J.LE.M) GOTO 5
      J=J-M
      M=M/2
      IF(M.GE.1) GOTO 3
5     J=J+M
      L=1
6     ISTEP=2*L
      DO 8 M=1,L
      CARG=CMPLX(0.,1.)*(PI*SIGNI*FLOAT(M-1))/FLOAT(L)
      CW=CEXP(CARG)
      DO 8 I=M,LX,ISTEP
      CTEMP=CW*CX(I+L)
      CX(I+L)=CX(I)-CTEMP
8     CX(I)=CX(I)+CTEMP
      L=ISTEP
      IF(L.LT.LX) GOTO 6
      RETURN
      END

      subroutine filtkaus(dt,f1,f2,ifenster,lx,fil,ifail)

      ! filterkoeff. fil(lx) (lx=pot von 2)
      ! eines kausalen tiefpasses  (einfach rechteck)
      ! %der mit
      ! %rechteck- (ifenster=1) oder cosinusfenster(ifenster=0) 
      ! %getapert wird (noch nicht eingebaut!!!!!!! ). 
      ! Die laenge des filters wird durch die
      ! laenge des fensters lx*dt bestimmt, dt ist die abtastfrequenz.
      ! f2 (in Hz) ist die Grenzferquenz
      ! fuer tiefpass ist f1<=0
      ! ifail = 0, wenn alles ok.

      implicit none

      integer lx,lxx,ifenster
      real dt,f1,f2,w
      real fil(lx) 
      integer ifail
      real pi
      real fnyq,w1,w2,xf,x1,x2,x,xk
      integer n,k

      lxx = lx/2 +1
c     f1 = 0.
      ifail = 0
      pi = 4.*atan(1.)
      fnyq = 1./(2.*dt)
      w2=f2*2.*pi
      w1=f1*2.*pi

      if(dt .le. 0 .or. f2.le.0)then
       write(*,*)'f oder  dt =',dt,' <= 0!'
       ifail=1
       ! end subroutine filtkaus
       return
      end if

      !-----> Tiefpassfilter im Frequenzbereich

       fil(1) =  w2/pi
      ! fil(lx+1) = fil(1)
       x2 = pi*w2/(2.*pi*fnyq) 

       do k = 1,lxx
        w=2.*pi*real(k-1)/(real(lx)*dt)
        ! if (ifenster .eq. 0) fft eines cos-fensters
        !  noch nicht implementiert                  
        ! else fft eines rechtecks
        if(w.ge.w1 .and. w.le.w2)then
         fil(k) = 1.
        else
         fil(k)=0.
        end if
        fil(lx-k+2) = fil(k)
       end do
       

      return
      end 

      subroutine slip(strike,dip,rake,sv,nv,bv)  
******************************************************************************
*
*     Program calculates slip vector, normal vector and b-axis vector
*     from Strike, dip and Rake of Double Couple
*                                         
****************************************************************************
      IMPLICIT NONE
      real*8 nv(3),sv(3),bv(3),strike,dip,rake
 
*     sv,nv und bv aus strike, dip und slip (aki+richards, 1980)

      sv(1) = dcos(rake)*dcos(strike)
     &        +dcos(dip)*dsin(rake)*dsin(strike)
      sv(2) = dcos(rake)*dsin(strike)
     &        -dcos(dip)*dsin(rake)*dcos(strike)
      sv(3) = -dsin(dip)*dsin(rake)

      nv(1) = -dsin(dip)*dsin(strike)
      nv(2) = +dsin(dip)*dcos(strike)
      nv(3) = -dcos(dip)
 
      bv(1) = sv(2)*nv(3) - sv(3)*nv(2) 
      bv(2) = sv(3)*nv(1) - sv(1)*nv(3)
      bv(3) = sv(1)*nv(2) - sv(2)*nv(1)
c     bv(1) = -bv(1) 
c     bv(2) = -bv(2)
c     bv(3) = -bv(3)

      return
      end

      subroutine searchbl1(cname,ilen,ibl)
*     sucht von vorne die erste .ne. ' ' Stelle (ibl)
*     vorandene blanks mit 0-en . 
      implicit none
      integer ilen,ibl,i
      character*50 cname
      i=0
 1    i=i+1
      if(i.gt.ilen) then
       ibl = ilen-1
       goto 2
      end if
      if(cname(i:i).eq.' ')then
       ibl=i-1
       goto 2
      end if
      goto 1
 2    return
      end
      subroutine comment(lll)
****************************************
*     spult input datei weiter auf erste zeile, die nicht pattern 
*     in 1 spalte enthaelt
****************************************
      integer lll 
      character*1 cpat,c1st
      cpat='%'
    1  read(lll,"(a1)",end=2)c1st
       if(cpat.eq.c1st) goto 1
    2  backspace(lll)
      return
      end



***********************************************************
      subroutine mech1(xm,m,xi,xi1,dc,rm,iso,pt)
***********************************************************
*     changes 19.04.93 iso wird zusaetlich uebergeben
*     xm(1) = 0.5*(M22-M11)
*     xm(2) = M12
*     xm(3) = M13
*     xm(4) = M23
*     xm(5) = -1/3 *(0.5(m(1)+m(3)) - m(6))
*     xm(6) = 1/3 *(m(1)+m(3)+m(6))
*     rm; totale seismische Moment nach Silver und Jordan 1982
*         rm = Tensornorm / sqrt(2)
*     iso relative isotrope Quellanteil nach Silver und Jordan 
*         iso = MI**2 / MT**2 
      implicit none
      integer iso
      real xm(6),m(6),xi(3),xi1(3),pt(6)
      real dc,rm

c     m(1)=-xm(1)+xm(5)+xm(6)
      m(1)=-xm(1)-xm(5)+xm(6)
      m(2)=xm(2)
c     m(3)=+xm(1)+xm(5)+xm(6)
      m(3)=+xm(1)-xm(5)+xm(6)
      m(4)=xm(3)
      m(5)=xm(4)
c     m(6)=xm(6)-2.*xm(5)
      m(6)=xm(6)+2.*xm(5)
      call moment1(m,xi,xi1,pt,dc,rm,iso)
      return
      end
      
      SUBROUTINE MOMENT1(M,XI,XI1,PT,DC,SMT,I1)
*
      IMPLICIT NONE
      INTEGER I,J,K,IACT,IPRT,ISWI,ISLI,IMYCRO,I1,I2,I3 
      INTEGER NMA,NMI,NNU,NROT 
      REAL A1(3),A2(3),A3(3),A11(3,3),A22(3,3),A33(3,3),EV(3)
      REAL Z(3,3),Z1(3,3),Z2(3,3),XI(3),ZETA(3),ETA(3),XI1(3),PT(6)
      REAL NV(3),SV(3),BV(3),P(3),T(3),SIG,DEL,GAM,SIG1,DEL1,GAM1
      REAL DELTAI(3),DELTAD(3),DELTAC(3),DELTAV(3),DELTA(3)
      REAL M(6),MCLVD(3,3),MDC(3,3),MTOT(3,3),V(3,3)
      REAL MDC1(3,3),MDC2(3,3),MDC3(3,3)
      REAL RM0,TOL,CODC,COCLVD,XF,FM,FMIN,FMAX,VORZ1,VORZ2
      REAL TRACE,FACT,EMIN,EMAX,DC,CLVD,CODC1,CODC2,CODC3,X1,X2,X3 
      REAL DDUN(3)
      REAL CNI,DELTD1,DELTD2,DELTD3,SMT,SMI,SMD,SMDC
      CHARACTER*1 IC(6),IC2(3)
      CHARACTER*6 LAB1(3)
      CHARACTER*12 LAB2(3)
*
      EQUIVALENCE (IC2,IC(4))
*
      DATA IC/'N','S','B','P','T','N'/
      DATA LAB1,LAB2/'STRIKE',' DIP  ',' RAKE ','COMPRESSION',
     & '  TENSION  ','   NULL    '/,TOL/1.E-3/
*
      DATA CNI/57.295780/
      DATA IPRT/0/
      DATA IACT/0/
      DATA ISWI/1/
      DATA ISLI/0/
      DATA IMYCRO/0/
*
      CALL MTOFI(MTOT,M)
*
* .....Berechnen der Eigenwerte des Momententesors
*
      CALL JACOBI(3,MTOT,DELTA,V,NROT)

*
* ......Berechnen der Eigenwerte des isoropen und des deviatorischen MT
*
      TRACE = DELTA(1) + DELTA(2) + DELTA(3)
      IF(ABS(TRACE).LE.TOL) TRACE = 0.
      DO 11 I=1,3
        DELTAI(I) = TRACE/3.
        DELTAD(I) = DELTA(I)-TRACE/3.
	IF(ABS(DELTAD(I)).LT.0.1*TOL) DELTAD(I) = 0.
	DDUN(I) = DELTAD(I)
 11   CONTINUE
      DELTD1=DELTAD(1)
      DELTD2=DELTAD(2)
      DELTD3=DELTAD(3)
* 
* ....Finden des max. und min deviatorischen Eigenvektors, umsortieren
*
      EMAX = ABS(DELTAD(1))
      EMIN = EMAX
      NMI = 1
      NMA = 1
      DO 2 K = 2,3
       IF(ABS(DELTAD(K)).GE.EMIN) GOTO 3
       EMIN = ABS(DELTAD(K))
       NMI = K
 3     IF(ABS(DELTAD(K)).LE.EMAX) GOTO 2
       EMAX = ABS(DELTAD(K))
       NMA = K
 2    CONTINUE
      NNU = 1
 4    IF(NNU.EQ.NMI .OR. NNU.EQ.NMA) THEN
	NNU = NNU + 1
	GO TO 4
      END IF
      EV(1) = DELTA(NMI)
      EV(2) = DELTA(NNU)
      EV(3) = DELTA(NMA)
      DO I=1,3
       DELTA(I)=EV(I)
      END DO
      EV(1) = DELTAD(NMI)
      EV(2) = DELTAD(NNU)
      EV(3) = DELTAD(NMA)
      DO  I=1,3
       DELTAD(I)=EV(I)
      END DO

*     Seismic Moment after Silver + Jordan

      SMT = (DELTA(1)**2+DELTA(2)**2+DELTA(3)**2)/2.
      SMI = TRACE**2/6.
      SMD = (DELTAD(1)**2+DELTAD(2)**2+DELTAD(3)**2)/2.
      FM = -DELTAD(1)/DELTAD(3)
      SMDC= ((1.-2.*FM)*DELTAD(3))**2
 
* ....Berechnen der Dyaden aus den Eigenvektoren
 
      DO 12 I = 1,3
	A1(I) = V(I,NMI)
	A2(I) = V(I,NNU)
 12     A3(I) = V(I,NMA)
      CALL DIADE(A1,A1,A11,3)
      CALL DIADE(A2,A2,A22,3)
      CALL DIADE(A3,A3,A33,3)
*
* .....3 elemtare Double Coubles
*
      CALL MATADD(1.,A11,-1.,A22,MDC1,3)
      CALL MATADD(1.,A22,-1.,A33,MDC2,3)
      CALL MATADD(1.,A33,-1.,A11,MDC3,3)
      CODC1 = (DELTA(1) - DELTA(2))/3.
      CODC2 = (DELTA(2) - DELTA(3))/3.
      CODC3 = (DELTA(3) - DELTA(1))/3.
      X1 = 1.
      X2 = 1.
      X3 = 1.
      IF(CODC1.LE.0.)THEN
	 CODC1=-1.*CODC1
	 X1 = -1.
      END IF
      IF(CODC2.LE.0.) THEN
	 CODC2 = -1.*CODC2
	 X2 = -1.
      END IF
      IF(CODC3.LE.0.) THEN
	 CODC3 = -1.*CODC3
	 X3 = -1.
      END IF
      DO 19 I=1,3
      DO 19 J = 1,3
        MDC1(I,J) = X1 * MDC1(I,J) 
        MDC2(I,J) = X2 * MDC2(I,J) 
 19     MDC3(I,J) = X3 * MDC3(I,J) 
*
* .....CLVD - ANTEIL + DOUBLE COUPLE
*
      CALL MATADD(2.,A33,-1.,A22,MCLVD,3)
      CALL MATADD(1.,MCLVD,-1.,A11,MCLVD,3)
      CALL MATADD(1.,A33,-1.,A22,MDC,3)
*
*     ........Prozentuale Anteil von DC%  und CLVD%
*
      FM=0.
      FMIN=AMIN1(ABS(DELTAD(1)),ABS(DELTAD(2)),ABS(DELTAD(3)))
      FMAX=AMAX1(ABS(DELTAD(1)),ABS(DELTAD(2)),ABS(DELTAD(3)))
      FM=FMIN/FMAX
      DC=100.*(1.-FM*2.)
c     CLVD=100.*FM*2.
*     ... den Wert dc durch 100 * -e2/max(|e1|,|e3|) belegen
*         sieher Definition Kawakatsu
      fmin = DELTAD(1)
      if(abs(deltad(2)).lt.abs(fmin))fmin = deltad(2)
      if(abs(deltad(3)).lt.abs(fmin))fmin = deltad(3)
      fmin = -fmin
*     ... fmax wie gehabt
c     dc=100.*fmin/fmax
*
* ....Berechnen der Eigenvectoren und seism.  Moment des major DC
*     Hier wird ausgenutzt, dass die Eigenvektoren des totalen 
*     Momententensors und des Major Double Anteils gleich sind
*     Im Grunde doppelt gemoppelt
*
      CALL FGMRTI(SV,NV,BV,RM0,MTOT)
*
*    Nochmal P und T aus SV und NV, da in FGMRTI nicht uebergeben (Z2=P)
*
      CALL FGPAF(SV,NV,P,T)
      DO 22 I=1,3
        Z2(I,1) = P(I)
        Z2(I,2) = T(I)
 22     Z2(I,3) = BV(I)
*
* ....Azimuth (ZETA) und Plunge (ETA) aus slip, normal und T-vector
*
      CALL PAI(ZETA,ETA,SV,NV,BV)
      PT(1)=ZETA(1)
      PT(2)=ETA(1)
      PT(3)=ZETA(2)
      PT(4)=ETA(2)
      PT(5)=ZETA(3)
      PT(6)=ETA(3)
*
* ... Strike, Dip und Rake (XI=SIG) (Z=NV) aus slip, normal und T
* 
      CALL FGI(SIG,DEL,GAM,SV,NV,BV)
      XI(1) = SIG
      XI(2) = DEL
      XI(3) = GAM
      DO 14 I = 1,3
        Z(I,1) = NV(I)
        Z(I,2) = SV(I)
 14     Z(I,3) = BV(I)
* ......auxiliary Plane: SV und NV vertauschen
      CALL FGI(SIG1,DEL1,GAM1,NV,SV,BV)
      XI1(1) = SIG1
      XI1(2) = DEL1
      XI1(3) = GAM1
      DO 15 I = 1,3
        Z1(I,1) = NV(I)
        Z1(I,2) = SV(I)
 15     Z1(I,3) = BV(I)
      
*
* ....................Berechnen des DOUBLE COUPLE MCD aus Eigenvectoren
*                     ist schon mit Dyaden berechnet worden
C     CALL FGMRTF(SV,NV,BV,1.,MDC)
*
*       .........Eigenwerte von DC
      CALL JACOBI(3,MDC,DELTAC,V,NROT)
*
*       .........Eigenwrte von CLVD
      CALL JACOBI(3,MCLVD,DELTAV,V,NROT)
*
* .........Normieren von MDC ind MCLVD mit RM0
*
      FACT = -1.*DELTAD(1)/( DELTAD(1) + DELTAD(3) )
      XF = -1.*DELTAD(1)/DELTAD(3)
      CODC = DELTAD(3)*(1.-2.*XF)
      COCLVD = -1.*DELTAD(1)
      VORZ1 = 1.
      VORZ2 = 1.
      IF(CODC.LT.0.) VORZ1 = -1.
      IF(COCLVD.LT.0.) VORZ2 = -1.
      CODC = VORZ1*CODC
      COCLVD = VORZ2*COCLVD
      IF(ABS(CODC).LE.TOL) VORZ1=0.0
      IF(ABS(COCLVD).LE.TOL) VORZ2=0.0
      DO 16 I=1,3
      DO 17 J=1,3
	MDC(I,J) = VORZ1 * MDC(I,J)
C       MCLVD(I,J) = VORZ2*FACT*MCLVD(I,J)
        MCLVD(I,J) = VORZ2*MCLVD(I,J)
        IF(ABS(MTOT(J,I)).LE.TOL) MTOT(J,I)=0.
        IF(ABS(MDC(J,I)).LE.TOL) MDC(J,I)=0.
        IF(ABS(MCLVD(J,I)).LE.TOL) MCLVD(J,I)=0.
 17   CONTINUE
 16   CONTINUE
 
*     ............Seismic Moment in  (dyne-cm) (if data in counts*s/ym , 
*                                               IMYCRO.eq.1)
      IF(SMI.ge.SMT)THEN
*       .......... Error ?
	GOTO 163
      ELSE IF(SMI.lt.0.001*SMT) THEN
	SMI=0.
      END IF
      IF(SMT.gt. 1.E-12) THEN
       I1=INT(100.*SMI/SMT)
c      I2=INT(100.*SMD/SMT)
c      I3=INT(100.*SMDC/SMT)
      ELSE
       I1=100*1.e+20*(SMI/(1.e+20*SMT))
c      I2=-1
c      I3=-1
      END IF
c     ISO durch TRACE
      I1 = sign(1.,TRACE)*I1
      
 163  CONTINUE
c     IF(IMYCRO.EQ.1) THEN
c       SMT=SQRT(SMT)*1.E14
c       SMI=SQRT(SMI)*1.E14
c       SMD=SQRT(SMD)*1.E14
c       SMDC=SQRT(SMDC)*1.E14
c       RM0=RM0*1.E14
c      ELSE
c       SMT=SQRT(SMT)*1.E20
c       SMI=SQRT(SMI)*1.E20
c       SMD=SQRT(SMD)*1.E20
c       SMDC=SQRT(SMDC)*1.E20
c        RM0=RM0*1.E20
c      END IF
      SMT=SQRT(SMT)
 
      RETURN
      END
      
      SUBROUTINE JACOBI(N,A,D,V,NROT)
C
C $$$$$ CALLS ONLY LIBRARY ROUTINES $$$$$
C
C   JACOBI FINDS ALL EIGENVALUES AND EIGENVECTORS OF THE N BY N REAL
C   SYMMETRIC MATRIX A BY JACOBI'S METHOD.  N MUST BE LESS THAN OR
C   EQUAL TO 50 (DETERMINED BY THE DIMENSIONS OF B AND Z BELOW).
C   THE UNORDERED EIGENVALUES ARE RETURNED IN REAL N VECTOR D AND
C   THE CORRESPONDING EIGENVECTORS ARE IN THE RESPECTIVE COLUMNS OF
C   N BY N REAL MATRIX V.  THE NUMBER OF JACOBI ROTATIONS NEEDED ARE
C   RETURNED IN NROT.  TAKEN FROM LINEAR ALGEBRA, VOLUME II, BY
C   WILKINSON AND REINSCH, 1971, SPRINGER-VERLAG.  THE ALGORITHM
C   IS PUBLISHED (IN ALGOL) BY H. RUTISHAUSER ON PAGES 202-211.
C   CONVERTED TO FORTRAN BY R. BULAND, 30 OCT. 1978.
C
      INTEGER P,Q,P1,P2,Q1,Q2
      DIMENSION A(N,N),D(N),V(N,N),B(50),Z(50)
      N1=N-1
      NN=N*N
C   INITIALIZE ARRAY STORAGE.
      DO 1 P=1,N
      DO 2 Q=1,N
 2    V(P,Q)=0.
      V(P,P)=1.
      B(P)=A(P,P)
      D(P)=B(P)
 1    Z(P)=0.
      NROT=0
C
C   MAKE UP TO 50 PASSES ROTATING EACH OFF DIAGONAL ELEMENT.
C
      DO 3 I=1,50
      SM=0.
      DO 4 P=1,N1
      P1=P+1
      DO 4 Q=P1,N
 4    SM=SM+ABS(A(P,Q))
C   EXIT IF ALL OFF DIAGONAL ELEMENTS HAVE UNDERFLOWED.
      IF(SM.EQ.0.) GO TO 13
      TRESH=0.
      IF(I.LT.4) TRESH=.2*SM/NN
C
C   LOOP OVER EACH OFF DIAGONAL ELEMENT.
C
      DO 5 P=1,N1
      P1=P+1
      P2=P-1
      DO 5 Q=P1,N
      Q1=Q+1
      Q2=Q-1
      G=100.*ABS(A(P,Q))
C   SKIP THIS ELEMENT IF IT HAS ALREADY UNDERFLOWED.
      IF((I.LE.4).OR.(ABS(D(P))+G.NE.ABS(D(P))).OR.
     1 (ABS(D(Q))+G.NE.ABS(D(Q)))) GO TO 6
      A(P,Q)=0.
      GO TO 5
 6    IF(ABS(A(P,Q)).LE.TRESH) GO TO 5
C   COMPUTE THE ROTATION.
      H=D(Q)-D(P)
      IF(ABS(H)+G.EQ.ABS(H)) GO TO 7
      THETA=.5*H/A(P,Q)
      T=1./(ABS(THETA)+SQRT(1.+THETA*THETA))
      IF(THETA.LT.0.) T=-T
      GO TO 14
 7    T=A(P,Q)/H
 14   C=1./SQRT(1.+T*T)
      S=T*C
      TAU=S/(1.+C)
C   ROTATE THE DIAGONAL.
      H=T*A(P,Q)
      Z(P)=Z(P)-H
      Z(Q)=Z(Q)+H
      D(P)=D(P)-H
      D(Q)=D(Q)+H
      A(P,Q)=0.
C   ROTATE THE OFF DIAGONAL.  NOTE THAT ONLY THE UPPER DIAGONAL
C   ELEMENTS ARE TOUCHED.  THIS ALLOWS THE RECOVERY OF MATRIX A LATER.
      IF(P2.LT.1) GO TO 15
      DO 8 J=1,P2
      G=A(J,P)
      H=A(J,Q)
      A(J,P)=G-S*(H+G*TAU)
 8    A(J,Q)=H+S*(G-H*TAU)
 15   IF(Q2.LT.P1) GO TO 16
      DO 9 J=P1,Q2
      G=A(P,J)
      H=A(J,Q)
      A(P,J)=G-S*(H+G*TAU)
 9    A(J,Q)=H+S*(G-H*TAU)
 16   IF(N.LT.Q1) GO TO 17
      DO 10 J=Q1,N
      G=A(P,J)
      H=A(Q,J)
      A(P,J)=G-S*(H+G*TAU)
 10   A(Q,J)=H+S*(G-H*TAU)
C   ROTATE THE EIGENVECTOR MATRIX.
 17   DO 11 J=1,N
      G=V(J,P)
      H=V(J,Q)
      V(J,P)=G-S*(H+G*TAU)
 11   V(J,Q)=H+S*(G-H*TAU)
      NROT=NROT+1
 5    CONTINUE
C   RESET THE TEMPORARY STORAGE FOR THE NEXT ROTATION PASS.
      DO 3 P=1,N
      D(P)=B(P)+Z(P)
      B(P)=D(P)
 3    Z(P)=0.
C
C   ALL FINISHED.  PREPARE FOR EXITING BY RECONSTRUCTING THE UPPER
C   TRIANGLE OF A FROM THE UNTOUCHED LOWER TRIANGLE.
C
 13   DO 12 P=1,N1
      P1=P+1
      DO 12 Q=P1,N
 12   A(P,Q)=A(Q,P)
      RETURN
      END
C    --- INCLUDE CROSS,FIXED,INSOURCE
      SUBROUTINE CROSS(A,B,C)
C
C $$$$$ CALLS NO OTHER ROUTINE $$$$$
C
C   CROSS COMPUTES THE VECTOR PRODUCT C = A X B, WHERE A, B, AND C ARE
C   ALL THREE VECTORS.  PROGRAMMED ON 30 OCT 78 BY R. BULAND.
C
      DIMENSION A(3),B(3),C(3)
      C(1)=A(2)*B(3)-B(2)*A(3)
      C(2)=A(3)*B(1)-B(3)*A(1)
      C(3)=A(1)*B(2)-B(1)*A(2)
      RETURN
      END
C    --- INCLUDE MTOFI,FIXED,INSOURCE
      SUBROUTINE MTOFI(M,G)
C
C $$$$$ CALLS NO OTHER ROUTINE $$$$$
C
      REAL M(3,3),G(3)
      K=0
      DO 2 J=1,3
      DO 2 L=1,J
      K=K+1
      M(L,J)=G(K)
 2    M(J,L)=G(K)
      RETURN
      END
C    --- INCLUDE FGMRTIXY,FIXED,INSOURCE
      SUBROUTINE FGMRTI(S,N,B,M0,M)
C     VERSION FOR X,Y,Z-(NORTH-EAST-DOWN)-COORDINATES
C
C $$$$$ CALLS CROSS, FGPAF, FGPAI, AND JACOBI $$$$$
C
      REAL S(3),N(3),B(3),M0,M(3,3),P(3),T(3),EV(3),VEC(3,3)
C ??? CALL FGPAF(S,N,P,T)
C   DECOMPOSE THE MOMENT TENSOR.
      CALL JACOBI(3,M,EV,VEC,NROT)
C   FIND THE MAXIMUM AND MINIMUM EIGENVALUES.
C   The Eigenvectors of the deviatoric Momenttensor are equivalent to the 
C   Eigenvectors of the composite Momenttensor
      EMAX=EV(1)
      EMIN=EMAX
      NP=1
      NT=1
      DO 2 K=2,3
      IF(EV(K).GE.EMIN) GO TO 3
      EMIN=EV(K)
      NP=K
 3    IF(EV(K).LE.EMAX) GO TO 2
      EMAX=EV(K)
      NT=K
 2    CONTINUE
C   COMPUTE S AND N.
      SP=SIGN(1.,VEC(3,NP))
      ST=SIGN(1.,VEC(3,NT))
      DO 4 K=1,3
      P(K)=-SP*VEC(K,NP)
 4    T(K)=-ST*VEC(K,NT)
      CALL CROSS(P,T,B)
* .......Vgl Jost + Herrmann (19)
C     M0=.5*(EV(NT)-EV(NP))
C     M0=.5*( ABS(EV(NT)) + ABS(EV(NP)) )
      M0=.5*( ABS(EMAX) + ABS(EMIN) )
C     PRINT*,' M0 = ',M0
      CALL FGPAI(S,N,P,T)
      RETURN
      END
C    --- INCLUDE PAIXY,FIXED,INSOURCE
      SUBROUTINE PAI(ZETA,ETA,S,N,B)
C     VERSION FOR X,Y,Z-COORDINATES
C
C $$$$$ CALLS FGPAF $$$$$
C
C $$$$$ THIS ROUTINE IS DEFINED IN A (X,Y,Z) COORDINATE SYSTEM WITH
C       ORIENTATION (NORTH,EAST,DOWN) OTHER THAN THE PREVIOUS COOR-
C       DINATES WITH (UP,SOUTH,EAST). SEE  AKI &RICHARDS P.119FF
C       EXTENDED ON JUNE 1, 1985 BY K.KOCH
C
      REAL ZETA(3),ETA(3),S(3),N(3),B(3),P(3),T(3)
      DATA CNI,TOL,TOL2/57.295780,1E-5,2E-5/
      CALL FGPAF(S,N,P,T)
      DO 2 K=1,3
 2    ZETA(K)=0.
      CE= SIGN(1.,P(3))
      IF(ABS(P(1))+ABS(P(2)).GT.TOL2) ZETA(1)=CNI*ATAN2(CE*P(2),
     1  CE*P(1))
      ETA(1)=CNI*ASIN(CE*P(3))
      CE= SIGN(1.,T(3))
      IF(ABS(T(1))+ABS(T(2)).GT.TOL2) ZETA(2)=CNI*ATAN2(CE*T(2),
     1  CE*T(1))
      ETA(2)=CNI*ASIN(CE*T(3))
      CE= SIGN(1.,B(3))
      IF(ABS(B(1))+ABS(B(2)).GT.TOL2) ZETA(3)=CNI*ATAN2(CE*B(2),
     1  CE*B(1))
      ETA(3)=CNI*ASIN(CE*B(3))
      DO 1 K=1,3
      IF(ZETA(K).LT.0.) ZETA(K)=ZETA(K)+360.
 1    CONTINUE
C   PUT ZETA INTO CANONICAL FORM IF ETA IS NEARLY ZERO.
      IF((ABS(P(3)).LE.TOL).AND.(ZETA(1).GT.180.)) ZETA(1)=ZETA(1)-180.
      IF((ABS(T(3)).LE.TOL).AND.(ZETA(2).GT.180.)) ZETA(2)=ZETA(2)-180.
      IF((ABS(B(3)).LE.TOL).AND.(ZETA(3).GT.180.)) ZETA(3)=ZETA(3)-180.
      RETURN
      END
C    --- INCLUDE FGIXY,FIXED,INSOURCE
      SUBROUTINE FGI(SIG,DEL,GAM,S,N,B)
C     VERSION FOR X,Y,Z-COORDINATES
C
C $$$$$ CALLS ONLY SYSTEM ROUTINES $$$$$
C
C $$$$$ THIS ROUTINE IS DEFINED IN A (X,Y,Z) COORDINATE SYSTEM WITH
C       ORIENTATION (NORTH,EAST,DOWN) OTHER THAN THE PREVIOUS COOR-
C       DINATES WITH (UP,SOUTH,EAST). SEE  AKI &RICHARDS P.115FF
C       EXTENDED ON JUNE 1, 1985 BY K.KOCH
C
      REAL S(3),N(3),B(3)
      DATA CNI/57.295780/
      DEL=ACOS(-N(3))
      SIG=ATAN2(-N(1),N(2))
      GAM=CNI*ATAN2(-S(3)/SIN(DEL),S(2)*SIN(SIG)+S(1)*COS(SIG))
      DEL=CNI*DEL
      SIG=CNI*SIG
      IF(DEL.GT.90.) THEN
        SIG=SIG-180.
        DEL=180.-DEL
        GAM=-GAM
* .....Hier muss rake gedreht werden,da man immer dieselbe Seite der
*      dipping fault betrachtet
        PRINT*,'RAKE UMGEDREHT'
      END IF
      IF(SIG.LT.0.) SIG=SIG+360.
C     IF(GAM.LT.0.) GAM=GAM+360.
      IF(GAM.GT.180.) GAM=GAM-360.
      IF(GAM.LE.-180.) GAM=GAM+360.
      RETURN
      END
C    --- INCLUDE FGPAFXY,FIXED,INSOURCE
      SUBROUTINE FGPAF(S,N,P,T)
C     VERSION FOR X,Y,Z-(NORTH-EAST-DOWN)-COORDINATES
C
C $$$$$ CALLS NO OTHER ROUTINE $$$$$
C
C   THERE ARE TWO FGPAXY ROUTINES.  FGPAFXY CONVERTS THE UNIT VECTORS
C   DEFINING THE FAULT GEOMETRY COORDINATE SYSTEM (SEE SUBROUTINE FGFXY)
C   TO THE UNIT VECTORS DEFINING THE PRINCIPAL AXIS COORDINATE SYSTEM:
C   P, T, AND B.  THESE UNIT VECTORS ARE COLINEAR WITH THE P, T, AND B
C   AXES SUCH THAT P(3)<=0 AND T = B X P (WHERE B = N X S).  B IS NOT
C   NEEDED AS IT IS COMMON TO BOTH SYSTEMS.  FGPAIXY PERFORMS THE IN-
C   VERSE TRANSFORMATION.  PROGRAMMED ON 30 OCT 78 BY R. BULAND.
C   UPDATED ON 11 SEP 1986 BY K.KOCH.
C
      REAL S(3),N(3),P(3),T(3)
      DATA CON/.70710678/
      CN=CON
      IF(N(3)-S(3).GT.0.) CN=-CN
      DO 1 K=1,3
      P(K)=CN*(N(K)-S(K))
 1    T(K)=CN*(N(K)+S(K))
      RETURN
      END
C    --- INCLUDE FGPAIXY,FIXED,INSOURCE
      SUBROUTINE FGPAI(S,N,P,T)
C     VERSION FOR X,Y,Z-(NORTH-EAST-DOWN)-COORDINATES
C
C $$$$$ CALLS NO OTHER ROUTINE $$$$$
C
      REAL S(3),N(3),P(3),T(3)
      DATA CON/.70710678/
      CN=CON
      IF(T(3)+P(3).GT.0.) CN=-CN
      DO 2 K=1,3
      N(K)=CN*(T(K)+P(K))
 2    S(K)=CN*(T(K)-P(K))
      RETURN
      END
C    --- INCLUDE FGMRTF,FIXED,INSOURCE
      SUBROUTINE FGMRTF(S,N,B,M0,M)
C
C $$$$$ CALLS NO OTHER ROUTINE $$$$$
C
C   THERE ARE TWO FGMRT ROUTINES.  FGMRTF CONVERTS THE UNIT VECTORS S
C   AND N (SEE SUBROUTINE FGF) AND THE MOMENT M0 TO A MOMENT TENSOR M.
C   FGMRTI PERFORMS THE INVERSE OPERATION.  PROGRAMMED ON 30 OCT 78 BY
C   R. BULAND.
C
      REAL S(3),N(3),B(3),M0,M(3,3)
      DO 1 K=1,3
      DO 1 J=1,3
 1    M(J,K)=M0*(S(K)*N(J)+S(J)*N(K))
      RETURN
      END
C
      SUBROUTINE MATADD(CA,A,CB,B,C,N)
C  CALCULATES C = aA + bB , C = C(N,N), B=B(N,N), A=A(N,N)
C
      INTEGER N,I,J
      REAL A(N,N), B(N,N), C(N,N),CA,CB
      DO 1 I = 1,N
      DO 1 J = 1,N
 1    C(I,J) = CA*A(I,J) + CB*B(I,J)
      RETURN 
      END
C
      SUBROUTINE DIADE(A,B,AB,N)
C  CALCULATES FROM VECTOR A(N) AND B(N) THE DYADIC AB 
C  LITERATURE: JOST + HERMANN SEISM RESEARCH LETTERS 60, 1989
C
      INTEGER I,J,N
      REAL A(N), B(N), AB(N,N)
      DO 1 I = 1,N
      DO 1 J = 1,N
 1    AB(I,J) = A(I) * B(J)
      RETURN
      END
       
      REAL FUNCTION RD(X)
      REAL X,STELLE
      INTEGER ISTELLE
      DATA ISTELLE / 3 /
*
      STELLE = 10.**ISTELLE
      RD = INT( STELLE * X) / STELLE
      RETURN
      END

      SUBROUTINE SSLIP(SIG,XFACT,XM)
 
*     .......SIG = Azimuth in degree
      IMPLICIT NONE
      INTEGER I,J
      REAL SIG,SIGR,XFACT,XM(3,3),CNI
      DATA CNI/57.295780/
      SIGR = SIG/CNI
      XM(1,1) = -1.*SIN(2*SIGR)
      XM(2,2) = SIN(2*SIGR)
      XM(3,3) = 0.
      XM(1,2) = COS(2.*SIGR)
      XM(2,1) = XM(1,2)
      XM(1,3) = 0.
      XM(3,1) = XM(1,3)
      XM(2,3) = 0.
      XM(3,2) = XM(2,3)
      DO 1 I = 1,3
      DO 1 J = 1,3
 1    XM(I,J) = XFACT*XM(I,J)
      RETURN
      END
       
      SUBROUTINE ISLIP(SIG,XFACT,XM)
 
*     .......SIG = Azimuth in degree
      IMPLICIT NONE
      INTEGER I,J
      REAL SIG,SIGR,XFACT,XM(3,3),CNI
      DATA CNI/57.295780/
      SIGR = SIG/CNI
      XM(1,1) = -1.*SIN(SIGR)**2
      XM(2,2) = -1.*COS(SIGR)**2
      XM(3,3) = 1.
      XM(1,2) = SIN(2.*SIGR)/2.
      XM(2,1) = XM(1,2)
      XM(1,3) = 0.
      XM(3,1) = XM(1,3)
      XM(2,3) = 0.
      XM(3,2) = XM(2,3)
      DO 1 I = 1,3
      DO 1 J = 1,3
 1    XM(I,J) = XFACT*XM(I,J)
      RETURN
      END
       
      SUBROUTINE DSLIP(SIG,XFACT,XM)
 
*     .......SIG = Azimuth in degree
      IMPLICIT NONE
      INTEGER I,J
      REAL SIG,SIGR,XFACT,XM(3,3),CNI
      DATA CNI/57.295780/
      SIGR = SIG/CNI
      XM(1,1) = 0.
      XM(2,2) = 0.
      XM(3,3) = 0.
      XM(1,2) = 0. 
      XM(2,1) = XM(1,2)
      XM(1,3) = SIN(SIGR)
      XM(3,1) = XM(1,3)
      XM(2,3) = -COS(SIGR)
      XM(3,2) = XM(2,3)
      DO 1 I = 1,3
      DO 1 J = 1,3
 1    XM(I,J) = XFACT*XM(I,J)
      RETURN
      END
       
      SUBROUTINE VECDIPO(XFACT,XM)
 
      IMPLICIT NONE
      INTEGER I,J
      REAL XFACT,XM(3,3)
      XM(1,1) = -1./3.
      XM(2,2) = -1./3.
      XM(3,3) = 2./3.
      XM(1,2) = 0. 
      XM(2,1) = XM(1,2)
      XM(1,3) = 0.
      XM(3,1) = XM(1,3)
      XM(2,3) = 0.
      XM(3,2) = XM(2,3)
      DO 1 I = 1,3
      DO 1 J = 1,3
 1    XM(I,J) = XFACT*XM(I,J)
      RETURN
      END
       
      subroutine mdekomp(rdp,rsl,re,rc,iswi)
*******************************************************************************
*     Function:  Program rotates a Tensor given in the mean
*                axis system (3 Eigenvalues) with  
*                STRIKE, DIP and SLIP defined for the  fault plane 
*                of a double couble  (in degree)
*     INPUT: 1) STRIKE, DIP and SLIP
*            2) Three eigenvalues of a Moment-tensor
*     OUTPUT:   Coefficients (RC(6) of rotatet elementary  Momenttensors
*     
*     Language : Fortran
*
*     Used Parameters:
*                       dip (f)   : dip
*                       rake (f)  : rake (all in degree)
*                       e(3)      : Eigenvalues
*                              abs(ev3) > abs(ev1) > abs(ev2) !!
*                       mij       : Moment-tensor elements
*                       c(6)      : Coefficients of elementary sources
*                       iswi      : switch
*
*     Author: Torsten Dahm  7.1991
*
* References: ..................
****************************************************************************** 
      implicit none
      integer  i,iswi
      real rdp,rsl,re(3),rc(6)
      double precision ev(3),c(6)
      double precision y1,y2
      double precision pi
      double precision dip,rake 
      double precision xdc,xclvd

      pi = 4.d0*atan(1.)
      do 11 i=1,3
 11     ev(i) = re(i)
      dip = rdp
      rake = rsl
      if(ev(3).gt.0) rake=rake-180.
      dip = pi*dip/180.
      rake = pi*rake/180.

*     Berechnen der Vorfaktoren

      xdc =  -ev(3) - 2.d0*ev(2)
      xclvd =  3.d0*ev(2)

*     festlegen der Coeffizienten

      y1=-dcos(2.*dip)*dsin(rake)
      y2=-0.5*dcos(2.*dip)*dsin(rake) 
     .                   -0.25*dsin(2.*dip)*dcos(rake)**2
      c(1) = xdc*y1 + xclvd*y2

      y1=-dcos(dip)*dcos(rake)
      y2=-0.5*dcos(dip)*dcos(rake)+0.25*dsin(dip)*dsin(2.*rake)
      c(2) = xdc*y1 + xclvd*y2

      y1=dsin(dip)*dcos(rake)
      y2=0.5*dsin(dip)*dcos(rake)+0.25*dcos(dip)*dsin(2.*rake)
      c(3) = xdc*y1 + xclvd*y2

      y1=dsin(2.*dip)*dsin(rake)
      y2=+0.5*(dsin(dip) + dcos(dip)*dsin(rake))**2
      c(4) = xdc*y1 + xclvd*y2

      c(5)=+0.5*xclvd*dcos(rake)**2

      c(6) = -1.d0*xclvd

      do 18 i=1,6
 18     rc(i)=real(c(i))
      
      return
      end

c------------------------------------------------------------
      subroutine init_hdrvars_mtinvers
c------------------------------------------------------------
      ! INTEGER 
      !  hdr_ifmtnum        ! input format number
      !  hdr_ofmtnum        ! output format number
      !  hdr_idiff          ! number of input differences
      !  hdr_odiff          ! number of output differences
      !  hdr_calunit        ! unit of calibration (0=displ, 1=vel, 2=acc)
      ! REAL    
      !  hdr_smprate        ! sample rate in Hz
      !  hdr_calfac         ! calibration factor
      !  hdr_calper         ! calibration period
      !  hdr_beamaz         ! beam azimuth
      !  hdr_beamslo        ! beam slowness
      !  hdr_hang           ! horizontal orientation
      !  hdr_vang           ! vertical orientation
      ! CHARACTER
      !  hdr_station*10     ! station name
      !  hdr_stadescr*10    ! station/chan description
      !  hdr_chan*3         ! channel name
      !  hdr_instr*6        ! instrument type
      !  hdr_network*9      ! network name
      !  hdr_coosys*12      ! name of coordinate system
      !  hdr_ifmtname*10    ! name of input format
      !  hdr_ofmtname*10    ! name of output format

      include 'codeco_common.f'

      !  hdr_debug = 4      ! debug level
      hdr_ifmtname = 'ascii'
      hdr_ifmtnum  = 0
      hdr_ofmtname = 'CM6' 
      hdr_ofmtnum  = 2   ! gse2 output format
      hdr_odiff    = 2   ! 2fache differenzen
      hdr_idiff    = 0

      hdr_year     = 2000
      hdr_month    = 1
      hdr_day      = 1
      hdr_jday     = 1
      hdr_hour     = 0
      hdr_min      = 0
      hdr_sec      = 0
      hdr_msec     = 0
      hdr_nsamp    = 0
      hdr_ifmtnum  = 0
      hdr_calunit  = 0
      hdr_smprate  = 0.0
      hdr_calfac   = 1.0
      hdr_calper   = 1.0
      hdr_stalat   = -999.0
      hdr_stalon   = -999.0
      hdr_staelev  = -999.0
      hdr_stadepth = -999.0
      hdr_beamaz   = -1.0
      hdr_beamslo  = -1.0
      hdr_hang     = -1.0
      hdr_vang     = -1.0
      hdr_station  = ' '
      hdr_stadescr = 'mtinvers'
      hdr_chan     = '   '
      hdr_instr    = 'unkown'
      hdr_network  = 'unknown'
      hdr_coosys   = 'cartesian'

      return
      end

c---------------------------------------------------
c adopted from H. Dufumier ? 
c---------------------------------------------------
      subroutine add_time_shift(sec) 
      implicit none
      include 'codeco_common.f'
      real sec

      hdr_sec=int(sec)
      hdr_msec=1000.*(sec-float(hdr_sec))
      if (hdr_msec .lt.0) then
           hdr_sec=hdr_sec -1
c --- just in case you worry about the 999: the float to integer
c     operation from above cuts for negative values towards 0
          hdr_msec=999+hdr_msec
      endif
      hdr_min=hdr_min+int(float(hdr_sec)/60.)
      hdr_sec=mod(hdr_sec,60)
      if (hdr_sec .lt.0) then
           hdr_min=hdr_min-1
           hdr_sec=60+hdr_sec
      endif
      hdr_hour=hdr_hour+int(float(hdr_min)/60.)
      hdr_min=mod(hdr_min,60)
      if (hdr_min .lt.0) then
           hdr_hour=hdr_hour-1
           hdr_min=60+hdr_min
      endif
      hdr_jday=hdr_jday+int(float(hdr_hour)/24.)
      hdr_hour=mod(hdr_hour,24)
      if (hdr_hour .lt.0) then
           hdr_jday=hdr_jday-1
           hdr_hour=24+hdr_hour
      endif
      if (hdr_jday.lt.1) then
       hdr_year=hdr_year-1
       call julien(31,12,hdr_year,hdr_jday,1)
      else
       call julien(hdr_day,hdr_month,hdr_year,hdr_jday,0)
      endif
      if  (hdr_debug .gt. 0)  write (*,*) '-- got start time ',
     &   hdr_year, hdr_jday, hdr_hour, hdr_min, hdr_sec,
     &   hdr_msec, sec

      return
      end

**************************************************************************
*
* HERE ARE SOME COMMENTS ON THE ORIGINAL VERSION OF MTINVERS USED AS
* STARTING SCRIPT FOR CODING VOLPIS.
* Some comments on the version used might be useful.
* Original version was coded by T. Dahm
* Some changes have been added by T. Dahm, F. Kruger and S. Cesca
*
* changes: 
* 17.08.05: - komp als real auf USER0 anstatt auf nevid 
* 30.09.00: -Zeilenumbruch in mtinvers.ball und mtinvers.ball1
*           -dispf.a dispf.b, dispf.l anstatt gross R, Z, T
*           -ebenso fuer synth.a, etc.
*           -itap eingefuehrt, um Taper zu steuern
*           - Zeitfenster beginnt jetzt bei iretard (bezogen auf origin),
*            (oder um Taperfenster voher wenn itap negativ)
*            und hat Laenge isamp (etwas laegr wenn itap < 0)
*            Hinter Fenster wird Spur mit Nullen aufgefuellt (vgl. isampf).
*    COSINUS FENSTER und Spuren numerisch testen
*           -Daten werden um iadd Punkte verlaengert
*
********************************************************************************
* Moment tensor inversion code (T. Dahm)
* This code is based on a program that has originally been used
* to estimate parameter of the extended earthquake source.
* In this version, only point source parameter can be estimated.
* No source time function is estimated (step function assumed)
* Also, acoustic emissions event have been analysed with a pre-version 
* of this code. Therefore, some parameter and statements are "commented out"
* or have no meaning for the present version.
*
* Input data are observed displacement seismograms (instrument deconvolved)
* and the corresponding Green functions (e.g. calculated with refgreen).
* Optionally, either waveforms or amplitude spectra are fitted.
* Different constraints can be used: 
*  (0) no constraint (6 moment tensor components)
*  (1) zero isotropic component constraint
*  (2) general dislocation source constraint (shear + tension dislocation)
*  (3) pure tension crack constraint
*  (4) pure double couple constraint
*
* An iterative inversion scheme is used, i.e. a starting model has to 
* be provided.
* For the time domain inversion and case (0) and (1) the inversion problem  
* is linear, and onlz then the starting model is uncritical; in all other
* cases different starting models should be tested to find the absolut 
* minimum misfit solution.
* Note also that the amplitude inversion can never resolve the "sign"
* of the moment tensor, i.e. P and T axes can be interchanged.
* 
* Input paramter are read from screen (or see mtinvers.cmd file).
* Input Files are 1. the controlling file (e.g. retard.dat)
*                 2. the waveforms (files termed  displ.n.k, where
*                    n is either z, n, e, and k is 1,2,3,....)
*                    The component n and numbers k are given in retard.dat
*                 3. the corresponding Green functions (displacement), 
*                    called PS_rSr.r.k, PS_rSz.k, etc. .
*                    Waveforms as well as Green functions are expected in 
*                    a special ascii format going back to Gerhard Muellers 
*                    reflectivity code.
*
* Output Files are:
*                 1. screen output
*                 2. result.best (list of the 10 best solutions)
*                 3. dispf.z, etc., containing filtered observations
*                 4. synth.z, etc, containing final fit solution traces 
*                    both may be plotted with e.g. Seismic Handler
*                 5 mtinvers.ball, psmeca moment tensor input file
*                 6 mtinvers.ball1, psmeca, best double couple input file
******************************************************************
*
*   some internals (not important for user)
*        xm(1) =0.5(M22-M11)      = sin(2sphi)
*        xm(2) =    M12           = cos(2sphi)
*        xm(3) =    M13           = sin(dphi)
*        xm(4) =    M23           = -cos(dphi))
*        xm(5) =1/3(0.5(M22+M11)) = VM
*        xm(6) =1/3(M11+M22+M33)  = Trace/3.
*
*     zu den Komponenten - Anteilen
*   | north |   | cos( azi )  -sin( azi )  |   | rad |
*   |       | = |                          | = |     |
*   | east  |   | sin( azi )   cos( azi )  |   | tra |
*
*   | rad   |   | cos( azi )   sin( azi )  |   | north |
*   |       | = |                          | = |       |
*   | tra   |   |-sin( azi )   cos( azi )  |   | east  |
*
*   | sv |   | cos(azi)*cos(toff)  sin( azi )*cos(toff) -sin(toff)|   |north|
*   | sh | = |-sin(azi)            cos(azi)              0        | = | east|
*   | p  |   | cos(azi)*sin(toff)  sin(azi)*sin(toff)    cos(toff)|   | down|
*
**************************************************************

C******************************************************************************
c#    The following data compression and decompression routines have
c#    been developped by Dr. Shane Ingate and Dr. Ken Muirhead, at the
c#    Australian Seismological Centre, Bureau of Mineral Resources,
c#    Canberra, Australia.
c#    They provided me with these routines in March 1989 during the
c#    session of the Group of Scientific Experts (GSE) in Geneva.
c#    These compression/decompression algorithms are used by all members
c#    of the GSE during the large-scale data exchange experiment GSETT-2,
c#    carried out from 1989 to 1991.
c#    It is recommended to use second differences and the six-bit compression.
c#    The second differences can be computed by two subsequent calls of
c#    subroutine DIF1 (see above).
c#    These routines are already running on many different machines.
c#    Because the AND function is not standard FORTRAN 77, this operation
c#    has been moved to a separate subroutine INTAND. All users of these
c#    routines will have to modify INTAND so that it performs correctly on
c#    their computers.
c#                                 Urs Kradolfer, Swiss Seismological Service
c#
C******************************************************************************
C                                                                       *
C     SUBROUTINE CMPRS6(LX,IX,LC,CBUFF,IERROR)                          *
C                                                                       *
C     ROUTINE TO COMPRESS INTEGER DATA INTO PRINTABLE ASCII CHARACTERS. *
C     INPUTS ARE INTEGER*4 ARRAY IX OF LENGTH LX.                       *
C     LC SHOULD CONTAIN THE DIMENSION OF THE ARRAY CBUFF.               *
C     OUTPUTS ARE CHARACTER*1 ARRAY CBUFF CONTAINING LC CHARACTERS.     * 
C     IF THE ARRAY CBUFF IS NOT LARGE ENOUGH TO CONTAIN ALL OF THE DATA *
C     IERROR IS SET TO -1, OTHERWISE IT IS SET TO ZERO.                 *
C     OUTPUT IS PADDED TO A MULTIPLE OF 80 CHARACTERS USING SPACES.     *
C                                                                       *
C     METHOD OF COMPRESSION IS TO USE THE 6 LEAST SIGNIFICANT SIX BITS  *
C     OF AN EIGHT BIT BYTE SO THAT ALL DATA CAN BE TRANSMITTED AS ASCII *
C     CHARACTERS.                                                       *
C     OF THESE SIX BITS, THE MOST SIGNIFICANT IS USED AS A CONTINUATION *
C     BIT. IF IT IS SET TO ONE THE FOLLOWING BYTE ALSO FORMS PART OF    *
C     THE PRESENT SAMPLE. IF ZERO, THIS IS THE LAST BYTE IN THE SAMPLE. *
C     THE SECOND LEAST SIGNIFICANT BIT IS USED AS A SIGN BIT IN THE     *
C     FIRST BYTE AND FOR DATA IN SUBSEQUENT BYTES (ORIGINAL DATA IS     *
C     FIRST CONVERTED TO SIGN AND MAGNITUDE). ALL OTHER BITS OF FIRST   *
C     AND SUBSEQUENT BYTES FORM THE MAGNITUDE OF THE NUMBER.            *
C                                                                       *
C     TO ENABLE TRANSMISSION OVER AS MANY LINKS AS POSSIBLE DATA IS     *
C     FURTHER TRANSFORMED TO THE CHARACTERS +,-,0 - 9,A - Z, a - z      *
C     USING A LOOKUP TABLE.                                             *
C                                                                       *
C     SUBROUTINES CALLED INTAND (THIS SUBROUTINE IS MACHINE SPECIFIC)   *
C                                                                       *
C     DATA MAY BE DECOMPRESSED USING SUBROUTINE DCOMP6.                 *
C                                                                       *
C************************************************************************ 
C
      SUBROUTINE CMPRS6(LX,IX,LC,CBUFF,IERROR)
      IMPLICIT INTEGER*4 (I-N)
cuk      CHARACTER *1 CBUFF(4),TEMP(4),TEST(4),ACHAR(64),BLANK
cuu91      CHARACTER *1 CBUFF(1),TEMP(4),TEST(4),ACHAR(64),BLANK
      CHARACTER *1 CBUFF(lc),TEMP(4),TEST(4),ACHAR(64),BLANK
cuu91      INTEGER *4 IX(1)
      INTEGER *4 IX(lx)
      EQUIVALENCE (J,TEMP(1)),(TEST,ITEST)
      DATA TEST/'1','2','3','4'/
      DATA ACHAR / '+','-','0','1','2','3','4','5','6','7','8','9','A',
     1 'B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q',
     2 'R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f','g',
     3 'h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w',
     4 'x','y','z'/
      DATA BLANK /' '/
      DATA N4/16/, N5/32/, N5M1/31/, N6/64/, N9/512/, N10/1024/, 
     1 N10M1/1023/, N14/16384/, N15/32768/, N15M1/32767/, N19/524288/, 
     2 N20/1048576/, N20M1/1048575/, N24/16777216/, N25/33554432/, 
     3 N25M1/33554431/, N28/134217728/, N28M1/134217727/
      IERROR = 0
      IMAX = LC
      MFLAG = N5
      IOFF = 0
      DO 60 I = 1,LX
        JN = IX(I)
C       SET NFLAG TO 1 TO POINT TO FIRST ELEMENT IN LOOKUP TABLE
        NFLAG = 1
C
C       SEE IF NUMBER IS -VE IF SO CONVERT TO SIGN AND MAGNITUDE.
C
        IF(JN .LT. 0) THEN
           NFLAG = NFLAG + N4
           JN = -JN
        END IF
        IF(JN .LT. N4) GO TO 50
C        IF HERE, DATA REQUIRES MORE THAN 1 BYTE
         IF(JN .LT. N9) GO TO 40
C         IF HERE, DATA REQUIRES MORE THAN 2 BYTES
          IF(JN .LT. N14) GO TO 30
C          IF HERE, DATA REQUIRES MORE THAN 3 BYTES.
           IF(JN. LT. N19) GO TO 20
C           IF HERE, DATA REQUIRES MORE THAN 4 BYTES.
            IF(JN. LT. N24) GO TO 10
C            IF HERE, DATA REQUIRES MORE THAN 5 BYTES.
             IF(JN .GT. N28M1) JN=N28M1
C            FILL A BYTE IF HERE NUMBER WILL REQUIRE SIX BYTES
             J = JN/N25 + NFLAG + MFLAG
             IOFF = IOFF + 1
             CBUFF(IOFF) = ACHAR(J)
             CALL INTAND(JN,N25M1,JN)
             NFLAG = 1
   10       CONTINUE
C           FIVE CHARACTERS TO GO
            J = JN/N20 + NFLAG + MFLAG
            IOFF = IOFF + 1
            IF (IOFF .GT. IMAX) GO TO 80
            CBUFF(IOFF) = ACHAR(J)
            CALL INTAND(JN,N20M1,JN)
            NFLAG = 1
   20      CONTINUE
C          FOUR CHARACTERS TO GO
           J = JN/N15 + NFLAG + MFLAG
           IOFF = IOFF + 1
           IF (IOFF .GT. IMAX) GO TO 80
           CBUFF(IOFF) = ACHAR(J)
           CALL INTAND(JN,N15M1,JN)
           NFLAG = 1
   30     CONTINUE
C         THREE CHARACTERS TO GO
          J = JN/N10 + NFLAG + MFLAG
          IOFF = IOFF + 1
          IF (IOFF .GT. IMAX) GO TO 80
          CBUFF(IOFF) = ACHAR(J)
          CALL INTAND(JN,N10M1,JN)
          NFLAG = 1
   40    CONTINUE
C        TWO CHARACTERS TO GO
         J = JN/N5 + NFLAG + MFLAG
         IOFF = IOFF + 1
         IF (IOFF .GT. IMAX) GO TO 80
         CBUFF(IOFF) = ACHAR(J)
         CALL INTAND(JN,N5M1,JN)
         NFLAG = 1
   50   CONTINUE
C       ONE CHARACTER TO GO
        J = JN + NFLAG
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 80
        CBUFF(IOFF) = ACHAR(J)
   60 CONTINUE
C     NOW MAKE OUTPUT BUFFER UP TO A MULTIPLE OF 80 CHARACTERS
C     WITH BLANKS
      K = 80 - (IOFF - ((IOFF/80) * 80))
      IF (K .LT. 2) K = K + 80
C     PUT IN AT LEAST TWO ADJACENT SPACE CHARACTERS TO ASSIST IN
C     DECODING
      DO 70 I = 1, K
         IOFF = IOFF + 1
         IF (IOFF .GT. IMAX) GO TO 80
         CBUFF(IOFF) = BLANK
   70 CONTINUE
   80 CONTINUE
      LC = IOFF
      IF (IOFF .GT. IMAX) THEN
         LC = IMAX
         IERROR = -1
      ENDIF
      RETURN
      END
C******************************************************************
C                                                                 *
C     SUBROUTINE CMPRS7(LX,IX,LC,CBUFF,IERROR)                    *
C                                                                 *
C     ROUTINE TO WORD-COMPRESS DATA INTO 7 BIT BYTES.             *
C     INPUTS ARE INTEGER*4 ARRAY IX CONTAINING LX VALUES TO BE    *
C     COMPRESSED INTO 7 BIT BYTES. THE MOST SIGNIFICANT BIT OF    *
C     EACH BYTE IS NOT USED.                                      *
C     ON ENTRY LC SHOULD CONTAIN DIMENSIONED LENGTH OF CBUFF.     *
C     OUTPUTS ARE CHARACTER*1 ARRAY CBUFF WITH LC MODIFIED TO     * 
C     REFLECT THE NUMBER OF BYTES WHICH HAVE BEEN PUT INTO CBUFF. *
C     LC IS MADE A MULTIPLE OF 80 USING UNIQUE FILL CHARACTERS.   *
C     IF CBUFF IS TOO SMALL TO CONTAIN ALL COMPRESSED DATA        *
C     IERROR WILL CONTAIN -1 OTHERWISE IT WILL BE SET TO ZERO.    *
C     METHODOLOGY IS THAT THE MOST SIGNIFICANT BIT OF EACH BYTE   *
C     IS SET TO ONE IF NEXT BYTE CONTAINS INFORMATION PERTAINING  *
C     TO THE SAME SAMPLE. IN THE FIRST BYTE PERTAINING TO EACH    *
C     SAMPLE, THE SECOND MOST SIGNIFICANT BIT IS USED AS A SIGN   *
C     BIT. THE LEAST SIGNIFICANT 5 BITS OF THE FIRST BYTE AND     *
C     THE LEAST SIGNIFICANT SIX BITS OF ANY SUBSEQUENT BYTE       *
C     PERTAINING TO THE SAME SAMPLE ARE COMPRESSED TOGETHER ON    *
C     DECODING TO GIVE THE MAGNITUDE OF THE SAMPLE.               * 
C     USING THIS COMPRESSION SCHEME THE CODES                     *
C     1000000  1000000  AND 1000000  0000001 WOULD NOT NORMALLY BE*
C     TRANSMITTED (AKIN TO NOT TRANSMITTING LEADING ZEROS).       *
C     THESE TWO PATTERNS ARE USED AS CONTROL PATTERNS.            *
C     THE PATTERN 1000000 1000000 SIGNIFIES THE END OF THE DATA   *
C     AND IS USED TO FILL UP TO A MULTIPLE OF EIGHTY CHARACTERS.  *
C     THE PATTERN 1000000  0000001 INDICATES THAT 32 SHOULD BE    *
C     SUBTRACTED FROM THE PREVIOUS SAMPLE. USING THIS METHODOLOGY,*
C     ANY CONTROL CHARACTER WITH INTEGER VALUE LESS THAN 32       *
C     WHICH A COMMUNICATION LINK WONT ACCEPT CAN BE MODIFIED BY   *
C     ADDING 32 TO IT. THE 32 WILL BE SUBTRACTED ON DECOMPRESSION.*
C     DATA MAY BE DECOMPRESSED USING SUBROUTINE DCOMP7.           *
C                                                                 *
C     SUBROUTINES CALLED   ---   INTAND   ---   CHEKBT   ---      * 
C                                                                 *
C******************************************************************
C
      SUBROUTINE CMPRS7(LX,IX,LC,CBUFF,IERROR)
      IMPLICIT INTEGER*4 (I-N)
cuk      CHARACTER*1 CBUFF(4),TEMP(4),TEST(4),NCNTRL
cuu91      CHARACTER*1 CBUFF(1),TEMP(4),TEST(4),NCNTRL
      CHARACTER*1 CBUFF(lc),TEMP(4),TEST(4),NCNTRL
cuu91      INTEGER *4 IX(*)
      INTEGER *4 IX(lx)
      EQUIVALENCE (J,TEMP),(TEST,ITEST)
      DATA TEST/'1','2','3','4'/
      DATA N5/32/,
     *     N6/64/,        N6M1/63/,
     *     N11/2048/,
     *     N12/4096/,     N12M1/4095/,
     *     N17/131072/,
     *     N18/262144/,   N18M1/262143/,
     *     N23/8388608/,
     *     N24/16777216/, N24M1/16777215/,
     *     N27/134217728/,N27M1/134217727/
C
C     WORK OUT WHICH WAY BYTES ARE STORED IN A COMPUTER WORD
      IBYTE = 4
      IF(ITEST.EQ.(((52*256+51)*256+50)*256+49)) IBYTE = 1
C
      NCNTRL = CHAR(64)
C     NCNTRL IS A 7 BIT BYTE WITH BIT PATTERN 1000000
      MFLAG = N6
      IMAX = LC
      IERROR = 0
      IOFF = 0
      DO 100 II = 1,LX
        IONLY = 0
        JN = IX(II)
C
C       GET SIGN AND MAGNITUDE OF SAMPLE
C
        NFLAG = 0
        IF(JN .LT. 0) THEN
           NFLAG = N5
           JN = -JN
        END IF
        IF(JN .LT. N5) GO TO 40
         IONLY = 1
C        IF HERE, DATA REQUIRES MORE THAN 1 BYTE
         IF(JN .LT. N11) GO TO 30
C         IF HERE, DATA REQUIRES MORE THAN 2 BYTES
          IF(JN. LT. N17) GO TO 20
C          IF HERE, DATA REQUIRES MORE THAN 3 BYTES.
           IF(JN. LT. N23) GO TO 15
C           IF HERE, DATA REQUIRES MORE THAN 4 BYTES.
            IF(JN. GT. N27M1) JN=N27M1
C           FILL A BYTE
            J = JN/N24 + NFLAG + MFLAG
            IOFF = IOFF + 1
            IF (IOFF .GT. IMAX) GO TO 120
            CBUFF(IOFF) = TEMP(IBYTE)
            CALL INTAND(JN,N24M1,JN)
            NFLAG = 0
   15      CONTINUE
C          FOUR MORE BYTES TO GO
           J = JN/N18 + NFLAG + MFLAG
           IOFF = IOFF + 1
           IF (IOFF .GT. IMAX) GO TO 120
           CBUFF(IOFF) = TEMP(IBYTE)
           CALL INTAND(JN,N18M1,JN)
           NFLAG = 0
   20     CONTINUE
C         THREE MORE BYTES TO GO
          J = JN/N12 + NFLAG + MFLAG
          IOFF = IOFF + 1
          IF (IOFF .GT. IMAX) GO TO 120
          CBUFF(IOFF) = TEMP(IBYTE)
          CALL INTAND(JN,N12M1,JN)
          NFLAG = 0
   30    CONTINUE
C        TWO MORE BYTES TO GO
         J = JN/N6 + NFLAG + MFLAG
         IOFF = IOFF + 1
         IF (IOFF .GT. IMAX) GO TO 120
         CBUFF(IOFF) = TEMP(IBYTE)
         CALL INTAND(JN,N6M1,JN)
         NFLAG = 0
   40   CONTINUE
C       ONE MORE BYTE TO GO
        J = JN + NFLAG
C       CHECK AND MODIFY BYTE IF IT CANNOT BE TRANSMITTED
        CALL CHEKBT(TEMP(IBYTE),NSTAT,IBYTE)
C       IF CHARACTER HAS BEEN MODIFIED AND ONLY ONE CHARACTER IN WORD
C       NEED A CHARACTER WITH A CONTINUE BIT - CHECK AND PUT IN IF
C       REQUIRED
        IF (NSTAT .NE. 0) THEN
          IF(IONLY .EQ. 0) THEN
             IOFF = IOFF + 1
             IF (IOFF .GT. IMAX) GO TO 120
             CBUFF(IOFF) = CHAR(64)
          ENDIF
        ENDIF
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = TEMP(IBYTE)
        IF (NSTAT .EQ. 0) GO TO 100
C       CHARACTER WAS MODIFIED PUT OUT THE CODE 1000000 0000001 TO
C       INDICATE THAT IT WAS
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = NCNTRL
        J = 1
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = TEMP(IBYTE)
  100 CONTINUE
C     FINISHED COMPRESSING NOW MAKE UP TO A MULTIPLE OF 80 CHARACTERS
C     FIND OUT HOW MANY CHARACTERS TO PUT IN
      K = 80 - (IOFF - ((IOFF/80) * 80))
      IF (K .LT. 2) K = K + 80
C     FILL TO A MULTIPLE OF 80 CHARACTERS WITH REPEATS OF 
C     THE BIT PATTERN 1000000
      DO 110 I = 1,K
         IOFF = IOFF + 1
         IF(IOFF .GT. IMAX) GO TO 120
         CBUFF(IOFF) = NCNTRL
  110 CONTINUE
  120 CONTINUE
      LC = IOFF
      IF (IOFF .GT. IMAX) THEN
         LC = IMAX
         IERROR = -1
      ENDIF
      RETURN
      END
C******************************************************************
C                                                                 *
C     SUBROUTINE CMPRS8(LX,IX,LC,CBUFF,IERROR)                    *
C                                                                 *
C     ROUTINE TO WORD-COMPRESS DATA INTO 8 BIT BYTES.             *
C     INPUTS ARE INTEGER*4 ARRAY IX CONTAINING LX VALUES TO BE    *
C     COMPRESSED INTO 8 BIT BYTES.                                *
C     ON ENTRY LC SHOULD CONTAIN DIMENSIONED LENGTH OF CBUFF.     *
C     OUTPUTS ARE CHARACTER*1 ARRAY CBUFF WITH LC MODIFIED TO     * 
C     REFLECT THE NUMBER OF BYTES WHICH HAVE BEEN PUT INTO CBUFF. *
C     LC IS MADE A MULTIPLE OF 80 USING UNIQUE FILL CHARACTERS.   *
C     IF CBUFF IS TOO SMALL TO CONTAIN ALL COMPRESSED DATA        *
C     IERROR WILL CONTAIN -1 OTHERWISE IT WILL BE SET TO ZERO.    *
C     METHODOLOGY IS THAT THE MOST SIGNIFICANT BIT OF EACH BYTE   *
C     IS SET TO ONE IF NEXT BYTE CONTAINS INFORMATION PERTAINING  *
C     TO THE SAME SAMPLE. IN THE FIRST BYTE PERTAINING TO EACH    *
C     SAMPLE, THE SECOND MOST SIGNIFICANT BIT IS USED AS A SIGN   *
C     BIT. THE LEAST SIGNIFICANT 6 BITS OF THE FIRST BYTE AND     *
C     THE LEAST SIGNIFICANT SEVEN BITS OF ANY SUBSEQUENT BYTE     *
C     PERTAINING TO THE SAME SAMPLE ARE COMPRESSED TOGETHER ON    *
C     DECODING TO GIVE THE MAGNITUDE OF THE SAMPLE.               * 
C     USING THIS COMPRESSION SCHEME THE CODES                     *
C     10000000 10000000 AND 10000000 00000001 WOULD NOT NORMALLY  *
C     BE TRANSMITTED (AKIN TO NOT TRANSMITTING LEADING ZEROS)     *
C     THESE TWO PATTERNS ARE USED AS CONTROL PATTERNS.            *
C     THE PATTERN 10000000 10000000 SIGNIFIES THE END OF THE DATA *
C     AND IS USED TO FILL UP TO A MULTIPLE OF EIGHTY CHARACTERS.  *
C     THE PATTERN 10000000 0000001 INDICATES THAT 32 SHOULD BE    *
C     SUBTRACTED FROM THE PREVIOUS SAMPLE. USING THIS METHODOLOGY *
C     ANY CONTROL CHARACTER WHICH A COMMUNICATION LINK WONT ACCEPT*
C     CAN BE MODIFIED BY ADDING 32 TO IT. THE 32 WILL BE SUB-     *
C     TRACTED ON DECOMPRESSION                                    *
C     DATA MAY BE DECOMPRESSED USING SUBROUTINE DCOMP8            *
C                                                                 *
C     SUBROUTINES CALLED   ---   INTAND   ---   CHEKBT   ---      * 
C                                                                 *
C******************************************************************
C
      SUBROUTINE CMPRS8(LX,IX,LC,CBUFF,IERROR)
      IMPLICIT INTEGER *4 (I-N)
cuk      CHARACTER *1 CBUFF(4),TEMP(4),TEST(4),NCNTRL
cuu91      CHARACTER *1 CBUFF(1),TEMP(4),TEST(4),NCNTRL
      CHARACTER *1 CBUFF(lc),TEMP(4),TEST(4),NCNTRL
cuu91      INTEGER *4 IX(*)
      INTEGER *4 IX(lx)
      EQUIVALENCE (J,TEMP),(TEST,ITEST)
      DATA TEST/'1','2','3','4'/
      DATA N5/32/,
     *     N6/64/,
     *     N7/128/,       N7M1/127/,
     *     N12/4096/,
     *     N13/8192/,
     *     N14/16384/,    N14M1/16383/,
     *     N19/524288/,
     *     N20/1048576/,
     *     N21/2097152/,  N21M1/2097151/,
     *     N26/67108864/, N28M1/268435455/
      IBYTE = 4
C     WORK OUT WHICH WAY BYTES ARE STORED IN COMPUTER
      IF(ITEST .EQ. (((52*256+51)*256+50)*256+49)) IBYTE = 1
      J = N7 
      NCNTRL = TEMP(IBYTE)
C     NCNTRL IS AN EIGHT BIT BYTE WITH BIT PATTERN 10000000
C
      MFLAG = N7
      IOFF = 0
      IMAX = LC
      IERROR = 0 
      DO 100 II = 1,LX
        IFIX = 0
        JN = IX(II)
C
C       SEE IF NUMBER IS -VE.
C
        NFLAG = 0
        IF(JN .LT. 0) THEN
           NFLAG = N6
           JN = -JN
        END IF
        IF(JN .LT. N6) GO TO 40
C        IF HERE, DATA REQUIRES MORE THAN 1 BYTE
         IF(JN. LT. N13) GO TO 30
C         IF HERE, DATA REQUIRES MORE THAN 2 BYTES
          IF(JN. LT. N20) GO TO 20
C          IF HERE, DATA REQUIRES MORE THAN THREE BYTES
           IF(JN. GT. N28M1) JN = N28M1
C          FILL A BYTE
           J = JN/N21 + NFLAG + MFLAG
           IOFF = IOFF + 1
           IF (IOFF .GT. IMAX) GO TO 120
           CBUFF(IOFF) = TEMP(IBYTE)
           CALL INTAND(JN,N21M1,JN)
           NFLAG = 0
   20     CONTINUE
C         IF HERE, DATA REQUIRES THREE MORE BYTES
          J = JN/N14 + NFLAG + MFLAG
          IOFF = IOFF + 1
          IF (IOFF .GT. IMAX) GO TO 120
          CBUFF(IOFF) = TEMP(IBYTE)
          CALL INTAND(JN,N14M1,JN)
          NFLAG = 0
   30    CONTINUE
C        IF HERE, DATA REQUIRES TWO MORE BYTES
         J = JN/N7 + NFLAG + MFLAG
         IOFF = IOFF + 1
         IF (IOFF .GT. IMAX) GO TO 120
         CBUFF(IOFF) = TEMP(IBYTE)
         CALL INTAND(JN,N7M1,JN)
         NFLAG = 0
   40   CONTINUE
C       FILL IN LAST REMAINING BYTE
        J = JN + NFLAG
C       CHECK AND MODIFY BYTE IF IT CANNOT BE TRANSMITTED
        CALL CHEKBT(TEMP(IBYTE),NSTAT,IBYTE)
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = TEMP(IBYTE)
        IF(NSTAT .EQ. 0) GO TO 100
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = NCNTRL
        J = 1
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = TEMP(IBYTE)
  100 CONTINUE
C     FINISHED COMPRESSING NOW MAKE UP TO A MULTIPLE OF 80 CHARACTERS
C     FIND HOW MANY CHARACTERS TO PUT IN
      K = 80 - (IOFF - ((IOFF/80) * 80))
      IF (K .LE. 2) K = K + 80
C     NEED AT LEAST TWO NCNTRL CHARACTERS TOGETHER FOR UNIQUENESS
      DO 110 I = 1,K
         IOFF = IOFF + 1
         IF (IOFF .GT. IMAX) GO TO 120
         CBUFF(IOFF) = NCNTRL
  110 CONTINUE
  120 CONTINUE
      LC = IOFF 
      IF ( IOFF .GT. IMAX) THEN
        LC = IMAX
        IERROR = -1
      ENDIF
      RETURN
      END
C***********************************************************************
C                                                                      *
C     SUBROUTINE DCOMP6(LB,IBUF,LOUT,IOUT,IERROR)                      *
C                                                                      *
C     SUBROUTINE DECOMPRESS INTEGER DATA THAT HAS BEEN COMPRESSED      *
C     INTO ASCII CHARACTERS AND RETURNS VALUES IN INTEGER *4 FORMAT    *
C     SEE SUBROUTINE CMPRS6 FOR COMPRESSION FORMAT                     *
C     INPUT - IBUF AN ARRAY OF CONTAINING  LB CHARACTERS.              *
C     LOUT SHOULD CONTAIN THE DIMENSION OF THE INTEGER *4 ARRAY IOUT.  * 
C     ON RETURN ARRAY LOUT WILL BE SET TO CONTAIN THE NUMBER OF INTEGER*
C     VALUES WHICH HAVE BEEN PUT IN THE ARRAY IOUT.                    *
C     IF THE ARRAY IOUT IS NOT LARGE ENOUGH TO CONTAIN ALL OF THE      *
C     DECOMPRESSED VALUES IERROR WILL BE SET TO -1 OTHERWISE IT WILL   *
C     SET TO ZERO                                                      *
C***********************************************************************
C
      SUBROUTINE DCOMP6(LB,IBUF,LOUT,IOUT,IERROR)
      IMPLICIT INTEGER *4 (I-N)
cuk      INTEGER *4 IOUT(*),ICHAR(128)
cuu91      INTEGER *4 IOUT(1),ICHAR(128)
      INTEGER *4 IOUT(lout),ICHAR(128)
cuu91      CHARACTER *1 IBUF(1), ACHAR(4), TEST(4)
      CHARACTER *1 IBUF(lb), ACHAR(4), TEST(4)
      CHARACTER *1 ASPACE,LFEED,CRETN
      EQUIVALENCE (INN,ACHAR),(ITEST,TEST)
      DATA TEST/'1','2','3','4'/
      data ichar/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     1 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     2 0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,2,
     3 3,4,5,6,7,8,9,10,11,0,0,0,0,0,0,0,
     4 12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,
     5 28,29,30,31,32,33,34,35,36,37,0,0,0,0,0,0,
     6 38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,
     7 54,55,56,57,58,59,60,61,62,63,0,0,0,0,0,0/
      IERROR = 0
      CRETN = CHAR(13)
      LFEED = CHAR(10)
      ASPACE = CHAR(32)
      IMAX = LOUT
      ISIGN = 16
      IOFLOW = 32
      MASK1 = 15
      MASK2 = 31
C     WORK OUT WHICH WAY BYTES ARE STORED IN COMPUTER
      IBYTE = 4
      IF (ITEST.EQ.(((52*256+51)*256+50)*256+49)) IBYTE = 1
      ICOUNT = 0
      I = 0
      J = 0
C     START OF DECODING
   1  CONTINUE
        I = I + 1
        ACHAR(IBYTE) = IBUF(I)
C       IF A CARRIAGE OR LINE FEED IGNORE, IF A SPACE THEN END OF DATA
        IF (ACHAR(IBYTE) .EQ. CRETN) GO TO 1 
        IF (ACHAR(IBYTE) .EQ. LFEED) GO TO 1 
        IF (ACHAR(IBYTE) .EQ. ASPACE) GO TO 5
        ICOUNT = ICOUNT + 1
C       STRIP OFF ANY HIGHER ORDER BITS
        CALL INTAND(INN,127,K)
C       GET NUMBER REPRESENTION OF INPUT CHARACTER
        INN = ICHAR(K)
C       GET SIGN BIT
        CALL INTAND(INN,ISIGN,JSIGN)
C       GET CONTINUATION BIT (IF ANY)
        CALL INTAND(INN,IOFLOW,JOFLOW)
C       REMOVE BITS WE DONT WANT
        CALL INTAND(INN,MASK1,ITEMP)
   2    CONTINUE
          IF(JOFLOW.EQ.0) GO TO 4
C         THERE IS ANOTHER BYTE IN THIS SAMPLE
          ITEMP = ITEMP * 32
   3        CONTINUE
            I = I + 1
            ACHAR(IBYTE) = IBUF(I)
          IF (ACHAR(IBYTE) .EQ. CRETN) GO TO 3 
          IF (ACHAR(IBYTE) .EQ. LFEED) GO TO 3 
          ICOUNT = ICOUNT + 1
C         STRIP OFF ANY HIGHER ORDER BITS
          CALL INTAND(INN,127,K)
          INN = ICHAR(K)
C         GET CONTINUATION BIT (IF ANY)
          CALL INTAND(INN,IOFLOW,JOFLOW)
          CALL INTAND(INN,MASK2,K)
          ITEMP = ITEMP + K
        GO TO 2
   4    CONTINUE
        IF (JSIGN.NE.0) ITEMP = -ITEMP
        J = J +1
        IF (J .GT. IMAX) GO TO 5
        IOUT(J) = ITEMP
      IF(ICOUNT.LT.LB) GO TO 1
   5  CONTINUE
      LOUT = J
      IF (J .GT. IMAX) THEN
         LOUT = IMAX
         IERROR = -1
      ENDIF
      RETURN
      END
C************************************************************************
C                                                                       *
C     SUBROUTINE DCOMP7(LB,IBUF,LOUT,IOUT,IERROR)                       *
C                                                                       *
C     SUBROUTINE DECOMPRESS INTEGER DATA THAT HAS BEEN COMPRESSED       *
C     INTO 7 BIT CHARACTERS AND RETURNS VALUES IN INTEGER *4 FORMAT.    *
C     SEE SUBROUTINE CMPRS7 FOR COMPRESSION FORMAT.                     *
C     INPUT - IBUF AN ARRAY OF CHARACTERS OF LENGTH LB.                 *
C     LOUT SHOULD CONTAIN THE LENGTH OF THE INTEGER *4 OUTPUT ARRAY IOUT*
C     ON RETURN ARRAY IOUT WILL CONTAIN LOUT INTEGER VALUES.            *
C     IF THE ARRAY IOUT WAS LARGE ENOUGH TO CONTAIN ALL CONVERTED       *
C     VALUES, IERROR WILL CONTAIN ZERO. IF NOT IT WILL BE SET TO -1     *
C                                                                       *
C************************************************************************
C
      SUBROUTINE DCOMP7(LB,IBUF,LOUT,IOUT,IERROR)
      IMPLICIT INTEGER *4 (I-N)
cuk      INTEGER *4 IOUT(*)
cuu91      INTEGER *4 IOUT(1)
      INTEGER *4 IOUT(lout)
cuu91      CHARACTER *1 IBUF(1),ACHAR(4),TEST(4)
      CHARACTER *1 IBUF(lb),ACHAR(4),TEST(4)
      EQUIVALENCE (INN,ACHAR),(ITEST,TEST)
      DATA TEST/'1','2','3','4'/
      DATA ISIGN/32/, IOFLOW/64/, MASK1/31/, MASK2/63/
      DATA ICORR/32/, MASK3/127/, NCNTRL/64/
C     WORK OUT WHICH WAY BYTES ARE STORED IN COMPUTER
      IBYTE = 4
      IF (ITEST.EQ.(((52*256+51)*256+50)*256+49)) IBYTE = 1
      I = 0
      J = 0
      IMAX = LOUT
C     START OF DECODING
   1  CONTINUE
        IEND = 0
        I = I + 1
        ACHAR(IBYTE) = IBUF(I)
C       REMOVE MOST SIGNIFICANT BIT - NOT USED
        CALL INTAND(INN,MASK3,INN)
C       TEST IF CHARACTER IS EQUAL TO NCNTRL
        IF (INN .EQ. NCNTRL) IEND =  1
C       GET SIGN BIT
        CALL INTAND(INN,ISIGN,JSIGN)
C       GET CONTINUATION BIT
        CALL INTAND(INN,IOFLOW,JOFLOW)
C       REMOVE SIGN AND CONTINUATION BITS
        CALL INTAND(INN,MASK1,ITEMP)
   2    CONTINUE
        IF(JOFLOW .EQ. 0) GO TO 3
C       THERE IS ANOTHER BYTE IN THIS SAMPLE
        I = I + 1
        ACHAR(IBYTE) = IBUF(I)
C       REMOVE MOST SIGNIFICANT BIT - NOT USED
        CALL INTAND(INN,MASK3,INN)
C       TEST IF CHARACTER IS EQUAL TO NCNTRL 
        IF (IEND .EQ. 1) THEN
           IF (INN .EQ. NCNTRL) GO TO 4
C          BIT PATTERN 1000000 FOLLOWED BY 1000000 MEANS END OF DATA
C          SEE IF PREVIOUS SAMPLE HAS TO BE MODIFIED
            IF (INN .LT. 16) THEN
               ITEMP = ICORR
C              SUBTRACT CORRECTION FROM PREVIOUS SAMPLE
               IF (IOUT(J) .LT. 0) ITEMP = -ITEMP
               IOUT(J) = IOUT(J) - ITEMP
               GO TO 1
           ENDIF
      ENDIF
      IEND = 0
C     GET CONTINUATION BIT
      CALL INTAND(INN,IOFLOW,JOFLOW)
      CALL INTAND(INN,MASK2,K)
C     SHIFT WHAT WE HAVE 6 BITS LEFT AND ADD IN NEW BITS
      ITEMP = ITEMP * 64 + K
      GO TO 2
   3  CONTINUE
      IF(JSIGN .NE. 0) ITEMP = -ITEMP
      J = J + 1
      IF (J .GT. IMAX) GO TO 4
      IOUT(J) = ITEMP
      IF(I. LT. LB) GO TO 1
   4  CONTINUE
      LOUT = J
      IF (J .GT. IMAX) THEN
         LOUT = IMAX
         IERROR = -1
      ENDIF
      RETURN
      END
C************************************************************************
C     SUBROUTINE DCOMP8(LB,IBUF,LOUT,IOUT,IERROR)                       *
C     SUBROUTINE DECOMPRESS INTEGER DATA THAT HAS BEEN COMPRESSED       * 
C     INTO 8 BIT CHARACTERS AND RETURNS VALUES IN INTEGER *4 FORMAT.    *
C     SEE SUBROUTINE CMPRS8 FOR COMPRESSION FORMAT.                     *
C     INPUT - IBUF AN ARRAY OF CHARACTERS OF LENGTH LB.                 *
C     LOUT SHOULD CONTAIN THE LENGTH OF THE INTEGER *4 OUTPUT ARRAY IOUT*
C     ON RETURN ARRAY IOUT WILL CONTAIN LOUT INTEGER VALUES.            *
C     IF THE ARRAY IOUT WAS LARGE ENOUGH TO CONTAIN ALL CONVERTED       *
C     VALUES IERROR WILL CONTAIN ZERO. IF NOT IT WILL BE SET TO -1      *
C************************************************************************
      SUBROUTINE DCOMP8(LB,IBUF,LOUT,IOUT,IERROR)
      IMPLICIT INTEGER *4 (I-N)
cuk      INTEGER *4 IOUT(*)
cuu91      INTEGER *4 IOUT(1)
      INTEGER *4 IOUT(lout)
cuu91      CHARACTER *1 IBUF(1),ACHAR(4),TEST(4)
      CHARACTER *1 IBUF(lb),ACHAR(4),TEST(4)
      EQUIVALENCE (INN,ACHAR),(ITEST,TEST)
      DATA TEST/'1','2','3','4'/
      DATA N5/32/,N12/4096/,N19/524288/,N26/67108864/
      DATA ISIGN/64/,IOFLOW/128/,MASK1/63/,MASK2/127/
      DATA NCNTRL/128/,ICORR/32/
C     WORK OUT WHICH WAY BYTES ARE STORED IN COMPUTER
      IBYTE = 4
      IF (ITEST.EQ.(((52*256+51)*256+50)*256+49)) IBYTE = 1
      I = 0
      J = 0
      IERROR = 0
      IMAX = LOUT
C     START OF DECODING
   1  CONTINUE
        IEND = 0
        ISUB = 0
        I = I + 1
        ACHAR(IBYTE) = IBUF(I)
C       TEST IF CHARACTER IS EQUAL TO NCNTRL (100000000)
        IF(INN.EQ.NCNTRL) IEND = 1
C       GET SIGN BIT
        CALL INTAND(INN,ISIGN,JSIGN)
C       GET CONTINUATION BIT
        CALL INTAND(INN,IOFLOW,JOFLOW)
C       REMOVE SIGN AND CONTINUATION BITS
        CALL INTAND(INN,MASK1,ITEMP)
   2    CONTINUE
          IF(JOFLOW.EQ.0) GO TO 3
C         THERE IS ANOTHER BYTE IN THIS SAMPLE
          I = I + 1
          ACHAR(IBYTE) = IBUF(I)
C         TEST IF CHARACTER IS EQUAL TO NCNTRL 
          IF (IEND.EQ.1) THEN
             IF (INN .EQ. NCNTRL) GO TO 100
C            IF TWO CONTROL CHARACTERS IN A ROW THEN END OF DATA
C            SEE IF PREVIOUS SAMPLE HAS TO BE MODIFIED
             IF (INN.LT.16) THEN
                ITEMP = ICORR
C               NOW SUBTRACT CORRECTION FROM PREVIOUS SAMPLE
                IF (IOUT(J).LT.0) ITEMP = - ITEMP 
                IOUT(J) = IOUT(J) - ITEMP
              GO TO 1
             ENDIF 
          ENDIF 
          IEND = 0
          ISUB = 0
C         GET CONTINUATION BIT
          CALL INTAND(INN,IOFLOW,JOFLOW)
C         MASK OFF CONTINUATION BIT
          CALL INTAND(INN,MASK2,K)
C         SHIFT WHAT WE HAVE SO FAR 7 BITS LEFT AND ADD IN NEXT BITS
          ITEMP = ITEMP * 128 + K
        GO TO 2
   3    CONTINUE
        IF(JSIGN.NE.0) ITEMP = -ITEMP
        J = J + 1
        IF (J .GT. IMAX) GO TO 100
        IOUT(J) = ITEMP
      IF(I. LT. LB) GO TO 1
  100 CONTINUE
      LOUT = J
      IF (J .GT. IMAX) THEN
        LOUT = IMAX
        IERROR = -1
      ENDIF
      RETURN
      END
C**********************************************************************
C                                                                     *
C      SUBROUTINE INTAND(I1,I2,I3)                                    *
C                                                                     *
C      SUBROUTINE BITWISE "ANDS" THE INTEGERS IN I1 AND I2            *
C      AND RETURNS THE RESULT IN INTEGER I3                           *
C      FOR EXAMPLE                                                    *
C      IF THE 32 BITS IN I1 ARE 11001100 1110001110 11110000 11111111 *
C      AND IN I2 ARE            10101010 1100110011 00110011 00110011 *
C      I3 WILL BECOME           10001000 1100000010 00110000 00110011 *
C                                                                     *
C      NOTE "AND" IS NOT STANDARD FORTRAN 77 FUNCTION SO THIS IS A    *
C      MACHINE DEPENDANT SUBROUTINE                                   *
C**********************************************************************
C
cks       SUBROUTINE INTAND(I1,I2,I3) 
cks       INTEGER *4 I1,I2,I3
cksC##SUN## REMOVE COMMENT FROM NEXT LINE FOR SUN COMPUTERS
cks       I3 = AND(I1,I2)
cksC##DEC## REMOVE COMMENT FROM NEXT LINE FOR PDP AND VAX COMPUTERS and HP's
ckscuk       I3 = JIAND(I1,I2)
cksC##IBM## REMOVE COMMENT FROM NEXT LINE FOR IBM PC'S (I THINK)
cksC      I3 = IAND(I1,I2)
cks       RETURN
cks       END


c =============================================================================

c      -- this routine is machine and compiler dependend.  The appropriate
c      -- command should be selected by the 'conf.csh' script.
c      -- K.S. 21-Aug-98

       SUBROUTINE INTAND(I1,I2,I3) 
       INTEGER *4 I1,I2,I3
c       I3 = AND(I1,I2)   ! Sun
       I3 = AND(I1,I2)   ! Linux (here same as sun)
c       I3 = JIAND(I1,I2)    ! HP, VAX
c      I3 = IAND(I1,I2)     ! PC ?
       RETURN
       END
       
       
C************************************************************************
C                                                                       *
C     SUBROUTINE CHEKBT(ACHAR,NSTAT,IBYTE)                              *
C                                                                       *
C     SUBROUTINE CHECKS WHETHER THE CHARACTER ACHAR IS ONE WHICH CANNOT *
C     BE TRANSMITTED OVER A COMMUNICATIONS LINK. IF THE CHARACTER       *
C     CAN BE TRANSMITTED NSTAT IS SET TO 0 OTHERWISE IT IS SET TO 1.    *
C     IF NSTART IS SET TO ONE A ONE BIT IS ADDED INTO THE SIXTH MOST    *
C     SIGNIFICANT BIT OF ACHAR. THIS IS REMOVED IN THE DECODING PROGRAM *
C     THE SUBROUTINE HAS BEEN INITIALLY SET UP TO STOP CONTROL Z,       *
C     CONTROL C, CONTROL P AND CONTROL D CHARACTERS FROM BEING          *   
C     TRANSMITTED. THESE MAY HAVE TO BE CHANGED, DELETED OR ADDED TO    *
C     DEPENDING ON THE PARTICULAR CIRCUIT AND COMPUTERS.                *
C     FOR A FULL BINARY LINK, NO CONTROL CHARACTERS NEED BE STOPPED     *
C     AND THIS SUBROUTINE WILL BECOME REDUNDANT.                        * 
C     TO ADD ANOTHER CONTROL CHARACTER DEFINE IT, SPECIFY IT AND TEST   *
C     FOR IT.                                                           *
C     IBYTE = 1 FOR COMPUTERS WHICH STORE A CHARACTER IN THE MOST       *
C     SIGNIFICANT BITS OF AN INTEGER  *4 WORD. IBYTE = 4 FOR            *
C     COMPUTERS WHICH STORE A CHARACTER IN THE LEAST SIGNIFICANT        *
C     BYTE OF A COMPUTER WORD.                                          *
C     NOTE THIS SUBROUTINE WILL NOT WORK FOR CHARACTERS WHOSE 8 BIT     *
C     INTEGER REPRESENTATION IS GREATER THAN 31                         *
C     MODIFIED 28TH NOVEMBER 1988 BECAUSE OF ERRORS ON VAX COMPUTERS    *
C************************************************************************
C
      SUBROUTINE CHEKBT(ACHAR,NSTAT,IBYTE)
      IMPLICIT INTEGER *4 (I-N)
      CHARACTER *1 ACHAR,CNTRLZ,CNTRLC,CNTRLP,CNTRLD
      CHARACTER *1 OVRLAY,CHAR32
      INTEGER *4 ITEMP,ITEMP1
      EQUIVALENCE (ITEMP,OVRLAY),(ITEMP1,CHAR32)
      ITEMP = 0
      ITEMP1 = 0
      CHAR32 = CHAR(32)
C     DEFINE CONTROL CHARACTERS WHICH SHOULD NOT BE TRANSMITTED
C     THESE WILL VARY FOR DIFFERENT CIRCUITS AND COMPUTERS AND MAY HAVE
C     TO BE FOUND BY TRIAL AND ERROR.
      CNTRLZ = CHAR(26)
      CNTRLC = CHAR(3)
      CNTRLP = CHAR(16)
      CNTRLD = CHAR(4)
      NSTAT = 0
      IF(ACHAR.EQ.CNTRLZ) NSTAT = 1
      IF(ACHAR.EQ.CNTRLC) NSTAT = 1
      IF(ACHAR.EQ.CNTRLP) NSTAT = 1
      IF(ACHAR.EQ.CNTRLD) NSTAT = 1
      IF(NSTAT.EQ.1) THEN
         OVRLAY = ACHAR
         ITEMP = ITEMP + ITEMP1
         ACHAR = OVRLAY
      ENDIF
      RETURN
      END

c     file codeco_common.f
c          ===============
c
c     version 3, 21-Aug-98
c
c     variables of header lines of GSE files
c     K. Stammler, 19-Aug-98

c     -- constants
      integer   c_sigsize          ! dimension of sample array
      integer   c_bufsize          ! dimension of char buffer for compressed data
      parameter(
     &   c_sigsize = 600000,
     &   c_bufsize = 6*c_sigsize
     &)

c     -- header variables of common block
      integer   hdr_debug          ! debug level
      integer   hdr_year           ! data start time; year
      integer   hdr_month          ! data start time; month
      integer   hdr_day            ! data start time; day of month
      integer   hdr_jday           ! data start time; day of year
      integer   hdr_hour           ! data start time; hour
      integer   hdr_min            ! data start time; minute
      integer   hdr_sec            ! data start time; second
      integer   hdr_msec           ! data start time; millisecond
      integer   hdr_nsamp          ! number of samples
      integer   hdr_ifmtnum        ! input format number
      integer   hdr_ofmtnum        ! output format number
      integer   hdr_idiff          ! number of input differences
      integer   hdr_odiff          ! number of output differences
      integer   hdr_calunit        ! unit of calibration (0=displ, 1=vel, 2=acc)
      real      hdr_smprate        ! sample rate in Hz
      real      hdr_calfac         ! calibration factor
      real      hdr_calper         ! calibration period
      real      hdr_stalat         ! station latitude
      real      hdr_stalon         ! station longitude
      real      hdr_staelev        ! station elevation
      real      hdr_stadepth       ! emplacement depth
      real      hdr_beamaz         ! beam azimuth
      real      hdr_beamslo        ! beam slowness
      real      hdr_hang           ! horizontal orientation
      real      hdr_vang           ! vertical orientation
      character hdr_station*10     ! station name
      character hdr_stadescr*10    ! station/chan description
      character hdr_chan*3         ! channel name
      character hdr_instr*6        ! instrument type
      character hdr_network*9      ! network name
      character hdr_coosys*12      ! name of coordinate system
      character hdr_ifmtname*10    ! name of input format
      character hdr_ofmtname*10    ! name of output format

      common /gsehdr/
     &   hdr_debug, hdr_year, hdr_month, hdr_day, hdr_jday,
     &   hdr_hour, hdr_min, hdr_sec, hdr_msec, hdr_nsamp,
     &   hdr_ifmtnum, hdr_ofmtnum, hdr_idiff, hdr_odiff,
     &   hdr_calunit, hdr_smprate, hdr_calfac, hdr_calper,
     &   hdr_stalat, hdr_stalon, hdr_staelev, hdr_stadepth,
     &   hdr_beamaz, hdr_beamslo, hdr_hang, hdr_vang,
     &   hdr_station, hdr_stadescr, hdr_chan, hdr_instr,
     &   hdr_network, hdr_coosys, hdr_ifmtname, hdr_ofmtname

       double precision FUNCTION DIFF(X,Y)
c
c  Function used in tests that depend on machine precision.
c
c  The original version of this code was developed by
c  Charles L. Lawson and Richard J. Hanson at Jet Propulsion Laboratory
c  1973 JUN 7, and published in the book
c  "SOLVING LEAST SQUARES PROBLEMS", Prentice-HalL, 1974.
c  Revised FEB 1995 to accompany reprinting of the book by SIAM.
C
      double precision X, Y
      DIFF=X-Y  
      RETURN
      END   
